import { BFormInput as _o, BFormInvalidFeedback as yt, BFormGroup as mt, BFormTextarea as yu, BFormSelect as mu, BFormRadioGroup as vu, BFormCheckboxGroup as hu, BFormCheckbox as bu, BForm as Ku, BFormFloatingLabel as Ju, BFormRadio as Zu, BFormRow as el, BFormSelectOption as tl, BFormSelectOptionGroup as nl, BFormSpinButton as rl, BFormTag as al, BFormTags as ol, BFormText as il, BFormValidFeedback as ul } from "bootstrap-vue-next";
import { openBlock as b, createElementBlock as E, toDisplayString as we, resolveComponent as pt, createBlock as re, normalizeClass as ye, withCtx as q, createTextVNode as Ie, createVNode as xe, createElementVNode as ie, renderSlot as L, createCommentVNode as R, reactive as Xt, ref as j, defineComponent as Ze, useSlots as wo, toRef as aa, onMounted as et, onUnmounted as Oo, watch as Kt, computed as W, unref as v, mergeProps as Ye, isRef as kt, createSlots as Ge, renderList as Ae, normalizeProps as Xe, guardReactiveProps as st, Teleport as ll, withKeys as pe, withModifiers as ft, Transition as Bt, Fragment as he, normalizeStyle as Ct, resolveDynamicComponent as an, nextTick as Jt, withDirectives as on, vShow as un, onBeforeUpdate as sl, getCurrentScope as fl, onScopeDispose as cl } from "vue";
const vt = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [r, a] of t)
    n[r] = a;
  return n;
}, dl = {
  name: "FormInputFeedbackMessage",
  props: {
    messages: {
      type: Object,
      required: !1
    },
    validationModel: {
      type: Object,
      required: !0
    }
  },
  computed: {
    ruleNames() {
      return [
        ...new Set(
          [
            "required",
            "requiredIf",
            "requiredUnless",
            "minLength",
            "maxLength",
            "minValue",
            "maxValue",
            "between",
            "alpha",
            "alphaNum",
            "numeric",
            "integer",
            "decimal",
            "email",
            "ipAddress",
            "macAddress",
            "sameAs",
            "url",
            "validated_email"
          ].concat(this.messages ? Object.keys(this.messages) : [])
        )
      ];
    },
    message() {
      const e = Object.keys(this.validationModel).filter((t) => !`${t}`.startsWith("$"));
      for (const t of e)
        if (this.ruleNames.includes(t) && this.validationModel[t].$invalid)
          return this.messages && this.messages[t] ? this.messages[t] : this.getDefaultMessage(t, this.validationModel[t].$params || {});
      return this.getDefaultMessage();
    }
  },
  methods: {
    getDefaultMessage(e, t) {
      let n;
      if (this.$i18n !== void 0 && this.$t !== void 0)
        switch (e) {
          case "required":
          case "requiredIf":
          case "requiredUnless":
            return this.$t("vueFormInputs.feedback.required");
          case "minLength":
            return this.$t("vueFormInputs.feedback.minLength", { minLength: t.min });
          case "maxLength":
            return this.$t("vueFormInputs.feedback.maxLength", { maxLength: t.max });
          case "minValue":
            return n = t.min instanceof Date ? t.min.toLocaleDateString() : t.min, this.$t("vueFormInputs.feedback.minValue", { minValue: n });
          case "maxValue":
            return n = t.max instanceof Date ? t.max.toLocaleDateString() : t.max, this.$t("vueFormInputs.feedback.maxValue", { maxValue: n });
          case "between":
            return this.$t("vueFormInputs.feedback.between", { betweenMin: t.min, betweenMax: t.max });
          case "alpha":
            return this.$t("vueFormInputs.feedback.alpha");
          case "alphaNum":
            return this.$t("vueFormInputs.feedback.alphaNum");
          case "numeric":
            return this.$t("vueFormInputs.feedback.numeric");
          case "integer":
            return this.$t("vueFormInputs.feedback.integer");
          case "decimal":
            return this.$t("vueFormInputs.feedback.decimal");
          case "email":
            return this.$t("vueFormInputs.feedback.email");
          case "ipAddress":
            return this.$t("vueFormInputs.feedback.ipAddress");
          case "macAddress":
            return this.$t("vueFormInputs.feedback.macAddress");
          case "sameAs":
            return this.$t("vueFormInputs.feedback.sameAs");
          case "url":
            return this.$t("vueFormInputs.feedback.url");
          case "validated_email":
          case "validatedEmail":
            return this.$t("vueFormInputs.feedback.validatedEmail");
          default:
            return this.$t("vueFormInputs.feedback.invalidValue");
        }
      switch (e) {
        case "required":
        case "requiredIf":
        case "requiredUnless":
          return "Toto pole je nutné vyplnit.";
        case "minLength":
          return `Hodnota musí být minimálně ${t.min} znaků dlouhá.`;
        case "maxLength":
          return `Hodnota musí být maximálně ${t.max} znaků dlouhá.`;
        case "minValue":
          return n = t.min instanceof Date ? t.min.toLocaleDateString() : t.min, `Hodnota musí být minimálně ${n}.`;
        case "maxValue":
          return n = t.max instanceof Date ? t.max.toLocaleDateString() : t.max, `Hodnota musí být maximálně ${n}.`;
        case "between":
          return `Hodnota musí být mezi ${t.min} a ${t.max}.`;
        case "alpha":
          return "Jsou povoleny pouze písmena.";
        case "alphaNum":
          return "Jsou povoleny pouze písmena a čísla.";
        case "numeric":
          return "Jsou povoleny pouze čísla.";
        case "integer":
          return "Jsou povolena pouze celá čísla.";
        case "decimal":
          return "Jsou povolena pouze desetinná čísla.";
        case "email":
          return "Chybný formát emailové adresy.";
        case "ipAddress":
          return "Chybný formát IP adresy.";
        case "macAddress":
          return "Chybný formát MAC adresy.";
        case "sameAs":
          return "Hodnota není shodná.";
        case "url":
          return "Chybný formát URL adresy.";
        case "validated_email":
        case "validatedEmail":
          return "Nefunkční nebo chybná emailová adresa.";
        default:
          return "Chybně vyplněná hodnota.";
      }
    }
  }
};
function pl(e, t, n, r, a, o) {
  return b(), E("span", null, we(o.message), 1);
}
const yl = /* @__PURE__ */ vt(dl, [["render", pl]]);
const ml = {
  name: "FormInput",
  components: {
    FormInputFeedbackMessage: yl
  },
  props: {
    label: {
      type: String,
      required: !1
    },
    type: {
      type: String,
      required: !1,
      default: "text"
    },
    size: {
      type: String,
      required: !1,
      default: "md"
    },
    validationMessages: {
      type: Object,
      required: !1,
      default() {
        return {};
      }
    },
    validation: {
      type: Object,
      required: !1,
      default() {
        return {};
      }
    },
    disabled: {
      type: Boolean,
      required: !1,
      default: !1
    },
    modelValue: {
      required: !1
    },
    hint: {
      type: String,
      required: !1
    },
    placeholder: {
      type: String,
      required: !1
    },
    formatter: {
      type: Function,
      required: !1
    },
    renderAsGroup: {
      type: Boolean,
      required: !1,
      default: !1
    },
    id: {
      type: String,
      required: !1
    },
    readOnly: {
      type: Boolean,
      required: !1,
      default: !1
    },
    showAsRequired: {
      required: !1,
      default: null
    }
  },
  computed: {
    isRequired() {
      if (this.showAsRequired === !1 || this.showAsRequired === !0)
        return !!this.showAsRequired;
      if (this.validation !== void 0) {
        const e = JSON.parse(JSON.stringify(this.validation));
        if (e && typeof e == "object")
          return Object.keys(e).filter((t) => !`${t}`.startsWith("$")).length > 0;
      }
      return !1;
    },
    model: {
      get() {
        return this.modelValue;
      },
      set(e) {
        this.$emit("update:modelValue", e), this.validation.$touch !== void 0 && typeof this.validation.$touch == "function" && this.validation.$touch();
      }
    },
    invalid() {
      return this.validation.$invalid !== void 0 && this.validation.$dirty ? this.validation.$invalid : null;
    }
  },
  methods: {
    onEvent(e) {
      const t = this;
      return (n) => {
        t.$emit(e, n);
      };
    },
    formatValue(e) {
      return typeof this.formatter == "function" ? this.formatter(e) : e;
    }
  }
}, vl = { class: "input-group-append" };
function hl(e, t, n, r, a, o) {
  const i = _o, l = pt("form-input-feedback-message"), f = yt, d = mt;
  return b(), re(d, {
    description: n.hint,
    "label-for": n.id,
    class: ye({ "form-group-required": o.isRequired })
  }, {
    label: q(() => [
      Ie(we(n.label), 1)
    ]),
    default: q(() => [
      n.renderAsGroup ? (b(), E("div", {
        key: 0,
        class: ye({ "input-group": !0, "is-invalid": o.invalid !== null ? !o.invalid : null, "is-valid": o.invalid !== null ? !!o.invalid : null })
      }, [
        xe(i, {
          modelValue: o.model,
          "onUpdate:modelValue": t[0] || (t[0] = (m) => o.model = m),
          modelModifiers: { trim: !0 },
          id: n.id,
          size: n.size,
          type: n.type,
          state: o.invalid !== null ? !o.invalid : null,
          disabled: n.disabled,
          formatter: o.formatValue,
          placeholder: n.placeholder,
          readonly: n.readOnly,
          "lazy-formatter": "",
          onChange: t[1] || (t[1] = (m) => o.onEvent("change")),
          onUpdate: t[2] || (t[2] = (m) => o.onEvent("update")),
          onBlur: t[3] || (t[3] = (m) => o.onEvent("blur"))
        }, null, 8, ["modelValue", "id", "size", "type", "state", "disabled", "formatter", "placeholder", "readonly"]),
        ie("div", vl, [
          L(e.$slots, "default")
        ])
      ], 2)) : (b(), re(i, {
        key: 1,
        modelValue: o.model,
        "onUpdate:modelValue": t[4] || (t[4] = (m) => o.model = m),
        modelModifiers: { trim: !0 },
        id: n.id,
        size: n.size,
        type: n.type,
        state: o.invalid !== null ? !o.invalid : null,
        disabled: n.disabled,
        formatter: o.formatValue,
        placeholder: n.placeholder,
        readonly: n.readOnly,
        "lazy-formatter": "",
        onChange: t[5] || (t[5] = (m) => o.onEvent("change")),
        onUpdate: t[6] || (t[6] = (m) => o.onEvent("update")),
        onBlur: t[7] || (t[7] = (m) => o.onEvent("blur"))
      }, null, 8, ["modelValue", "id", "size", "type", "state", "disabled", "formatter", "placeholder", "readonly"])),
      o.invalid ? (b(), re(f, { key: 2 }, {
        default: q(() => [
          xe(l, {
            "validation-model": n.validation,
            messages: n.validationMessages
          }, null, 8, ["validation-model", "messages"])
        ]),
        _: 1
      })) : R("", !0),
      L(e.$slots, "input-text")
    ]),
    _: 3
  }, 8, ["description", "label-for", "class"]);
}
const St = /* @__PURE__ */ vt(ml, [["render", hl]]), bl = (e) => `${e < 10 ? "0" : ""}${e}`, gu = (e) => e instanceof Date ? `${e.getDate()}.${e.getMonth() + 1}. ${e.getFullYear()}` : null, gl = (e) => e instanceof Date ? `${gu(e)} - ${e.getHours()}:${bl(e.getMinutes())}` : null;
function ae(e) {
  if (e === null || e === !0 || e === !1)
    return NaN;
  var t = Number(e);
  return isNaN(t) ? t : t < 0 ? Math.ceil(t) : Math.floor(t);
}
function J(e, t) {
  if (t.length < e)
    throw new TypeError(e + " argument" + (e > 1 ? "s" : "") + " required, but only " + t.length + " present");
}
function ln(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? ln = function(n) {
    return typeof n;
  } : ln = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, ln(e);
}
function oe(e) {
  J(1, arguments);
  var t = Object.prototype.toString.call(e);
  return e instanceof Date || ln(e) === "object" && t === "[object Date]" ? new Date(e.getTime()) : typeof e == "number" || t === "[object Number]" ? new Date(e) : ((typeof e == "string" || t === "[object String]") && typeof console < "u" && (console.warn("Starting with v2.0.0-beta.1 date-fns doesn't accept strings as date arguments. Please use `parseISO` to parse strings. See: https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#string-arguments"), console.warn(new Error().stack)), new Date(NaN));
}
function dt(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t);
  return isNaN(r) ? new Date(NaN) : (r && n.setDate(n.getDate() + r), n);
}
function at(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t);
  if (isNaN(r))
    return new Date(NaN);
  if (!r)
    return n;
  var a = n.getDate(), o = new Date(n.getTime());
  o.setMonth(n.getMonth() + r + 1, 0);
  var i = o.getDate();
  return a >= i ? o : (n.setFullYear(o.getFullYear(), o.getMonth(), a), n);
}
function sn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? sn = function(n) {
    return typeof n;
  } : sn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, sn(e);
}
function _u(e, t) {
  if (J(2, arguments), !t || sn(t) !== "object")
    return new Date(NaN);
  var n = t.years ? ae(t.years) : 0, r = t.months ? ae(t.months) : 0, a = t.weeks ? ae(t.weeks) : 0, o = t.days ? ae(t.days) : 0, i = t.hours ? ae(t.hours) : 0, l = t.minutes ? ae(t.minutes) : 0, f = t.seconds ? ae(t.seconds) : 0, d = oe(e), m = r || n ? at(d, r + n * 12) : d, p = o || a ? dt(m, o + a * 7) : m, s = l + i * 60, w = f + s * 60, A = w * 1e3, U = new Date(p.getTime() + A);
  return U;
}
function _l(e, t) {
  J(2, arguments);
  var n = oe(e).getTime(), r = ae(t);
  return new Date(n + r);
}
var wl = {};
function ht() {
  return wl;
}
function oa(e, t) {
  var n, r, a, o, i, l, f, d;
  J(1, arguments);
  var m = ht(), p = ae((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (l = i.options) === null || l === void 0 ? void 0 : l.weekStartsOn) !== null && a !== void 0 ? a : m.weekStartsOn) !== null && r !== void 0 ? r : (f = m.locale) === null || f === void 0 || (d = f.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(p >= 0 && p <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var s = oe(e), w = s.getDay(), A = (w < p ? 7 : 0) + w - p;
  return s.setDate(s.getDate() - A), s.setHours(0, 0, 0, 0), s;
}
function Qn(e) {
  return J(1, arguments), oa(e, {
    weekStartsOn: 1
  });
}
function Ol(e) {
  J(1, arguments);
  var t = oe(e), n = t.getFullYear(), r = new Date(0);
  r.setFullYear(n + 1, 0, 4), r.setHours(0, 0, 0, 0);
  var a = Qn(r), o = new Date(0);
  o.setFullYear(n, 0, 4), o.setHours(0, 0, 0, 0);
  var i = Qn(o);
  return t.getTime() >= a.getTime() ? n + 1 : t.getTime() >= i.getTime() ? n : n - 1;
}
function $l(e) {
  J(1, arguments);
  var t = Ol(e), n = new Date(0);
  n.setFullYear(t, 0, 4), n.setHours(0, 0, 0, 0);
  var r = Qn(n);
  return r;
}
function Xn(e) {
  var t = new Date(Date.UTC(e.getFullYear(), e.getMonth(), e.getDate(), e.getHours(), e.getMinutes(), e.getSeconds(), e.getMilliseconds()));
  return t.setUTCFullYear(e.getFullYear()), e.getTime() - t.getTime();
}
function Bo(e) {
  J(1, arguments);
  var t = oe(e);
  return t.setHours(0, 0, 0, 0), t;
}
var kl = 864e5;
function Pl(e, t) {
  J(2, arguments);
  var n = Bo(e), r = Bo(t), a = n.getTime() - Xn(n), o = r.getTime() - Xn(r);
  return Math.round((a - o) / kl);
}
function wu(e, t) {
  J(2, arguments);
  var n = ae(t);
  return at(e, n * 12);
}
var $o = 6e4, ko = 36e5, Tl = 1e3;
function fn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? fn = function(n) {
    return typeof n;
  } : fn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, fn(e);
}
function Ou(e) {
  return J(1, arguments), e instanceof Date || fn(e) === "object" && Object.prototype.toString.call(e) === "[object Date]";
}
function Ht(e) {
  if (J(1, arguments), !Ou(e) && typeof e != "number")
    return !1;
  var t = oe(e);
  return !isNaN(Number(t));
}
function Yo(e, t) {
  var n;
  J(1, arguments);
  var r = e || {}, a = oe(r.start), o = oe(r.end), i = o.getTime();
  if (!(a.getTime() <= i))
    throw new RangeError("Invalid interval");
  var l = [], f = a;
  f.setHours(0, 0, 0, 0);
  var d = Number((n = t == null ? void 0 : t.step) !== null && n !== void 0 ? n : 1);
  if (d < 1 || isNaN(d))
    throw new RangeError("`options.step` must be a number greater than 1");
  for (; f.getTime() <= i; )
    l.push(oe(f)), f.setDate(f.getDate() + d), f.setHours(0, 0, 0, 0);
  return l;
}
function Dl(e, t) {
  var n, r, a, o, i, l, f, d;
  J(1, arguments);
  var m = ht(), p = ae((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (l = i.options) === null || l === void 0 ? void 0 : l.weekStartsOn) !== null && a !== void 0 ? a : m.weekStartsOn) !== null && r !== void 0 ? r : (f = m.locale) === null || f === void 0 || (d = f.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(p >= 0 && p <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var s = oe(e), w = s.getDay(), A = (w < p ? -7 : 0) + 6 - (w - p);
  return s.setDate(s.getDate() + A), s.setHours(23, 59, 59, 999), s;
}
function $u(e, t) {
  J(2, arguments);
  var n = ae(t);
  return _l(e, -n);
}
var Sl = 864e5;
function Rl(e) {
  J(1, arguments);
  var t = oe(e), n = t.getTime();
  t.setUTCMonth(0, 1), t.setUTCHours(0, 0, 0, 0);
  var r = t.getTime(), a = n - r;
  return Math.floor(a / Sl) + 1;
}
function At(e) {
  J(1, arguments);
  var t = 1, n = oe(e), r = n.getUTCDay(), a = (r < t ? 7 : 0) + r - t;
  return n.setUTCDate(n.getUTCDate() - a), n.setUTCHours(0, 0, 0, 0), n;
}
function ku(e) {
  J(1, arguments);
  var t = oe(e), n = t.getUTCFullYear(), r = new Date(0);
  r.setUTCFullYear(n + 1, 0, 4), r.setUTCHours(0, 0, 0, 0);
  var a = At(r), o = new Date(0);
  o.setUTCFullYear(n, 0, 4), o.setUTCHours(0, 0, 0, 0);
  var i = At(o);
  return t.getTime() >= a.getTime() ? n + 1 : t.getTime() >= i.getTime() ? n : n - 1;
}
function Ml(e) {
  J(1, arguments);
  var t = ku(e), n = new Date(0);
  n.setUTCFullYear(t, 0, 4), n.setUTCHours(0, 0, 0, 0);
  var r = At(n);
  return r;
}
var xl = 6048e5;
function Pu(e) {
  J(1, arguments);
  var t = oe(e), n = At(t).getTime() - Ml(t).getTime();
  return Math.round(n / xl) + 1;
}
function Dt(e, t) {
  var n, r, a, o, i, l, f, d;
  J(1, arguments);
  var m = ht(), p = ae((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (l = i.options) === null || l === void 0 ? void 0 : l.weekStartsOn) !== null && a !== void 0 ? a : m.weekStartsOn) !== null && r !== void 0 ? r : (f = m.locale) === null || f === void 0 || (d = f.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(p >= 0 && p <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var s = oe(e), w = s.getUTCDay(), A = (w < p ? 7 : 0) + w - p;
  return s.setUTCDate(s.getUTCDate() - A), s.setUTCHours(0, 0, 0, 0), s;
}
function Po(e, t) {
  var n, r, a, o, i, l, f, d;
  J(1, arguments);
  var m = oe(e), p = m.getUTCFullYear(), s = ht(), w = ae((n = (r = (a = (o = t == null ? void 0 : t.firstWeekContainsDate) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (l = i.options) === null || l === void 0 ? void 0 : l.firstWeekContainsDate) !== null && a !== void 0 ? a : s.firstWeekContainsDate) !== null && r !== void 0 ? r : (f = s.locale) === null || f === void 0 || (d = f.options) === null || d === void 0 ? void 0 : d.firstWeekContainsDate) !== null && n !== void 0 ? n : 1);
  if (!(w >= 1 && w <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var A = new Date(0);
  A.setUTCFullYear(p + 1, 0, w), A.setUTCHours(0, 0, 0, 0);
  var U = Dt(A, t), G = new Date(0);
  G.setUTCFullYear(p, 0, w), G.setUTCHours(0, 0, 0, 0);
  var ee = Dt(G, t);
  return m.getTime() >= U.getTime() ? p + 1 : m.getTime() >= ee.getTime() ? p : p - 1;
}
function Nl(e, t) {
  var n, r, a, o, i, l, f, d;
  J(1, arguments);
  var m = ht(), p = ae((n = (r = (a = (o = t == null ? void 0 : t.firstWeekContainsDate) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (l = i.options) === null || l === void 0 ? void 0 : l.firstWeekContainsDate) !== null && a !== void 0 ? a : m.firstWeekContainsDate) !== null && r !== void 0 ? r : (f = m.locale) === null || f === void 0 || (d = f.options) === null || d === void 0 ? void 0 : d.firstWeekContainsDate) !== null && n !== void 0 ? n : 1), s = Po(e, t), w = new Date(0);
  w.setUTCFullYear(s, 0, p), w.setUTCHours(0, 0, 0, 0);
  var A = Dt(w, t);
  return A;
}
var Cl = 6048e5;
function Tu(e, t) {
  J(1, arguments);
  var n = oe(e), r = Dt(n, t).getTime() - Nl(n, t).getTime();
  return Math.round(r / Cl) + 1;
}
function _e(e, t) {
  for (var n = e < 0 ? "-" : "", r = Math.abs(e).toString(); r.length < t; )
    r = "0" + r;
  return n + r;
}
var El = {
  // Year
  y: function(t, n) {
    var r = t.getUTCFullYear(), a = r > 0 ? r : 1 - r;
    return _e(n === "yy" ? a % 100 : a, n.length);
  },
  // Month
  M: function(t, n) {
    var r = t.getUTCMonth();
    return n === "M" ? String(r + 1) : _e(r + 1, 2);
  },
  // Day of the month
  d: function(t, n) {
    return _e(t.getUTCDate(), n.length);
  },
  // AM or PM
  a: function(t, n) {
    var r = t.getUTCHours() / 12 >= 1 ? "pm" : "am";
    switch (n) {
      case "a":
      case "aa":
        return r.toUpperCase();
      case "aaa":
        return r;
      case "aaaaa":
        return r[0];
      case "aaaa":
      default:
        return r === "am" ? "a.m." : "p.m.";
    }
  },
  // Hour [1-12]
  h: function(t, n) {
    return _e(t.getUTCHours() % 12 || 12, n.length);
  },
  // Hour [0-23]
  H: function(t, n) {
    return _e(t.getUTCHours(), n.length);
  },
  // Minute
  m: function(t, n) {
    return _e(t.getUTCMinutes(), n.length);
  },
  // Second
  s: function(t, n) {
    return _e(t.getUTCSeconds(), n.length);
  },
  // Fraction of second
  S: function(t, n) {
    var r = n.length, a = t.getUTCMilliseconds(), o = Math.floor(a * Math.pow(10, r - 3));
    return _e(o, n.length);
  }
};
const ct = El;
var xt = {
  am: "am",
  pm: "pm",
  midnight: "midnight",
  noon: "noon",
  morning: "morning",
  afternoon: "afternoon",
  evening: "evening",
  night: "night"
}, Al = {
  // Era
  G: function(t, n, r) {
    var a = t.getUTCFullYear() > 0 ? 1 : 0;
    switch (n) {
      case "G":
      case "GG":
      case "GGG":
        return r.era(a, {
          width: "abbreviated"
        });
      case "GGGGG":
        return r.era(a, {
          width: "narrow"
        });
      case "GGGG":
      default:
        return r.era(a, {
          width: "wide"
        });
    }
  },
  // Year
  y: function(t, n, r) {
    if (n === "yo") {
      var a = t.getUTCFullYear(), o = a > 0 ? a : 1 - a;
      return r.ordinalNumber(o, {
        unit: "year"
      });
    }
    return ct.y(t, n);
  },
  // Local week-numbering year
  Y: function(t, n, r, a) {
    var o = Po(t, a), i = o > 0 ? o : 1 - o;
    if (n === "YY") {
      var l = i % 100;
      return _e(l, 2);
    }
    return n === "Yo" ? r.ordinalNumber(i, {
      unit: "year"
    }) : _e(i, n.length);
  },
  // ISO week-numbering year
  R: function(t, n) {
    var r = ku(t);
    return _e(r, n.length);
  },
  // Extended year. This is a single number designating the year of this calendar system.
  // The main difference between `y` and `u` localizers are B.C. years:
  // | Year | `y` | `u` |
  // |------|-----|-----|
  // | AC 1 |   1 |   1 |
  // | BC 1 |   1 |   0 |
  // | BC 2 |   2 |  -1 |
  // Also `yy` always returns the last two digits of a year,
  // while `uu` pads single digit years to 2 characters and returns other years unchanged.
  u: function(t, n) {
    var r = t.getUTCFullYear();
    return _e(r, n.length);
  },
  // Quarter
  Q: function(t, n, r) {
    var a = Math.ceil((t.getUTCMonth() + 1) / 3);
    switch (n) {
      case "Q":
        return String(a);
      case "QQ":
        return _e(a, 2);
      case "Qo":
        return r.ordinalNumber(a, {
          unit: "quarter"
        });
      case "QQQ":
        return r.quarter(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "QQQQQ":
        return r.quarter(a, {
          width: "narrow",
          context: "formatting"
        });
      case "QQQQ":
      default:
        return r.quarter(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone quarter
  q: function(t, n, r) {
    var a = Math.ceil((t.getUTCMonth() + 1) / 3);
    switch (n) {
      case "q":
        return String(a);
      case "qq":
        return _e(a, 2);
      case "qo":
        return r.ordinalNumber(a, {
          unit: "quarter"
        });
      case "qqq":
        return r.quarter(a, {
          width: "abbreviated",
          context: "standalone"
        });
      case "qqqqq":
        return r.quarter(a, {
          width: "narrow",
          context: "standalone"
        });
      case "qqqq":
      default:
        return r.quarter(a, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // Month
  M: function(t, n, r) {
    var a = t.getUTCMonth();
    switch (n) {
      case "M":
      case "MM":
        return ct.M(t, n);
      case "Mo":
        return r.ordinalNumber(a + 1, {
          unit: "month"
        });
      case "MMM":
        return r.month(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "MMMMM":
        return r.month(a, {
          width: "narrow",
          context: "formatting"
        });
      case "MMMM":
      default:
        return r.month(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone month
  L: function(t, n, r) {
    var a = t.getUTCMonth();
    switch (n) {
      case "L":
        return String(a + 1);
      case "LL":
        return _e(a + 1, 2);
      case "Lo":
        return r.ordinalNumber(a + 1, {
          unit: "month"
        });
      case "LLL":
        return r.month(a, {
          width: "abbreviated",
          context: "standalone"
        });
      case "LLLLL":
        return r.month(a, {
          width: "narrow",
          context: "standalone"
        });
      case "LLLL":
      default:
        return r.month(a, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // Local week of year
  w: function(t, n, r, a) {
    var o = Tu(t, a);
    return n === "wo" ? r.ordinalNumber(o, {
      unit: "week"
    }) : _e(o, n.length);
  },
  // ISO week of year
  I: function(t, n, r) {
    var a = Pu(t);
    return n === "Io" ? r.ordinalNumber(a, {
      unit: "week"
    }) : _e(a, n.length);
  },
  // Day of the month
  d: function(t, n, r) {
    return n === "do" ? r.ordinalNumber(t.getUTCDate(), {
      unit: "date"
    }) : ct.d(t, n);
  },
  // Day of year
  D: function(t, n, r) {
    var a = Rl(t);
    return n === "Do" ? r.ordinalNumber(a, {
      unit: "dayOfYear"
    }) : _e(a, n.length);
  },
  // Day of week
  E: function(t, n, r) {
    var a = t.getUTCDay();
    switch (n) {
      case "E":
      case "EE":
      case "EEE":
        return r.day(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "EEEEE":
        return r.day(a, {
          width: "narrow",
          context: "formatting"
        });
      case "EEEEEE":
        return r.day(a, {
          width: "short",
          context: "formatting"
        });
      case "EEEE":
      default:
        return r.day(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Local day of week
  e: function(t, n, r, a) {
    var o = t.getUTCDay(), i = (o - a.weekStartsOn + 8) % 7 || 7;
    switch (n) {
      case "e":
        return String(i);
      case "ee":
        return _e(i, 2);
      case "eo":
        return r.ordinalNumber(i, {
          unit: "day"
        });
      case "eee":
        return r.day(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "eeeee":
        return r.day(o, {
          width: "narrow",
          context: "formatting"
        });
      case "eeeeee":
        return r.day(o, {
          width: "short",
          context: "formatting"
        });
      case "eeee":
      default:
        return r.day(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone local day of week
  c: function(t, n, r, a) {
    var o = t.getUTCDay(), i = (o - a.weekStartsOn + 8) % 7 || 7;
    switch (n) {
      case "c":
        return String(i);
      case "cc":
        return _e(i, n.length);
      case "co":
        return r.ordinalNumber(i, {
          unit: "day"
        });
      case "ccc":
        return r.day(o, {
          width: "abbreviated",
          context: "standalone"
        });
      case "ccccc":
        return r.day(o, {
          width: "narrow",
          context: "standalone"
        });
      case "cccccc":
        return r.day(o, {
          width: "short",
          context: "standalone"
        });
      case "cccc":
      default:
        return r.day(o, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // ISO day of week
  i: function(t, n, r) {
    var a = t.getUTCDay(), o = a === 0 ? 7 : a;
    switch (n) {
      case "i":
        return String(o);
      case "ii":
        return _e(o, n.length);
      case "io":
        return r.ordinalNumber(o, {
          unit: "day"
        });
      case "iii":
        return r.day(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "iiiii":
        return r.day(a, {
          width: "narrow",
          context: "formatting"
        });
      case "iiiiii":
        return r.day(a, {
          width: "short",
          context: "formatting"
        });
      case "iiii":
      default:
        return r.day(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // AM or PM
  a: function(t, n, r) {
    var a = t.getUTCHours(), o = a / 12 >= 1 ? "pm" : "am";
    switch (n) {
      case "a":
      case "aa":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "aaa":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        }).toLowerCase();
      case "aaaaa":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "aaaa":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // AM, PM, midnight, noon
  b: function(t, n, r) {
    var a = t.getUTCHours(), o;
    switch (a === 12 ? o = xt.noon : a === 0 ? o = xt.midnight : o = a / 12 >= 1 ? "pm" : "am", n) {
      case "b":
      case "bb":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "bbb":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        }).toLowerCase();
      case "bbbbb":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "bbbb":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // in the morning, in the afternoon, in the evening, at night
  B: function(t, n, r) {
    var a = t.getUTCHours(), o;
    switch (a >= 17 ? o = xt.evening : a >= 12 ? o = xt.afternoon : a >= 4 ? o = xt.morning : o = xt.night, n) {
      case "B":
      case "BB":
      case "BBB":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "BBBBB":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "BBBB":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Hour [1-12]
  h: function(t, n, r) {
    if (n === "ho") {
      var a = t.getUTCHours() % 12;
      return a === 0 && (a = 12), r.ordinalNumber(a, {
        unit: "hour"
      });
    }
    return ct.h(t, n);
  },
  // Hour [0-23]
  H: function(t, n, r) {
    return n === "Ho" ? r.ordinalNumber(t.getUTCHours(), {
      unit: "hour"
    }) : ct.H(t, n);
  },
  // Hour [0-11]
  K: function(t, n, r) {
    var a = t.getUTCHours() % 12;
    return n === "Ko" ? r.ordinalNumber(a, {
      unit: "hour"
    }) : _e(a, n.length);
  },
  // Hour [1-24]
  k: function(t, n, r) {
    var a = t.getUTCHours();
    return a === 0 && (a = 24), n === "ko" ? r.ordinalNumber(a, {
      unit: "hour"
    }) : _e(a, n.length);
  },
  // Minute
  m: function(t, n, r) {
    return n === "mo" ? r.ordinalNumber(t.getUTCMinutes(), {
      unit: "minute"
    }) : ct.m(t, n);
  },
  // Second
  s: function(t, n, r) {
    return n === "so" ? r.ordinalNumber(t.getUTCSeconds(), {
      unit: "second"
    }) : ct.s(t, n);
  },
  // Fraction of second
  S: function(t, n) {
    return ct.S(t, n);
  },
  // Timezone (ISO-8601. If offset is 0, output is always `'Z'`)
  X: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    if (i === 0)
      return "Z";
    switch (n) {
      case "X":
        return Vo(i);
      case "XXXX":
      case "XX":
        return $t(i);
      case "XXXXX":
      case "XXX":
      default:
        return $t(i, ":");
    }
  },
  // Timezone (ISO-8601. If offset is 0, output is `'+00:00'` or equivalent)
  x: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "x":
        return Vo(i);
      case "xxxx":
      case "xx":
        return $t(i);
      case "xxxxx":
      case "xxx":
      default:
        return $t(i, ":");
    }
  },
  // Timezone (GMT)
  O: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "O":
      case "OO":
      case "OOO":
        return "GMT" + Uo(i, ":");
      case "OOOO":
      default:
        return "GMT" + $t(i, ":");
    }
  },
  // Timezone (specific non-location)
  z: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "z":
      case "zz":
      case "zzz":
        return "GMT" + Uo(i, ":");
      case "zzzz":
      default:
        return "GMT" + $t(i, ":");
    }
  },
  // Seconds timestamp
  t: function(t, n, r, a) {
    var o = a._originalDate || t, i = Math.floor(o.getTime() / 1e3);
    return _e(i, n.length);
  },
  // Milliseconds timestamp
  T: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTime();
    return _e(i, n.length);
  }
};
function Uo(e, t) {
  var n = e > 0 ? "-" : "+", r = Math.abs(e), a = Math.floor(r / 60), o = r % 60;
  if (o === 0)
    return n + String(a);
  var i = t || "";
  return n + String(a) + i + _e(o, 2);
}
function Vo(e, t) {
  if (e % 60 === 0) {
    var n = e > 0 ? "-" : "+";
    return n + _e(Math.abs(e) / 60, 2);
  }
  return $t(e, t);
}
function $t(e, t) {
  var n = t || "", r = e > 0 ? "-" : "+", a = Math.abs(e), o = _e(Math.floor(a / 60), 2), i = _e(a % 60, 2);
  return r + o + n + i;
}
const Il = Al;
var Fo = function(t, n) {
  switch (t) {
    case "P":
      return n.date({
        width: "short"
      });
    case "PP":
      return n.date({
        width: "medium"
      });
    case "PPP":
      return n.date({
        width: "long"
      });
    case "PPPP":
    default:
      return n.date({
        width: "full"
      });
  }
}, Du = function(t, n) {
  switch (t) {
    case "p":
      return n.time({
        width: "short"
      });
    case "pp":
      return n.time({
        width: "medium"
      });
    case "ppp":
      return n.time({
        width: "long"
      });
    case "pppp":
    default:
      return n.time({
        width: "full"
      });
  }
}, Bl = function(t, n) {
  var r = t.match(/(P+)(p+)?/) || [], a = r[1], o = r[2];
  if (!o)
    return Fo(t, n);
  var i;
  switch (a) {
    case "P":
      i = n.dateTime({
        width: "short"
      });
      break;
    case "PP":
      i = n.dateTime({
        width: "medium"
      });
      break;
    case "PPP":
      i = n.dateTime({
        width: "long"
      });
      break;
    case "PPPP":
    default:
      i = n.dateTime({
        width: "full"
      });
      break;
  }
  return i.replace("{{date}}", Fo(a, n)).replace("{{time}}", Du(o, n));
}, Yl = {
  p: Du,
  P: Bl
};
const ia = Yl;
var Ul = ["D", "DD"], Vl = ["YY", "YYYY"];
function Su(e) {
  return Ul.indexOf(e) !== -1;
}
function Ru(e) {
  return Vl.indexOf(e) !== -1;
}
function Kn(e, t, n) {
  if (e === "YYYY")
    throw new RangeError("Use `yyyy` instead of `YYYY` (in `".concat(t, "`) for formatting years to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "YY")
    throw new RangeError("Use `yy` instead of `YY` (in `".concat(t, "`) for formatting years to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "D")
    throw new RangeError("Use `d` instead of `D` (in `".concat(t, "`) for formatting days of the month to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "DD")
    throw new RangeError("Use `dd` instead of `DD` (in `".concat(t, "`) for formatting days of the month to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
}
var Fl = {
  lessThanXSeconds: {
    one: "less than a second",
    other: "less than {{count}} seconds"
  },
  xSeconds: {
    one: "1 second",
    other: "{{count}} seconds"
  },
  halfAMinute: "half a minute",
  lessThanXMinutes: {
    one: "less than a minute",
    other: "less than {{count}} minutes"
  },
  xMinutes: {
    one: "1 minute",
    other: "{{count}} minutes"
  },
  aboutXHours: {
    one: "about 1 hour",
    other: "about {{count}} hours"
  },
  xHours: {
    one: "1 hour",
    other: "{{count}} hours"
  },
  xDays: {
    one: "1 day",
    other: "{{count}} days"
  },
  aboutXWeeks: {
    one: "about 1 week",
    other: "about {{count}} weeks"
  },
  xWeeks: {
    one: "1 week",
    other: "{{count}} weeks"
  },
  aboutXMonths: {
    one: "about 1 month",
    other: "about {{count}} months"
  },
  xMonths: {
    one: "1 month",
    other: "{{count}} months"
  },
  aboutXYears: {
    one: "about 1 year",
    other: "about {{count}} years"
  },
  xYears: {
    one: "1 year",
    other: "{{count}} years"
  },
  overXYears: {
    one: "over 1 year",
    other: "over {{count}} years"
  },
  almostXYears: {
    one: "almost 1 year",
    other: "almost {{count}} years"
  }
}, Ll = function(t, n, r) {
  var a, o = Fl[t];
  return typeof o == "string" ? a = o : n === 1 ? a = o.one : a = o.other.replace("{{count}}", n.toString()), r != null && r.addSuffix ? r.comparison && r.comparison > 0 ? "in " + a : a + " ago" : a;
};
const Wl = Ll;
function zr(e) {
  return function() {
    var t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, n = t.width ? String(t.width) : e.defaultWidth, r = e.formats[n] || e.formats[e.defaultWidth];
    return r;
  };
}
var zl = {
  full: "EEEE, MMMM do, y",
  long: "MMMM do, y",
  medium: "MMM d, y",
  short: "MM/dd/yyyy"
}, jl = {
  full: "h:mm:ss a zzzz",
  long: "h:mm:ss a z",
  medium: "h:mm:ss a",
  short: "h:mm a"
}, Hl = {
  full: "{{date}} 'at' {{time}}",
  long: "{{date}} 'at' {{time}}",
  medium: "{{date}}, {{time}}",
  short: "{{date}}, {{time}}"
}, ql = {
  date: zr({
    formats: zl,
    defaultWidth: "full"
  }),
  time: zr({
    formats: jl,
    defaultWidth: "full"
  }),
  dateTime: zr({
    formats: Hl,
    defaultWidth: "full"
  })
};
const Gl = ql;
var Ql = {
  lastWeek: "'last' eeee 'at' p",
  yesterday: "'yesterday at' p",
  today: "'today at' p",
  tomorrow: "'tomorrow at' p",
  nextWeek: "eeee 'at' p",
  other: "P"
}, Xl = function(t, n, r, a) {
  return Ql[t];
};
const Kl = Xl;
function Lt(e) {
  return function(t, n) {
    var r = n != null && n.context ? String(n.context) : "standalone", a;
    if (r === "formatting" && e.formattingValues) {
      var o = e.defaultFormattingWidth || e.defaultWidth, i = n != null && n.width ? String(n.width) : o;
      a = e.formattingValues[i] || e.formattingValues[o];
    } else {
      var l = e.defaultWidth, f = n != null && n.width ? String(n.width) : e.defaultWidth;
      a = e.values[f] || e.values[l];
    }
    var d = e.argumentCallback ? e.argumentCallback(t) : t;
    return a[d];
  };
}
var Jl = {
  narrow: ["B", "A"],
  abbreviated: ["BC", "AD"],
  wide: ["Before Christ", "Anno Domini"]
}, Zl = {
  narrow: ["1", "2", "3", "4"],
  abbreviated: ["Q1", "Q2", "Q3", "Q4"],
  wide: ["1st quarter", "2nd quarter", "3rd quarter", "4th quarter"]
}, es = {
  narrow: ["J", "F", "M", "A", "M", "J", "J", "A", "S", "O", "N", "D"],
  abbreviated: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
  wide: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
}, ts = {
  narrow: ["S", "M", "T", "W", "T", "F", "S"],
  short: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
  abbreviated: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
  wide: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
}, ns = {
  narrow: {
    am: "a",
    pm: "p",
    midnight: "mi",
    noon: "n",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  },
  abbreviated: {
    am: "AM",
    pm: "PM",
    midnight: "midnight",
    noon: "noon",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  },
  wide: {
    am: "a.m.",
    pm: "p.m.",
    midnight: "midnight",
    noon: "noon",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  }
}, rs = {
  narrow: {
    am: "a",
    pm: "p",
    midnight: "mi",
    noon: "n",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  },
  abbreviated: {
    am: "AM",
    pm: "PM",
    midnight: "midnight",
    noon: "noon",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  },
  wide: {
    am: "a.m.",
    pm: "p.m.",
    midnight: "midnight",
    noon: "noon",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  }
}, as = function(t, n) {
  var r = Number(t), a = r % 100;
  if (a > 20 || a < 10)
    switch (a % 10) {
      case 1:
        return r + "st";
      case 2:
        return r + "nd";
      case 3:
        return r + "rd";
    }
  return r + "th";
}, os = {
  ordinalNumber: as,
  era: Lt({
    values: Jl,
    defaultWidth: "wide"
  }),
  quarter: Lt({
    values: Zl,
    defaultWidth: "wide",
    argumentCallback: function(t) {
      return t - 1;
    }
  }),
  month: Lt({
    values: es,
    defaultWidth: "wide"
  }),
  day: Lt({
    values: ts,
    defaultWidth: "wide"
  }),
  dayPeriod: Lt({
    values: ns,
    defaultWidth: "wide",
    formattingValues: rs,
    defaultFormattingWidth: "wide"
  })
};
const is = os;
function Wt(e) {
  return function(t) {
    var n = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = n.width, a = r && e.matchPatterns[r] || e.matchPatterns[e.defaultMatchWidth], o = t.match(a);
    if (!o)
      return null;
    var i = o[0], l = r && e.parsePatterns[r] || e.parsePatterns[e.defaultParseWidth], f = Array.isArray(l) ? ls(l, function(p) {
      return p.test(i);
    }) : us(l, function(p) {
      return p.test(i);
    }), d;
    d = e.valueCallback ? e.valueCallback(f) : f, d = n.valueCallback ? n.valueCallback(d) : d;
    var m = t.slice(i.length);
    return {
      value: d,
      rest: m
    };
  };
}
function us(e, t) {
  for (var n in e)
    if (e.hasOwnProperty(n) && t(e[n]))
      return n;
}
function ls(e, t) {
  for (var n = 0; n < e.length; n++)
    if (t(e[n]))
      return n;
}
function ss(e) {
  return function(t) {
    var n = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = t.match(e.matchPattern);
    if (!r)
      return null;
    var a = r[0], o = t.match(e.parsePattern);
    if (!o)
      return null;
    var i = e.valueCallback ? e.valueCallback(o[0]) : o[0];
    i = n.valueCallback ? n.valueCallback(i) : i;
    var l = t.slice(a.length);
    return {
      value: i,
      rest: l
    };
  };
}
var fs = /^(\d+)(th|st|nd|rd)?/i, cs = /\d+/i, ds = {
  narrow: /^(b|a)/i,
  abbreviated: /^(b\.?\s?c\.?|b\.?\s?c\.?\s?e\.?|a\.?\s?d\.?|c\.?\s?e\.?)/i,
  wide: /^(before christ|before common era|anno domini|common era)/i
}, ps = {
  any: [/^b/i, /^(a|c)/i]
}, ys = {
  narrow: /^[1234]/i,
  abbreviated: /^q[1234]/i,
  wide: /^[1234](th|st|nd|rd)? quarter/i
}, ms = {
  any: [/1/i, /2/i, /3/i, /4/i]
}, vs = {
  narrow: /^[jfmasond]/i,
  abbreviated: /^(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)/i,
  wide: /^(january|february|march|april|may|june|july|august|september|october|november|december)/i
}, hs = {
  narrow: [/^j/i, /^f/i, /^m/i, /^a/i, /^m/i, /^j/i, /^j/i, /^a/i, /^s/i, /^o/i, /^n/i, /^d/i],
  any: [/^ja/i, /^f/i, /^mar/i, /^ap/i, /^may/i, /^jun/i, /^jul/i, /^au/i, /^s/i, /^o/i, /^n/i, /^d/i]
}, bs = {
  narrow: /^[smtwf]/i,
  short: /^(su|mo|tu|we|th|fr|sa)/i,
  abbreviated: /^(sun|mon|tue|wed|thu|fri|sat)/i,
  wide: /^(sunday|monday|tuesday|wednesday|thursday|friday|saturday)/i
}, gs = {
  narrow: [/^s/i, /^m/i, /^t/i, /^w/i, /^t/i, /^f/i, /^s/i],
  any: [/^su/i, /^m/i, /^tu/i, /^w/i, /^th/i, /^f/i, /^sa/i]
}, _s = {
  narrow: /^(a|p|mi|n|(in the|at) (morning|afternoon|evening|night))/i,
  any: /^([ap]\.?\s?m\.?|midnight|noon|(in the|at) (morning|afternoon|evening|night))/i
}, ws = {
  any: {
    am: /^a/i,
    pm: /^p/i,
    midnight: /^mi/i,
    noon: /^no/i,
    morning: /morning/i,
    afternoon: /afternoon/i,
    evening: /evening/i,
    night: /night/i
  }
}, Os = {
  ordinalNumber: ss({
    matchPattern: fs,
    parsePattern: cs,
    valueCallback: function(t) {
      return parseInt(t, 10);
    }
  }),
  era: Wt({
    matchPatterns: ds,
    defaultMatchWidth: "wide",
    parsePatterns: ps,
    defaultParseWidth: "any"
  }),
  quarter: Wt({
    matchPatterns: ys,
    defaultMatchWidth: "wide",
    parsePatterns: ms,
    defaultParseWidth: "any",
    valueCallback: function(t) {
      return t + 1;
    }
  }),
  month: Wt({
    matchPatterns: vs,
    defaultMatchWidth: "wide",
    parsePatterns: hs,
    defaultParseWidth: "any"
  }),
  day: Wt({
    matchPatterns: bs,
    defaultMatchWidth: "wide",
    parsePatterns: gs,
    defaultParseWidth: "any"
  }),
  dayPeriod: Wt({
    matchPatterns: _s,
    defaultMatchWidth: "any",
    parsePatterns: ws,
    defaultParseWidth: "any"
  })
};
const $s = Os;
var ks = {
  code: "en-US",
  formatDistance: Wl,
  formatLong: Gl,
  formatRelative: Kl,
  localize: is,
  match: $s,
  options: {
    weekStartsOn: 0,
    firstWeekContainsDate: 1
  }
};
const Mu = ks;
var Ps = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g, Ts = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g, Ds = /^'([^]*?)'?$/, Ss = /''/g, Rs = /[a-zA-Z]/;
function qt(e, t, n) {
  var r, a, o, i, l, f, d, m, p, s, w, A, U, G, ee, Q, C, z;
  J(2, arguments);
  var te = String(t), k = ht(), $ = (r = (a = n == null ? void 0 : n.locale) !== null && a !== void 0 ? a : k.locale) !== null && r !== void 0 ? r : Mu, x = ae((o = (i = (l = (f = n == null ? void 0 : n.firstWeekContainsDate) !== null && f !== void 0 ? f : n == null || (d = n.locale) === null || d === void 0 || (m = d.options) === null || m === void 0 ? void 0 : m.firstWeekContainsDate) !== null && l !== void 0 ? l : k.firstWeekContainsDate) !== null && i !== void 0 ? i : (p = k.locale) === null || p === void 0 || (s = p.options) === null || s === void 0 ? void 0 : s.firstWeekContainsDate) !== null && o !== void 0 ? o : 1);
  if (!(x >= 1 && x <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var F = ae((w = (A = (U = (G = n == null ? void 0 : n.weekStartsOn) !== null && G !== void 0 ? G : n == null || (ee = n.locale) === null || ee === void 0 || (Q = ee.options) === null || Q === void 0 ? void 0 : Q.weekStartsOn) !== null && U !== void 0 ? U : k.weekStartsOn) !== null && A !== void 0 ? A : (C = k.locale) === null || C === void 0 || (z = C.options) === null || z === void 0 ? void 0 : z.weekStartsOn) !== null && w !== void 0 ? w : 0);
  if (!(F >= 0 && F <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  if (!$.localize)
    throw new RangeError("locale must contain localize property");
  if (!$.formatLong)
    throw new RangeError("locale must contain formatLong property");
  var H = oe(e);
  if (!Ht(H))
    throw new RangeError("Invalid time value");
  var Y = Xn(H), X = $u(H, Y), O = {
    firstWeekContainsDate: x,
    weekStartsOn: F,
    locale: $,
    _originalDate: H
  }, y = te.match(Ts).map(function(P) {
    var D = P[0];
    if (D === "p" || D === "P") {
      var u = ia[D];
      return u(P, $.formatLong);
    }
    return P;
  }).join("").match(Ps).map(function(P) {
    if (P === "''")
      return "'";
    var D = P[0];
    if (D === "'")
      return Ms(P);
    var u = Il[D];
    if (u)
      return !(n != null && n.useAdditionalWeekYearTokens) && Ru(P) && Kn(P, t, String(e)), !(n != null && n.useAdditionalDayOfYearTokens) && Su(P) && Kn(P, t, String(e)), u(X, P, $.localize, O);
    if (D.match(Rs))
      throw new RangeError("Format string contains an unescaped latin alphabet character `" + D + "`");
    return P;
  }).join("");
  return y;
}
function Ms(e) {
  var t = e.match(Ds);
  return t ? t[1].replace(Ss, "'") : e;
}
function xs(e, t) {
  if (e == null)
    throw new TypeError("assign requires that input parameter not be null or undefined");
  for (var n in t)
    Object.prototype.hasOwnProperty.call(t, n) && (e[n] = t[n]);
  return e;
}
function Ns(e) {
  J(1, arguments);
  var t = oe(e), n = t.getDay();
  return n;
}
function Cs(e) {
  J(1, arguments);
  var t = oe(e), n = t.getFullYear(), r = t.getMonth(), a = new Date(0);
  return a.setFullYear(n, r + 1, 0), a.setHours(0, 0, 0, 0), a.getDate();
}
function ut(e) {
  J(1, arguments);
  var t = oe(e), n = t.getHours();
  return n;
}
var Es = 6048e5;
function As(e) {
  J(1, arguments);
  var t = oe(e), n = Qn(t).getTime() - $l(t).getTime();
  return Math.round(n / Es) + 1;
}
function lt(e) {
  J(1, arguments);
  var t = oe(e), n = t.getMinutes();
  return n;
}
function ke(e) {
  J(1, arguments);
  var t = oe(e), n = t.getMonth();
  return n;
}
function It(e) {
  J(1, arguments);
  var t = oe(e), n = t.getSeconds();
  return n;
}
function Pe(e) {
  return J(1, arguments), oe(e).getFullYear();
}
function To(e, t) {
  J(2, arguments);
  var n = oe(e), r = oe(t);
  return n.getTime() > r.getTime();
}
function Do(e, t) {
  J(2, arguments);
  var n = oe(e), r = oe(t);
  return n.getTime() < r.getTime();
}
function xu(e, t) {
  J(2, arguments);
  var n = oe(e), r = oe(t);
  return n.getTime() === r.getTime();
}
function cn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? cn = function(n) {
    return typeof n;
  } : cn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, cn(e);
}
function Nu(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ua(e, t);
}
function ua(e, t) {
  return ua = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ua(e, t);
}
function Cu(e) {
  var t = Bs();
  return function() {
    var r = Jn(e), a;
    if (t) {
      var o = Jn(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Is(this, a);
  };
}
function Is(e, t) {
  return t && (cn(t) === "object" || typeof t == "function") ? t : la(e);
}
function la(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Bs() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Jn(e) {
  return Jn = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Jn(e);
}
function So(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Lo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ro(e, t, n) {
  return t && Lo(e.prototype, t), n && Lo(e, n), e;
}
function sa(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Ys = 10, Eu = /* @__PURE__ */ function() {
  function e() {
    So(this, e), sa(this, "subPriority", 0);
  }
  return Ro(e, [{
    key: "validate",
    value: function(n, r) {
      return !0;
    }
  }]), e;
}(), Us = /* @__PURE__ */ function(e) {
  Nu(n, e);
  var t = Cu(n);
  function n(r, a, o, i, l) {
    var f;
    return So(this, n), f = t.call(this), f.value = r, f.validateValue = a, f.setValue = o, f.priority = i, l && (f.subPriority = l), f;
  }
  return Ro(n, [{
    key: "validate",
    value: function(a, o) {
      return this.validateValue(a, this.value, o);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return this.setValue(a, o, this.value, i);
    }
  }]), n;
}(Eu), Vs = /* @__PURE__ */ function(e) {
  Nu(n, e);
  var t = Cu(n);
  function n() {
    var r;
    So(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), sa(la(r), "priority", Ys), sa(la(r), "subPriority", -1), r;
  }
  return Ro(n, [{
    key: "set",
    value: function(a, o) {
      if (o.timestampIsSet)
        return a;
      var i = new Date(0);
      return i.setFullYear(a.getUTCFullYear(), a.getUTCMonth(), a.getUTCDate()), i.setHours(a.getUTCHours(), a.getUTCMinutes(), a.getUTCSeconds(), a.getUTCMilliseconds()), i;
    }
  }]), n;
}(Eu);
function Fs(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Wo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ls(e, t, n) {
  return t && Wo(e.prototype, t), n && Wo(e, n), e;
}
var ge = /* @__PURE__ */ function() {
  function e() {
    Fs(this, e);
  }
  return Ls(e, [{
    key: "run",
    value: function(n, r, a, o) {
      var i = this.parse(n, r, a, o);
      return i ? {
        setter: new Us(i.value, this.validate, this.set, this.priority, this.subPriority),
        rest: i.rest
      } : null;
    }
  }, {
    key: "validate",
    value: function(n, r, a) {
      return !0;
    }
  }]), e;
}();
function dn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? dn = function(n) {
    return typeof n;
  } : dn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, dn(e);
}
function Ws(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function zo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function zs(e, t, n) {
  return t && zo(e.prototype, t), n && zo(e, n), e;
}
function js(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && fa(e, t);
}
function fa(e, t) {
  return fa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, fa(e, t);
}
function Hs(e) {
  var t = Gs();
  return function() {
    var r = Zn(e), a;
    if (t) {
      var o = Zn(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return qs(this, a);
  };
}
function qs(e, t) {
  return t && (dn(t) === "object" || typeof t == "function") ? t : ca(e);
}
function ca(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Gs() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Zn(e) {
  return Zn = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Zn(e);
}
function jo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Qs = /* @__PURE__ */ function(e) {
  js(n, e);
  var t = Hs(n);
  function n() {
    var r;
    Ws(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), jo(ca(r), "priority", 140), jo(ca(r), "incompatibleTokens", ["R", "u", "t", "T"]), r;
  }
  return zs(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "G":
        case "GG":
        case "GGG":
          return i.era(a, {
            width: "abbreviated"
          }) || i.era(a, {
            width: "narrow"
          });
        case "GGGGG":
          return i.era(a, {
            width: "narrow"
          });
        case "GGGG":
        default:
          return i.era(a, {
            width: "wide"
          }) || i.era(a, {
            width: "abbreviated"
          }) || i.era(a, {
            width: "narrow"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.era = i, a.setUTCFullYear(i, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge), Ce = {
  month: /^(1[0-2]|0?\d)/,
  // 0 to 12
  date: /^(3[0-1]|[0-2]?\d)/,
  // 0 to 31
  dayOfYear: /^(36[0-6]|3[0-5]\d|[0-2]?\d?\d)/,
  // 0 to 366
  week: /^(5[0-3]|[0-4]?\d)/,
  // 0 to 53
  hour23h: /^(2[0-3]|[0-1]?\d)/,
  // 0 to 23
  hour24h: /^(2[0-4]|[0-1]?\d)/,
  // 0 to 24
  hour11h: /^(1[0-1]|0?\d)/,
  // 0 to 11
  hour12h: /^(1[0-2]|0?\d)/,
  // 0 to 12
  minute: /^[0-5]?\d/,
  // 0 to 59
  second: /^[0-5]?\d/,
  // 0 to 59
  singleDigit: /^\d/,
  // 0 to 9
  twoDigits: /^\d{1,2}/,
  // 0 to 99
  threeDigits: /^\d{1,3}/,
  // 0 to 999
  fourDigits: /^\d{1,4}/,
  // 0 to 9999
  anyDigitsSigned: /^-?\d+/,
  singleDigitSigned: /^-?\d/,
  // 0 to 9, -0 to -9
  twoDigitsSigned: /^-?\d{1,2}/,
  // 0 to 99, -0 to -99
  threeDigitsSigned: /^-?\d{1,3}/,
  // 0 to 999, -0 to -999
  fourDigitsSigned: /^-?\d{1,4}/
  // 0 to 9999, -0 to -9999
}, nt = {
  basicOptionalMinutes: /^([+-])(\d{2})(\d{2})?|Z/,
  basic: /^([+-])(\d{2})(\d{2})|Z/,
  basicOptionalSeconds: /^([+-])(\d{2})(\d{2})((\d{2}))?|Z/,
  extended: /^([+-])(\d{2}):(\d{2})|Z/,
  extendedOptionalSeconds: /^([+-])(\d{2}):(\d{2})(:(\d{2}))?|Z/
};
function Ee(e, t) {
  return e && {
    value: t(e.value),
    rest: e.rest
  };
}
function Re(e, t) {
  var n = t.match(e);
  return n ? {
    value: parseInt(n[0], 10),
    rest: t.slice(n[0].length)
  } : null;
}
function rt(e, t) {
  var n = t.match(e);
  if (!n)
    return null;
  if (n[0] === "Z")
    return {
      value: 0,
      rest: t.slice(1)
    };
  var r = n[1] === "+" ? 1 : -1, a = n[2] ? parseInt(n[2], 10) : 0, o = n[3] ? parseInt(n[3], 10) : 0, i = n[5] ? parseInt(n[5], 10) : 0;
  return {
    value: r * (a * ko + o * $o + i * Tl),
    rest: t.slice(n[0].length)
  };
}
function Au(e) {
  return Re(Ce.anyDigitsSigned, e);
}
function Ne(e, t) {
  switch (e) {
    case 1:
      return Re(Ce.singleDigit, t);
    case 2:
      return Re(Ce.twoDigits, t);
    case 3:
      return Re(Ce.threeDigits, t);
    case 4:
      return Re(Ce.fourDigits, t);
    default:
      return Re(new RegExp("^\\d{1," + e + "}"), t);
  }
}
function er(e, t) {
  switch (e) {
    case 1:
      return Re(Ce.singleDigitSigned, t);
    case 2:
      return Re(Ce.twoDigitsSigned, t);
    case 3:
      return Re(Ce.threeDigitsSigned, t);
    case 4:
      return Re(Ce.fourDigitsSigned, t);
    default:
      return Re(new RegExp("^-?\\d{1," + e + "}"), t);
  }
}
function Mo(e) {
  switch (e) {
    case "morning":
      return 4;
    case "evening":
      return 17;
    case "pm":
    case "noon":
    case "afternoon":
      return 12;
    case "am":
    case "midnight":
    case "night":
    default:
      return 0;
  }
}
function Iu(e, t) {
  var n = t > 0, r = n ? t : 1 - t, a;
  if (r <= 50)
    a = e || 100;
  else {
    var o = r + 50, i = Math.floor(o / 100) * 100, l = e >= o % 100;
    a = e + i - (l ? 100 : 0);
  }
  return n ? a : 1 - a;
}
function Bu(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function pn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? pn = function(n) {
    return typeof n;
  } : pn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, pn(e);
}
function Xs(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ho(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ks(e, t, n) {
  return t && Ho(e.prototype, t), n && Ho(e, n), e;
}
function Js(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && da(e, t);
}
function da(e, t) {
  return da = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, da(e, t);
}
function Zs(e) {
  var t = tf();
  return function() {
    var r = tr(e), a;
    if (t) {
      var o = tr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return ef(this, a);
  };
}
function ef(e, t) {
  return t && (pn(t) === "object" || typeof t == "function") ? t : pa(e);
}
function pa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function tf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function tr(e) {
  return tr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, tr(e);
}
function qo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var nf = /* @__PURE__ */ function(e) {
  Js(n, e);
  var t = Zs(n);
  function n() {
    var r;
    Xs(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), qo(pa(r), "priority", 130), qo(pa(r), "incompatibleTokens", ["Y", "R", "u", "w", "I", "i", "e", "c", "t", "T"]), r;
  }
  return Ks(n, [{
    key: "parse",
    value: function(a, o, i) {
      var l = function(d) {
        return {
          year: d,
          isTwoDigitYear: o === "yy"
        };
      };
      switch (o) {
        case "y":
          return Ee(Ne(4, a), l);
        case "yo":
          return Ee(i.ordinalNumber(a, {
            unit: "year"
          }), l);
        default:
          return Ee(Ne(o.length, a), l);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o.isTwoDigitYear || o.year > 0;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var l = a.getUTCFullYear();
      if (i.isTwoDigitYear) {
        var f = Iu(i.year, l);
        return a.setUTCFullYear(f, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
      }
      var d = !("era" in o) || o.era === 1 ? i.year : 1 - i.year;
      return a.setUTCFullYear(d, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function yn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? yn = function(n) {
    return typeof n;
  } : yn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, yn(e);
}
function rf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Go(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function af(e, t, n) {
  return t && Go(e.prototype, t), n && Go(e, n), e;
}
function of(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ya(e, t);
}
function ya(e, t) {
  return ya = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ya(e, t);
}
function uf(e) {
  var t = sf();
  return function() {
    var r = nr(e), a;
    if (t) {
      var o = nr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return lf(this, a);
  };
}
function lf(e, t) {
  return t && (yn(t) === "object" || typeof t == "function") ? t : ma(e);
}
function ma(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function sf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function nr(e) {
  return nr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, nr(e);
}
function Qo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var ff = /* @__PURE__ */ function(e) {
  of(n, e);
  var t = uf(n);
  function n() {
    var r;
    rf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Qo(ma(r), "priority", 130), Qo(ma(r), "incompatibleTokens", ["y", "R", "u", "Q", "q", "M", "L", "I", "d", "D", "i", "t", "T"]), r;
  }
  return af(n, [{
    key: "parse",
    value: function(a, o, i) {
      var l = function(d) {
        return {
          year: d,
          isTwoDigitYear: o === "YY"
        };
      };
      switch (o) {
        case "Y":
          return Ee(Ne(4, a), l);
        case "Yo":
          return Ee(i.ordinalNumber(a, {
            unit: "year"
          }), l);
        default:
          return Ee(Ne(o.length, a), l);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o.isTwoDigitYear || o.year > 0;
    }
  }, {
    key: "set",
    value: function(a, o, i, l) {
      var f = Po(a, l);
      if (i.isTwoDigitYear) {
        var d = Iu(i.year, f);
        return a.setUTCFullYear(d, 0, l.firstWeekContainsDate), a.setUTCHours(0, 0, 0, 0), Dt(a, l);
      }
      var m = !("era" in o) || o.era === 1 ? i.year : 1 - i.year;
      return a.setUTCFullYear(m, 0, l.firstWeekContainsDate), a.setUTCHours(0, 0, 0, 0), Dt(a, l);
    }
  }]), n;
}(ge);
function mn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? mn = function(n) {
    return typeof n;
  } : mn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, mn(e);
}
function cf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Xo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function df(e, t, n) {
  return t && Xo(e.prototype, t), n && Xo(e, n), e;
}
function pf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && va(e, t);
}
function va(e, t) {
  return va = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, va(e, t);
}
function yf(e) {
  var t = vf();
  return function() {
    var r = rr(e), a;
    if (t) {
      var o = rr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return mf(this, a);
  };
}
function mf(e, t) {
  return t && (mn(t) === "object" || typeof t == "function") ? t : ha(e);
}
function ha(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function vf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function rr(e) {
  return rr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, rr(e);
}
function Ko(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var hf = /* @__PURE__ */ function(e) {
  pf(n, e);
  var t = yf(n);
  function n() {
    var r;
    cf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ko(ha(r), "priority", 130), Ko(ha(r), "incompatibleTokens", ["G", "y", "Y", "u", "Q", "q", "M", "L", "w", "d", "D", "e", "c", "t", "T"]), r;
  }
  return df(n, [{
    key: "parse",
    value: function(a, o) {
      return er(o === "R" ? 4 : o.length, a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var l = new Date(0);
      return l.setUTCFullYear(i, 0, 4), l.setUTCHours(0, 0, 0, 0), At(l);
    }
  }]), n;
}(ge);
function vn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? vn = function(n) {
    return typeof n;
  } : vn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, vn(e);
}
function bf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Jo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function gf(e, t, n) {
  return t && Jo(e.prototype, t), n && Jo(e, n), e;
}
function _f(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ba(e, t);
}
function ba(e, t) {
  return ba = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ba(e, t);
}
function wf(e) {
  var t = $f();
  return function() {
    var r = ar(e), a;
    if (t) {
      var o = ar(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Of(this, a);
  };
}
function Of(e, t) {
  return t && (vn(t) === "object" || typeof t == "function") ? t : ga(e);
}
function ga(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function $f() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ar(e) {
  return ar = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ar(e);
}
function Zo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var kf = /* @__PURE__ */ function(e) {
  _f(n, e);
  var t = wf(n);
  function n() {
    var r;
    bf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Zo(ga(r), "priority", 130), Zo(ga(r), "incompatibleTokens", ["G", "y", "Y", "R", "w", "I", "i", "e", "c", "t", "T"]), r;
  }
  return gf(n, [{
    key: "parse",
    value: function(a, o) {
      return er(o === "u" ? 4 : o.length, a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCFullYear(i, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function hn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? hn = function(n) {
    return typeof n;
  } : hn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, hn(e);
}
function Pf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ei(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Tf(e, t, n) {
  return t && ei(e.prototype, t), n && ei(e, n), e;
}
function Df(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && _a(e, t);
}
function _a(e, t) {
  return _a = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, _a(e, t);
}
function Sf(e) {
  var t = Mf();
  return function() {
    var r = or(e), a;
    if (t) {
      var o = or(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Rf(this, a);
  };
}
function Rf(e, t) {
  return t && (hn(t) === "object" || typeof t == "function") ? t : wa(e);
}
function wa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Mf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function or(e) {
  return or = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, or(e);
}
function ti(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var xf = /* @__PURE__ */ function(e) {
  Df(n, e);
  var t = Sf(n);
  function n() {
    var r;
    Pf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ti(wa(r), "priority", 120), ti(wa(r), "incompatibleTokens", ["Y", "R", "q", "M", "L", "w", "I", "d", "D", "i", "e", "c", "t", "T"]), r;
  }
  return Tf(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "Q":
        case "QQ":
          return Ne(o.length, a);
        case "Qo":
          return i.ordinalNumber(a, {
            unit: "quarter"
          });
        case "QQQ":
          return i.quarter(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
        case "QQQQQ":
          return i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
        case "QQQQ":
        default:
          return i.quarter(a, {
            width: "wide",
            context: "formatting"
          }) || i.quarter(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 4;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth((i - 1) * 3, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function bn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? bn = function(n) {
    return typeof n;
  } : bn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, bn(e);
}
function Nf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ni(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Cf(e, t, n) {
  return t && ni(e.prototype, t), n && ni(e, n), e;
}
function Ef(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Oa(e, t);
}
function Oa(e, t) {
  return Oa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Oa(e, t);
}
function Af(e) {
  var t = Bf();
  return function() {
    var r = ir(e), a;
    if (t) {
      var o = ir(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return If(this, a);
  };
}
function If(e, t) {
  return t && (bn(t) === "object" || typeof t == "function") ? t : $a(e);
}
function $a(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Bf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ir(e) {
  return ir = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ir(e);
}
function ri(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Yf = /* @__PURE__ */ function(e) {
  Ef(n, e);
  var t = Af(n);
  function n() {
    var r;
    Nf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ri($a(r), "priority", 120), ri($a(r), "incompatibleTokens", ["Y", "R", "Q", "M", "L", "w", "I", "d", "D", "i", "e", "c", "t", "T"]), r;
  }
  return Cf(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "q":
        case "qq":
          return Ne(o.length, a);
        case "qo":
          return i.ordinalNumber(a, {
            unit: "quarter"
          });
        case "qqq":
          return i.quarter(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
        case "qqqqq":
          return i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
        case "qqqq":
        default:
          return i.quarter(a, {
            width: "wide",
            context: "standalone"
          }) || i.quarter(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 4;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth((i - 1) * 3, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function gn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? gn = function(n) {
    return typeof n;
  } : gn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, gn(e);
}
function Uf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ai(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Vf(e, t, n) {
  return t && ai(e.prototype, t), n && ai(e, n), e;
}
function Ff(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ka(e, t);
}
function ka(e, t) {
  return ka = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ka(e, t);
}
function Lf(e) {
  var t = zf();
  return function() {
    var r = ur(e), a;
    if (t) {
      var o = ur(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Wf(this, a);
  };
}
function Wf(e, t) {
  return t && (gn(t) === "object" || typeof t == "function") ? t : Pa(e);
}
function Pa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function zf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ur(e) {
  return ur = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ur(e);
}
function oi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var jf = /* @__PURE__ */ function(e) {
  Ff(n, e);
  var t = Lf(n);
  function n() {
    var r;
    Uf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), oi(Pa(r), "incompatibleTokens", ["Y", "R", "q", "Q", "L", "w", "I", "D", "i", "e", "c", "t", "T"]), oi(Pa(r), "priority", 110), r;
  }
  return Vf(n, [{
    key: "parse",
    value: function(a, o, i) {
      var l = function(d) {
        return d - 1;
      };
      switch (o) {
        case "M":
          return Ee(Re(Ce.month, a), l);
        case "MM":
          return Ee(Ne(2, a), l);
        case "Mo":
          return Ee(i.ordinalNumber(a, {
            unit: "month"
          }), l);
        case "MMM":
          return i.month(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.month(a, {
            width: "narrow",
            context: "formatting"
          });
        case "MMMMM":
          return i.month(a, {
            width: "narrow",
            context: "formatting"
          });
        case "MMMM":
        default:
          return i.month(a, {
            width: "wide",
            context: "formatting"
          }) || i.month(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.month(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(i, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function _n(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? _n = function(n) {
    return typeof n;
  } : _n = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, _n(e);
}
function Hf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ii(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function qf(e, t, n) {
  return t && ii(e.prototype, t), n && ii(e, n), e;
}
function Gf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ta(e, t);
}
function Ta(e, t) {
  return Ta = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ta(e, t);
}
function Qf(e) {
  var t = Kf();
  return function() {
    var r = lr(e), a;
    if (t) {
      var o = lr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Xf(this, a);
  };
}
function Xf(e, t) {
  return t && (_n(t) === "object" || typeof t == "function") ? t : Da(e);
}
function Da(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Kf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function lr(e) {
  return lr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, lr(e);
}
function ui(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Jf = /* @__PURE__ */ function(e) {
  Gf(n, e);
  var t = Qf(n);
  function n() {
    var r;
    Hf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ui(Da(r), "priority", 110), ui(Da(r), "incompatibleTokens", ["Y", "R", "q", "Q", "M", "w", "I", "D", "i", "e", "c", "t", "T"]), r;
  }
  return qf(n, [{
    key: "parse",
    value: function(a, o, i) {
      var l = function(d) {
        return d - 1;
      };
      switch (o) {
        case "L":
          return Ee(Re(Ce.month, a), l);
        case "LL":
          return Ee(Ne(2, a), l);
        case "Lo":
          return Ee(i.ordinalNumber(a, {
            unit: "month"
          }), l);
        case "LLL":
          return i.month(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.month(a, {
            width: "narrow",
            context: "standalone"
          });
        case "LLLLL":
          return i.month(a, {
            width: "narrow",
            context: "standalone"
          });
        case "LLLL":
        default:
          return i.month(a, {
            width: "wide",
            context: "standalone"
          }) || i.month(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.month(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(i, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Zf(e, t, n) {
  J(2, arguments);
  var r = oe(e), a = ae(t), o = Tu(r, n) - a;
  return r.setUTCDate(r.getUTCDate() - o * 7), r;
}
function wn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? wn = function(n) {
    return typeof n;
  } : wn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, wn(e);
}
function ec(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function li(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function tc(e, t, n) {
  return t && li(e.prototype, t), n && li(e, n), e;
}
function nc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Sa(e, t);
}
function Sa(e, t) {
  return Sa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Sa(e, t);
}
function rc(e) {
  var t = oc();
  return function() {
    var r = sr(e), a;
    if (t) {
      var o = sr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return ac(this, a);
  };
}
function ac(e, t) {
  return t && (wn(t) === "object" || typeof t == "function") ? t : Ra(e);
}
function Ra(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function oc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function sr(e) {
  return sr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, sr(e);
}
function si(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var ic = /* @__PURE__ */ function(e) {
  nc(n, e);
  var t = rc(n);
  function n() {
    var r;
    ec(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), si(Ra(r), "priority", 100), si(Ra(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "i", "t", "T"]), r;
  }
  return tc(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "w":
          return Re(Ce.week, a);
        case "wo":
          return i.ordinalNumber(a, {
            unit: "week"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 53;
    }
  }, {
    key: "set",
    value: function(a, o, i, l) {
      return Dt(Zf(a, i, l), l);
    }
  }]), n;
}(ge);
function uc(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t), a = Pu(n) - r;
  return n.setUTCDate(n.getUTCDate() - a * 7), n;
}
function On(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? On = function(n) {
    return typeof n;
  } : On = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, On(e);
}
function lc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function fi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function sc(e, t, n) {
  return t && fi(e.prototype, t), n && fi(e, n), e;
}
function fc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ma(e, t);
}
function Ma(e, t) {
  return Ma = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ma(e, t);
}
function cc(e) {
  var t = pc();
  return function() {
    var r = fr(e), a;
    if (t) {
      var o = fr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return dc(this, a);
  };
}
function dc(e, t) {
  return t && (On(t) === "object" || typeof t == "function") ? t : xa(e);
}
function xa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function pc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function fr(e) {
  return fr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, fr(e);
}
function ci(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var yc = /* @__PURE__ */ function(e) {
  fc(n, e);
  var t = cc(n);
  function n() {
    var r;
    lc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ci(xa(r), "priority", 100), ci(xa(r), "incompatibleTokens", ["y", "Y", "u", "q", "Q", "M", "L", "w", "d", "D", "e", "c", "t", "T"]), r;
  }
  return sc(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "I":
          return Re(Ce.week, a);
        case "Io":
          return i.ordinalNumber(a, {
            unit: "week"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 53;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return At(uc(a, i));
    }
  }]), n;
}(ge);
function $n(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? $n = function(n) {
    return typeof n;
  } : $n = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, $n(e);
}
function mc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function di(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function vc(e, t, n) {
  return t && di(e.prototype, t), n && di(e, n), e;
}
function hc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Na(e, t);
}
function Na(e, t) {
  return Na = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Na(e, t);
}
function bc(e) {
  var t = _c();
  return function() {
    var r = cr(e), a;
    if (t) {
      var o = cr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return gc(this, a);
  };
}
function gc(e, t) {
  return t && ($n(t) === "object" || typeof t == "function") ? t : kn(e);
}
function kn(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function _c() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function cr(e) {
  return cr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, cr(e);
}
function jr(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var wc = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], Oc = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], $c = /* @__PURE__ */ function(e) {
  hc(n, e);
  var t = bc(n);
  function n() {
    var r;
    mc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), jr(kn(r), "priority", 90), jr(kn(r), "subPriority", 1), jr(kn(r), "incompatibleTokens", ["Y", "R", "q", "Q", "w", "I", "D", "i", "e", "c", "t", "T"]), r;
  }
  return vc(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "d":
          return Re(Ce.date, a);
        case "do":
          return i.ordinalNumber(a, {
            unit: "date"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      var i = a.getUTCFullYear(), l = Bu(i), f = a.getUTCMonth();
      return l ? o >= 1 && o <= Oc[f] : o >= 1 && o <= wc[f];
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCDate(i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Pn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Pn = function(n) {
    return typeof n;
  } : Pn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Pn(e);
}
function kc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function pi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Pc(e, t, n) {
  return t && pi(e.prototype, t), n && pi(e, n), e;
}
function Tc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ca(e, t);
}
function Ca(e, t) {
  return Ca = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ca(e, t);
}
function Dc(e) {
  var t = Rc();
  return function() {
    var r = dr(e), a;
    if (t) {
      var o = dr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Sc(this, a);
  };
}
function Sc(e, t) {
  return t && (Pn(t) === "object" || typeof t == "function") ? t : Tn(e);
}
function Tn(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Rc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function dr(e) {
  return dr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, dr(e);
}
function Hr(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Mc = /* @__PURE__ */ function(e) {
  Tc(n, e);
  var t = Dc(n);
  function n() {
    var r;
    kc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Hr(Tn(r), "priority", 90), Hr(Tn(r), "subpriority", 1), Hr(Tn(r), "incompatibleTokens", ["Y", "R", "q", "Q", "M", "L", "w", "I", "d", "E", "i", "e", "c", "t", "T"]), r;
  }
  return Pc(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "D":
        case "DD":
          return Re(Ce.dayOfYear, a);
        case "Do":
          return i.ordinalNumber(a, {
            unit: "date"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      var i = a.getUTCFullYear(), l = Bu(i);
      return l ? o >= 1 && o <= 366 : o >= 1 && o <= 365;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(0, i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function xo(e, t, n) {
  var r, a, o, i, l, f, d, m;
  J(2, arguments);
  var p = ht(), s = ae((r = (a = (o = (i = n == null ? void 0 : n.weekStartsOn) !== null && i !== void 0 ? i : n == null || (l = n.locale) === null || l === void 0 || (f = l.options) === null || f === void 0 ? void 0 : f.weekStartsOn) !== null && o !== void 0 ? o : p.weekStartsOn) !== null && a !== void 0 ? a : (d = p.locale) === null || d === void 0 || (m = d.options) === null || m === void 0 ? void 0 : m.weekStartsOn) !== null && r !== void 0 ? r : 0);
  if (!(s >= 0 && s <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var w = oe(e), A = ae(t), U = w.getUTCDay(), G = A % 7, ee = (G + 7) % 7, Q = (ee < s ? 7 : 0) + A - U;
  return w.setUTCDate(w.getUTCDate() + Q), w;
}
function Dn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Dn = function(n) {
    return typeof n;
  } : Dn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Dn(e);
}
function xc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function yi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Nc(e, t, n) {
  return t && yi(e.prototype, t), n && yi(e, n), e;
}
function Cc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ea(e, t);
}
function Ea(e, t) {
  return Ea = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ea(e, t);
}
function Ec(e) {
  var t = Ic();
  return function() {
    var r = pr(e), a;
    if (t) {
      var o = pr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ac(this, a);
  };
}
function Ac(e, t) {
  return t && (Dn(t) === "object" || typeof t == "function") ? t : Aa(e);
}
function Aa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Ic() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function pr(e) {
  return pr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, pr(e);
}
function mi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Bc = /* @__PURE__ */ function(e) {
  Cc(n, e);
  var t = Ec(n);
  function n() {
    var r;
    xc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), mi(Aa(r), "priority", 90), mi(Aa(r), "incompatibleTokens", ["D", "i", "e", "c", "t", "T"]), r;
  }
  return Nc(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "E":
        case "EE":
        case "EEE":
          return i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEEE":
          return i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEEEE":
          return i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEE":
        default:
          return i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, l) {
      return a = xo(a, i, l), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Sn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Sn = function(n) {
    return typeof n;
  } : Sn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Sn(e);
}
function Yc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function vi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Uc(e, t, n) {
  return t && vi(e.prototype, t), n && vi(e, n), e;
}
function Vc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ia(e, t);
}
function Ia(e, t) {
  return Ia = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ia(e, t);
}
function Fc(e) {
  var t = Wc();
  return function() {
    var r = yr(e), a;
    if (t) {
      var o = yr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Lc(this, a);
  };
}
function Lc(e, t) {
  return t && (Sn(t) === "object" || typeof t == "function") ? t : Ba(e);
}
function Ba(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Wc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function yr(e) {
  return yr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, yr(e);
}
function hi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var zc = /* @__PURE__ */ function(e) {
  Vc(n, e);
  var t = Fc(n);
  function n() {
    var r;
    Yc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), hi(Ba(r), "priority", 90), hi(Ba(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "E", "i", "c", "t", "T"]), r;
  }
  return Uc(n, [{
    key: "parse",
    value: function(a, o, i, l) {
      var f = function(m) {
        var p = Math.floor((m - 1) / 7) * 7;
        return (m + l.weekStartsOn + 6) % 7 + p;
      };
      switch (o) {
        case "e":
        case "ee":
          return Ee(Ne(o.length, a), f);
        case "eo":
          return Ee(i.ordinalNumber(a, {
            unit: "day"
          }), f);
        case "eee":
          return i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeeee":
          return i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeeeee":
          return i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeee":
        default:
          return i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, l) {
      return a = xo(a, i, l), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Rn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Rn = function(n) {
    return typeof n;
  } : Rn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Rn(e);
}
function jc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function bi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Hc(e, t, n) {
  return t && bi(e.prototype, t), n && bi(e, n), e;
}
function qc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ya(e, t);
}
function Ya(e, t) {
  return Ya = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ya(e, t);
}
function Gc(e) {
  var t = Xc();
  return function() {
    var r = mr(e), a;
    if (t) {
      var o = mr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Qc(this, a);
  };
}
function Qc(e, t) {
  return t && (Rn(t) === "object" || typeof t == "function") ? t : Ua(e);
}
function Ua(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Xc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function mr(e) {
  return mr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, mr(e);
}
function gi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Kc = /* @__PURE__ */ function(e) {
  qc(n, e);
  var t = Gc(n);
  function n() {
    var r;
    jc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), gi(Ua(r), "priority", 90), gi(Ua(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "E", "i", "e", "t", "T"]), r;
  }
  return Hc(n, [{
    key: "parse",
    value: function(a, o, i, l) {
      var f = function(m) {
        var p = Math.floor((m - 1) / 7) * 7;
        return (m + l.weekStartsOn + 6) % 7 + p;
      };
      switch (o) {
        case "c":
        case "cc":
          return Ee(Ne(o.length, a), f);
        case "co":
          return Ee(i.ordinalNumber(a, {
            unit: "day"
          }), f);
        case "ccc":
          return i.day(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "ccccc":
          return i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "cccccc":
          return i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "cccc":
        default:
          return i.day(a, {
            width: "wide",
            context: "standalone"
          }) || i.day(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, l) {
      return a = xo(a, i, l), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Jc(e, t) {
  J(2, arguments);
  var n = ae(t);
  n % 7 === 0 && (n = n - 7);
  var r = 1, a = oe(e), o = a.getUTCDay(), i = n % 7, l = (i + 7) % 7, f = (l < r ? 7 : 0) + n - o;
  return a.setUTCDate(a.getUTCDate() + f), a;
}
function Mn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Mn = function(n) {
    return typeof n;
  } : Mn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Mn(e);
}
function Zc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function _i(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function ed(e, t, n) {
  return t && _i(e.prototype, t), n && _i(e, n), e;
}
function td(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Va(e, t);
}
function Va(e, t) {
  return Va = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Va(e, t);
}
function nd(e) {
  var t = ad();
  return function() {
    var r = vr(e), a;
    if (t) {
      var o = vr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return rd(this, a);
  };
}
function rd(e, t) {
  return t && (Mn(t) === "object" || typeof t == "function") ? t : Fa(e);
}
function Fa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function ad() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function vr(e) {
  return vr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, vr(e);
}
function wi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var od = /* @__PURE__ */ function(e) {
  td(n, e);
  var t = nd(n);
  function n() {
    var r;
    Zc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), wi(Fa(r), "priority", 90), wi(Fa(r), "incompatibleTokens", ["y", "Y", "u", "q", "Q", "M", "L", "w", "d", "D", "E", "e", "c", "t", "T"]), r;
  }
  return ed(n, [{
    key: "parse",
    value: function(a, o, i) {
      var l = function(d) {
        return d === 0 ? 7 : d;
      };
      switch (o) {
        case "i":
        case "ii":
          return Ne(o.length, a);
        case "io":
          return i.ordinalNumber(a, {
            unit: "day"
          });
        case "iii":
          return Ee(i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), l);
        case "iiiii":
          return Ee(i.day(a, {
            width: "narrow",
            context: "formatting"
          }), l);
        case "iiiiii":
          return Ee(i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), l);
        case "iiii":
        default:
          return Ee(i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), l);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 7;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a = Jc(a, i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function xn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? xn = function(n) {
    return typeof n;
  } : xn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, xn(e);
}
function id(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Oi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function ud(e, t, n) {
  return t && Oi(e.prototype, t), n && Oi(e, n), e;
}
function ld(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && La(e, t);
}
function La(e, t) {
  return La = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, La(e, t);
}
function sd(e) {
  var t = cd();
  return function() {
    var r = hr(e), a;
    if (t) {
      var o = hr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return fd(this, a);
  };
}
function fd(e, t) {
  return t && (xn(t) === "object" || typeof t == "function") ? t : Wa(e);
}
function Wa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function cd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function hr(e) {
  return hr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, hr(e);
}
function $i(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var dd = /* @__PURE__ */ function(e) {
  ld(n, e);
  var t = sd(n);
  function n() {
    var r;
    id(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), $i(Wa(r), "priority", 80), $i(Wa(r), "incompatibleTokens", ["b", "B", "H", "k", "t", "T"]), r;
  }
  return ud(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "a":
        case "aa":
        case "aaa":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "aaaaa":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "aaaa":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(Mo(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Nn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Nn = function(n) {
    return typeof n;
  } : Nn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Nn(e);
}
function pd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ki(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function yd(e, t, n) {
  return t && ki(e.prototype, t), n && ki(e, n), e;
}
function md(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && za(e, t);
}
function za(e, t) {
  return za = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, za(e, t);
}
function vd(e) {
  var t = bd();
  return function() {
    var r = br(e), a;
    if (t) {
      var o = br(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return hd(this, a);
  };
}
function hd(e, t) {
  return t && (Nn(t) === "object" || typeof t == "function") ? t : ja(e);
}
function ja(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function bd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function br(e) {
  return br = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, br(e);
}
function Pi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var gd = /* @__PURE__ */ function(e) {
  md(n, e);
  var t = vd(n);
  function n() {
    var r;
    pd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Pi(ja(r), "priority", 80), Pi(ja(r), "incompatibleTokens", ["a", "B", "H", "k", "t", "T"]), r;
  }
  return yd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "b":
        case "bb":
        case "bbb":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "bbbbb":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "bbbb":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(Mo(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Cn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Cn = function(n) {
    return typeof n;
  } : Cn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Cn(e);
}
function _d(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ti(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function wd(e, t, n) {
  return t && Ti(e.prototype, t), n && Ti(e, n), e;
}
function Od(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ha(e, t);
}
function Ha(e, t) {
  return Ha = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ha(e, t);
}
function $d(e) {
  var t = Pd();
  return function() {
    var r = gr(e), a;
    if (t) {
      var o = gr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return kd(this, a);
  };
}
function kd(e, t) {
  return t && (Cn(t) === "object" || typeof t == "function") ? t : qa(e);
}
function qa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Pd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function gr(e) {
  return gr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, gr(e);
}
function Di(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Td = /* @__PURE__ */ function(e) {
  Od(n, e);
  var t = $d(n);
  function n() {
    var r;
    _d(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Di(qa(r), "priority", 80), Di(qa(r), "incompatibleTokens", ["a", "b", "t", "T"]), r;
  }
  return wd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "B":
        case "BB":
        case "BBB":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "BBBBB":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "BBBB":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(Mo(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function En(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? En = function(n) {
    return typeof n;
  } : En = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, En(e);
}
function Dd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Si(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Sd(e, t, n) {
  return t && Si(e.prototype, t), n && Si(e, n), e;
}
function Rd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ga(e, t);
}
function Ga(e, t) {
  return Ga = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ga(e, t);
}
function Md(e) {
  var t = Nd();
  return function() {
    var r = _r(e), a;
    if (t) {
      var o = _r(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return xd(this, a);
  };
}
function xd(e, t) {
  return t && (En(t) === "object" || typeof t == "function") ? t : Qa(e);
}
function Qa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Nd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function _r(e) {
  return _r = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, _r(e);
}
function Ri(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Cd = /* @__PURE__ */ function(e) {
  Rd(n, e);
  var t = Md(n);
  function n() {
    var r;
    Dd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ri(Qa(r), "priority", 70), Ri(Qa(r), "incompatibleTokens", ["H", "K", "k", "t", "T"]), r;
  }
  return Sd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "h":
          return Re(Ce.hour12h, a);
        case "ho":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 12;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var l = a.getUTCHours() >= 12;
      return l && i < 12 ? a.setUTCHours(i + 12, 0, 0, 0) : !l && i === 12 ? a.setUTCHours(0, 0, 0, 0) : a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function An(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? An = function(n) {
    return typeof n;
  } : An = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, An(e);
}
function Ed(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Mi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ad(e, t, n) {
  return t && Mi(e.prototype, t), n && Mi(e, n), e;
}
function Id(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Xa(e, t);
}
function Xa(e, t) {
  return Xa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Xa(e, t);
}
function Bd(e) {
  var t = Ud();
  return function() {
    var r = wr(e), a;
    if (t) {
      var o = wr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Yd(this, a);
  };
}
function Yd(e, t) {
  return t && (An(t) === "object" || typeof t == "function") ? t : Ka(e);
}
function Ka(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Ud() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function wr(e) {
  return wr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, wr(e);
}
function xi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Vd = /* @__PURE__ */ function(e) {
  Id(n, e);
  var t = Bd(n);
  function n() {
    var r;
    Ed(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), xi(Ka(r), "priority", 70), xi(Ka(r), "incompatibleTokens", ["a", "b", "h", "K", "k", "t", "T"]), r;
  }
  return Ad(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "H":
          return Re(Ce.hour23h, a);
        case "Ho":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 23;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function In(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? In = function(n) {
    return typeof n;
  } : In = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, In(e);
}
function Fd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ni(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ld(e, t, n) {
  return t && Ni(e.prototype, t), n && Ni(e, n), e;
}
function Wd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ja(e, t);
}
function Ja(e, t) {
  return Ja = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ja(e, t);
}
function zd(e) {
  var t = Hd();
  return function() {
    var r = Or(e), a;
    if (t) {
      var o = Or(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return jd(this, a);
  };
}
function jd(e, t) {
  return t && (In(t) === "object" || typeof t == "function") ? t : Za(e);
}
function Za(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Hd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Or(e) {
  return Or = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Or(e);
}
function Ci(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var qd = /* @__PURE__ */ function(e) {
  Wd(n, e);
  var t = zd(n);
  function n() {
    var r;
    Fd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ci(Za(r), "priority", 70), Ci(Za(r), "incompatibleTokens", ["h", "H", "k", "t", "T"]), r;
  }
  return Ld(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "K":
          return Re(Ce.hour11h, a);
        case "Ko":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var l = a.getUTCHours() >= 12;
      return l && i < 12 ? a.setUTCHours(i + 12, 0, 0, 0) : a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Bn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Bn = function(n) {
    return typeof n;
  } : Bn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Bn(e);
}
function Gd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ei(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Qd(e, t, n) {
  return t && Ei(e.prototype, t), n && Ei(e, n), e;
}
function Xd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && eo(e, t);
}
function eo(e, t) {
  return eo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, eo(e, t);
}
function Kd(e) {
  var t = Zd();
  return function() {
    var r = $r(e), a;
    if (t) {
      var o = $r(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Jd(this, a);
  };
}
function Jd(e, t) {
  return t && (Bn(t) === "object" || typeof t == "function") ? t : to(e);
}
function to(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Zd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function $r(e) {
  return $r = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, $r(e);
}
function Ai(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var ep = /* @__PURE__ */ function(e) {
  Xd(n, e);
  var t = Kd(n);
  function n() {
    var r;
    Gd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ai(to(r), "priority", 70), Ai(to(r), "incompatibleTokens", ["a", "b", "h", "H", "K", "t", "T"]), r;
  }
  return Qd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "k":
          return Re(Ce.hour24h, a);
        case "ko":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 24;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var l = i <= 24 ? i % 24 : i;
      return a.setUTCHours(l, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Yn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Yn = function(n) {
    return typeof n;
  } : Yn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Yn(e);
}
function tp(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ii(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function np(e, t, n) {
  return t && Ii(e.prototype, t), n && Ii(e, n), e;
}
function rp(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && no(e, t);
}
function no(e, t) {
  return no = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, no(e, t);
}
function ap(e) {
  var t = ip();
  return function() {
    var r = kr(e), a;
    if (t) {
      var o = kr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return op(this, a);
  };
}
function op(e, t) {
  return t && (Yn(t) === "object" || typeof t == "function") ? t : ro(e);
}
function ro(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function ip() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function kr(e) {
  return kr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, kr(e);
}
function Bi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var up = /* @__PURE__ */ function(e) {
  rp(n, e);
  var t = ap(n);
  function n() {
    var r;
    tp(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Bi(ro(r), "priority", 60), Bi(ro(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return np(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "m":
          return Re(Ce.minute, a);
        case "mo":
          return i.ordinalNumber(a, {
            unit: "minute"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 59;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMinutes(i, 0, 0), a;
    }
  }]), n;
}(ge);
function Un(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Un = function(n) {
    return typeof n;
  } : Un = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Un(e);
}
function lp(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Yi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function sp(e, t, n) {
  return t && Yi(e.prototype, t), n && Yi(e, n), e;
}
function fp(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ao(e, t);
}
function ao(e, t) {
  return ao = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ao(e, t);
}
function cp(e) {
  var t = pp();
  return function() {
    var r = Pr(e), a;
    if (t) {
      var o = Pr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return dp(this, a);
  };
}
function dp(e, t) {
  return t && (Un(t) === "object" || typeof t == "function") ? t : oo(e);
}
function oo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function pp() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Pr(e) {
  return Pr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Pr(e);
}
function Ui(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var yp = /* @__PURE__ */ function(e) {
  fp(n, e);
  var t = cp(n);
  function n() {
    var r;
    lp(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ui(oo(r), "priority", 50), Ui(oo(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return sp(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "s":
          return Re(Ce.second, a);
        case "so":
          return i.ordinalNumber(a, {
            unit: "second"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 59;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCSeconds(i, 0), a;
    }
  }]), n;
}(ge);
function Vn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Vn = function(n) {
    return typeof n;
  } : Vn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Vn(e);
}
function mp(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Vi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function vp(e, t, n) {
  return t && Vi(e.prototype, t), n && Vi(e, n), e;
}
function hp(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && io(e, t);
}
function io(e, t) {
  return io = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, io(e, t);
}
function bp(e) {
  var t = _p();
  return function() {
    var r = Tr(e), a;
    if (t) {
      var o = Tr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return gp(this, a);
  };
}
function gp(e, t) {
  return t && (Vn(t) === "object" || typeof t == "function") ? t : uo(e);
}
function uo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function _p() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Tr(e) {
  return Tr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Tr(e);
}
function Fi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var wp = /* @__PURE__ */ function(e) {
  hp(n, e);
  var t = bp(n);
  function n() {
    var r;
    mp(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Fi(uo(r), "priority", 30), Fi(uo(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return vp(n, [{
    key: "parse",
    value: function(a, o) {
      var i = function(f) {
        return Math.floor(f * Math.pow(10, -o.length + 3));
      };
      return Ee(Ne(o.length, a), i);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMilliseconds(i), a;
    }
  }]), n;
}(ge);
function Fn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Fn = function(n) {
    return typeof n;
  } : Fn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Fn(e);
}
function Op(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Li(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function $p(e, t, n) {
  return t && Li(e.prototype, t), n && Li(e, n), e;
}
function kp(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && lo(e, t);
}
function lo(e, t) {
  return lo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, lo(e, t);
}
function Pp(e) {
  var t = Dp();
  return function() {
    var r = Dr(e), a;
    if (t) {
      var o = Dr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Tp(this, a);
  };
}
function Tp(e, t) {
  return t && (Fn(t) === "object" || typeof t == "function") ? t : so(e);
}
function so(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Dp() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Dr(e) {
  return Dr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Dr(e);
}
function Wi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Sp = /* @__PURE__ */ function(e) {
  kp(n, e);
  var t = Pp(n);
  function n() {
    var r;
    Op(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Wi(so(r), "priority", 10), Wi(so(r), "incompatibleTokens", ["t", "T", "x"]), r;
  }
  return $p(n, [{
    key: "parse",
    value: function(a, o) {
      switch (o) {
        case "X":
          return rt(nt.basicOptionalMinutes, a);
        case "XX":
          return rt(nt.basic, a);
        case "XXXX":
          return rt(nt.basicOptionalSeconds, a);
        case "XXXXX":
          return rt(nt.extendedOptionalSeconds, a);
        case "XXX":
        default:
          return rt(nt.extended, a);
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.timestampIsSet ? a : new Date(a.getTime() - i);
    }
  }]), n;
}(ge);
function Ln(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Ln = function(n) {
    return typeof n;
  } : Ln = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Ln(e);
}
function Rp(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function zi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Mp(e, t, n) {
  return t && zi(e.prototype, t), n && zi(e, n), e;
}
function xp(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && fo(e, t);
}
function fo(e, t) {
  return fo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, fo(e, t);
}
function Np(e) {
  var t = Ep();
  return function() {
    var r = Sr(e), a;
    if (t) {
      var o = Sr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Cp(this, a);
  };
}
function Cp(e, t) {
  return t && (Ln(t) === "object" || typeof t == "function") ? t : co(e);
}
function co(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Ep() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Sr(e) {
  return Sr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Sr(e);
}
function ji(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Ap = /* @__PURE__ */ function(e) {
  xp(n, e);
  var t = Np(n);
  function n() {
    var r;
    Rp(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ji(co(r), "priority", 10), ji(co(r), "incompatibleTokens", ["t", "T", "X"]), r;
  }
  return Mp(n, [{
    key: "parse",
    value: function(a, o) {
      switch (o) {
        case "x":
          return rt(nt.basicOptionalMinutes, a);
        case "xx":
          return rt(nt.basic, a);
        case "xxxx":
          return rt(nt.basicOptionalSeconds, a);
        case "xxxxx":
          return rt(nt.extendedOptionalSeconds, a);
        case "xxx":
        default:
          return rt(nt.extended, a);
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.timestampIsSet ? a : new Date(a.getTime() - i);
    }
  }]), n;
}(ge);
function Wn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Wn = function(n) {
    return typeof n;
  } : Wn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Wn(e);
}
function Ip(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Hi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Bp(e, t, n) {
  return t && Hi(e.prototype, t), n && Hi(e, n), e;
}
function Yp(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && po(e, t);
}
function po(e, t) {
  return po = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, po(e, t);
}
function Up(e) {
  var t = Fp();
  return function() {
    var r = Rr(e), a;
    if (t) {
      var o = Rr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Vp(this, a);
  };
}
function Vp(e, t) {
  return t && (Wn(t) === "object" || typeof t == "function") ? t : yo(e);
}
function yo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Fp() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Rr(e) {
  return Rr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Rr(e);
}
function qi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Lp = /* @__PURE__ */ function(e) {
  Yp(n, e);
  var t = Up(n);
  function n() {
    var r;
    Ip(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), qi(yo(r), "priority", 40), qi(yo(r), "incompatibleTokens", "*"), r;
  }
  return Bp(n, [{
    key: "parse",
    value: function(a) {
      return Au(a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return [new Date(i * 1e3), {
        timestampIsSet: !0
      }];
    }
  }]), n;
}(ge);
function zn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? zn = function(n) {
    return typeof n;
  } : zn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, zn(e);
}
function Wp(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Gi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function zp(e, t, n) {
  return t && Gi(e.prototype, t), n && Gi(e, n), e;
}
function jp(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && mo(e, t);
}
function mo(e, t) {
  return mo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, mo(e, t);
}
function Hp(e) {
  var t = Gp();
  return function() {
    var r = Mr(e), a;
    if (t) {
      var o = Mr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return qp(this, a);
  };
}
function qp(e, t) {
  return t && (zn(t) === "object" || typeof t == "function") ? t : vo(e);
}
function vo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Gp() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Mr(e) {
  return Mr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Mr(e);
}
function Qi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Qp = /* @__PURE__ */ function(e) {
  jp(n, e);
  var t = Hp(n);
  function n() {
    var r;
    Wp(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Qi(vo(r), "priority", 20), Qi(vo(r), "incompatibleTokens", "*"), r;
  }
  return zp(n, [{
    key: "parse",
    value: function(a) {
      return Au(a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return [new Date(i), {
        timestampIsSet: !0
      }];
    }
  }]), n;
}(ge), Xp = {
  G: new Qs(),
  y: new nf(),
  Y: new ff(),
  R: new hf(),
  u: new kf(),
  Q: new xf(),
  q: new Yf(),
  M: new jf(),
  L: new Jf(),
  w: new ic(),
  I: new yc(),
  d: new $c(),
  D: new Mc(),
  E: new Bc(),
  e: new zc(),
  c: new Kc(),
  i: new od(),
  a: new dd(),
  b: new gd(),
  B: new Td(),
  h: new Cd(),
  H: new Vd(),
  K: new qd(),
  k: new ep(),
  m: new up(),
  s: new yp(),
  S: new wp(),
  X: new Sp(),
  x: new Ap(),
  t: new Lp(),
  T: new Qp()
};
function jn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? jn = function(n) {
    return typeof n;
  } : jn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, jn(e);
}
function Xi(e, t) {
  var n;
  if (typeof Symbol > "u" || e[Symbol.iterator] == null) {
    if (Array.isArray(e) || (n = Kp(e)) || t && e && typeof e.length == "number") {
      n && (e = n);
      var r = 0, a = function() {
      };
      return { s: a, n: function() {
        return r >= e.length ? { done: !0 } : { done: !1, value: e[r++] };
      }, e: function(d) {
        throw d;
      }, f: a };
    }
    throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  var o = !0, i = !1, l;
  return { s: function() {
    n = e[Symbol.iterator]();
  }, n: function() {
    var d = n.next();
    return o = d.done, d;
  }, e: function(d) {
    i = !0, l = d;
  }, f: function() {
    try {
      !o && n.return != null && n.return();
    } finally {
      if (i)
        throw l;
    }
  } };
}
function Kp(e, t) {
  if (e) {
    if (typeof e == "string")
      return Ki(e, t);
    var n = Object.prototype.toString.call(e).slice(8, -1);
    if (n === "Object" && e.constructor && (n = e.constructor.name), n === "Map" || n === "Set")
      return Array.from(e);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return Ki(e, t);
  }
}
function Ki(e, t) {
  (t == null || t > e.length) && (t = e.length);
  for (var n = 0, r = new Array(t); n < t; n++)
    r[n] = e[n];
  return r;
}
var Jp = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g, Zp = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g, ey = /^'([^]*?)'?$/, ty = /''/g, ny = /\S/, ry = /[a-zA-Z]/;
function ho(e, t, n, r) {
  var a, o, i, l, f, d, m, p, s, w, A, U, G, ee, Q, C, z, te;
  J(3, arguments);
  var k = String(e), $ = String(t), x = ht(), F = (a = (o = r == null ? void 0 : r.locale) !== null && o !== void 0 ? o : x.locale) !== null && a !== void 0 ? a : Mu;
  if (!F.match)
    throw new RangeError("locale must contain match property");
  var H = ae((i = (l = (f = (d = r == null ? void 0 : r.firstWeekContainsDate) !== null && d !== void 0 ? d : r == null || (m = r.locale) === null || m === void 0 || (p = m.options) === null || p === void 0 ? void 0 : p.firstWeekContainsDate) !== null && f !== void 0 ? f : x.firstWeekContainsDate) !== null && l !== void 0 ? l : (s = x.locale) === null || s === void 0 || (w = s.options) === null || w === void 0 ? void 0 : w.firstWeekContainsDate) !== null && i !== void 0 ? i : 1);
  if (!(H >= 1 && H <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var Y = ae((A = (U = (G = (ee = r == null ? void 0 : r.weekStartsOn) !== null && ee !== void 0 ? ee : r == null || (Q = r.locale) === null || Q === void 0 || (C = Q.options) === null || C === void 0 ? void 0 : C.weekStartsOn) !== null && G !== void 0 ? G : x.weekStartsOn) !== null && U !== void 0 ? U : (z = x.locale) === null || z === void 0 || (te = z.options) === null || te === void 0 ? void 0 : te.weekStartsOn) !== null && A !== void 0 ? A : 0);
  if (!(Y >= 0 && Y <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  if ($ === "")
    return k === "" ? oe(n) : new Date(NaN);
  var X = {
    firstWeekContainsDate: H,
    weekStartsOn: Y,
    locale: F
  }, O = [new Vs()], y = $.match(Zp).map(function(me) {
    var ue = me[0];
    if (ue in ia) {
      var De = ia[ue];
      return De(me, F.formatLong);
    }
    return me;
  }).join("").match(Jp), P = [], D = Xi(y), u;
  try {
    var g = function() {
      var ue = u.value;
      !(r != null && r.useAdditionalWeekYearTokens) && Ru(ue) && Kn(ue, $, e), !(r != null && r.useAdditionalDayOfYearTokens) && Su(ue) && Kn(ue, $, e);
      var De = ue[0], Qe = Xp[De];
      if (Qe) {
        var se = Qe.incompatibleTokens;
        if (Array.isArray(se)) {
          var ce = P.find(function(be) {
            return se.includes(be.token) || be.token === De;
          });
          if (ce)
            throw new RangeError("The format string mustn't contain `".concat(ce.fullToken, "` and `").concat(ue, "` at the same time"));
        } else if (Qe.incompatibleTokens === "*" && P.length > 0)
          throw new RangeError("The format string mustn't contain `".concat(ue, "` and any other token at the same time"));
        P.push({
          token: De,
          fullToken: ue
        });
        var Oe = Qe.run(k, ue, F.match, X);
        if (!Oe)
          return {
            v: new Date(NaN)
          };
        O.push(Oe.setter), k = Oe.rest;
      } else {
        if (De.match(ry))
          throw new RangeError("Format string contains an unescaped latin alphabet character `" + De + "`");
        if (ue === "''" ? ue = "'" : De === "'" && (ue = ay(ue)), k.indexOf(ue) === 0)
          k = k.slice(ue.length);
        else
          return {
            v: new Date(NaN)
          };
      }
    };
    for (D.s(); !(u = D.n()).done; ) {
      var S = g();
      if (jn(S) === "object")
        return S.v;
    }
  } catch (me) {
    D.e(me);
  } finally {
    D.f();
  }
  if (k.length > 0 && ny.test(k))
    return new Date(NaN);
  var I = O.map(function(me) {
    return me.priority;
  }).sort(function(me, ue) {
    return ue - me;
  }).filter(function(me, ue, De) {
    return De.indexOf(me) === ue;
  }).map(function(me) {
    return O.filter(function(ue) {
      return ue.priority === me;
    }).sort(function(ue, De) {
      return De.subPriority - ue.subPriority;
    });
  }).map(function(me) {
    return me[0];
  }), V = oe(n);
  if (isNaN(V.getTime()))
    return new Date(NaN);
  var _ = $u(V, Xn(V)), le = {}, de = Xi(I), h;
  try {
    for (de.s(); !(h = de.n()).done; ) {
      var B = h.value;
      if (!B.validate(_, X))
        return new Date(NaN);
      var Me = B.set(_, le, X);
      Array.isArray(Me) ? (_ = Me[0], xs(le, Me[1])) : _ = Me;
    }
  } catch (me) {
    de.e(me);
  } finally {
    de.f();
  }
  return _;
}
function ay(e) {
  return e.match(ey)[1].replace(ty, "'");
}
function oy(e, t) {
  J(2, arguments);
  var n = ae(t);
  return dt(e, -n);
}
function iy(e, t) {
  var n;
  J(1, arguments);
  var r = ae((n = t == null ? void 0 : t.additionalDigits) !== null && n !== void 0 ? n : 2);
  if (r !== 2 && r !== 1 && r !== 0)
    throw new RangeError("additionalDigits must be 0, 1 or 2");
  if (!(typeof e == "string" || Object.prototype.toString.call(e) === "[object String]"))
    return new Date(NaN);
  var a = fy(e), o;
  if (a.date) {
    var i = cy(a.date, r);
    o = dy(i.restDateString, i.year);
  }
  if (!o || isNaN(o.getTime()))
    return new Date(NaN);
  var l = o.getTime(), f = 0, d;
  if (a.time && (f = py(a.time), isNaN(f)))
    return new Date(NaN);
  if (a.timezone) {
    if (d = yy(a.timezone), isNaN(d))
      return new Date(NaN);
  } else {
    var m = new Date(l + f), p = new Date(0);
    return p.setFullYear(m.getUTCFullYear(), m.getUTCMonth(), m.getUTCDate()), p.setHours(m.getUTCHours(), m.getUTCMinutes(), m.getUTCSeconds(), m.getUTCMilliseconds()), p;
  }
  return new Date(l + f + d);
}
var nn = {
  dateTimeDelimiter: /[T ]/,
  timeZoneDelimiter: /[Z ]/i,
  timezone: /([Z+-].*)$/
}, uy = /^-?(?:(\d{3})|(\d{2})(?:-?(\d{2}))?|W(\d{2})(?:-?(\d{1}))?|)$/, ly = /^(\d{2}(?:[.,]\d*)?)(?::?(\d{2}(?:[.,]\d*)?))?(?::?(\d{2}(?:[.,]\d*)?))?$/, sy = /^([+-])(\d{2})(?::?(\d{2}))?$/;
function fy(e) {
  var t = {}, n = e.split(nn.dateTimeDelimiter), r;
  if (n.length > 2)
    return t;
  if (/:/.test(n[0]) ? r = n[0] : (t.date = n[0], r = n[1], nn.timeZoneDelimiter.test(t.date) && (t.date = e.split(nn.timeZoneDelimiter)[0], r = e.substr(t.date.length, e.length))), r) {
    var a = nn.timezone.exec(r);
    a ? (t.time = r.replace(a[1], ""), t.timezone = a[1]) : t.time = r;
  }
  return t;
}
function cy(e, t) {
  var n = new RegExp("^(?:(\\d{4}|[+-]\\d{" + (4 + t) + "})|(\\d{2}|[+-]\\d{" + (2 + t) + "})$)"), r = e.match(n);
  if (!r)
    return {
      year: NaN,
      restDateString: ""
    };
  var a = r[1] ? parseInt(r[1]) : null, o = r[2] ? parseInt(r[2]) : null;
  return {
    year: o === null ? a : o * 100,
    restDateString: e.slice((r[1] || r[2]).length)
  };
}
function dy(e, t) {
  if (t === null)
    return new Date(NaN);
  var n = e.match(uy);
  if (!n)
    return new Date(NaN);
  var r = !!n[4], a = zt(n[1]), o = zt(n[2]) - 1, i = zt(n[3]), l = zt(n[4]), f = zt(n[5]) - 1;
  if (r)
    return gy(t, l, f) ? my(t, l, f) : new Date(NaN);
  var d = new Date(0);
  return !hy(t, o, i) || !by(t, a) ? new Date(NaN) : (d.setUTCFullYear(t, o, Math.max(a, i)), d);
}
function zt(e) {
  return e ? parseInt(e) : 1;
}
function py(e) {
  var t = e.match(ly);
  if (!t)
    return NaN;
  var n = qr(t[1]), r = qr(t[2]), a = qr(t[3]);
  return _y(n, r, a) ? n * ko + r * $o + a * 1e3 : NaN;
}
function qr(e) {
  return e && parseFloat(e.replace(",", ".")) || 0;
}
function yy(e) {
  if (e === "Z")
    return 0;
  var t = e.match(sy);
  if (!t)
    return 0;
  var n = t[1] === "+" ? -1 : 1, r = parseInt(t[2]), a = t[3] && parseInt(t[3]) || 0;
  return wy(r, a) ? n * (r * ko + a * $o) : NaN;
}
function my(e, t, n) {
  var r = new Date(0);
  r.setUTCFullYear(e, 0, 4);
  var a = r.getUTCDay() || 7, o = (t - 1) * 7 + n + 1 - a;
  return r.setUTCDate(r.getUTCDate() + o), r;
}
var vy = [31, null, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
function Yu(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function hy(e, t, n) {
  return t >= 0 && t <= 11 && n >= 1 && n <= (vy[t] || (Yu(e) ? 29 : 28));
}
function by(e, t) {
  return t >= 1 && t <= (Yu(e) ? 366 : 365);
}
function gy(e, t, n) {
  return t >= 1 && t <= 53 && n >= 0 && n <= 6;
}
function _y(e, t, n) {
  return e === 24 ? t === 0 && n === 0 : n >= 0 && n < 60 && t >= 0 && t < 60 && e >= 0 && e < 25;
}
function wy(e, t) {
  return t >= 0 && t <= 59;
}
function Gt(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t), a = n.getFullYear(), o = n.getDate(), i = new Date(0);
  i.setFullYear(a, r, 15), i.setHours(0, 0, 0, 0);
  var l = Cs(i);
  return n.setMonth(r, Math.min(o, l)), n;
}
function Hn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Hn = function(n) {
    return typeof n;
  } : Hn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Hn(e);
}
function ze(e, t) {
  if (J(2, arguments), Hn(t) !== "object" || t === null)
    throw new RangeError("values parameter must be an object");
  var n = oe(e);
  return isNaN(n.getTime()) ? new Date(NaN) : (t.year != null && n.setFullYear(t.year), t.month != null && (n = Gt(n, t.month)), t.date != null && n.setDate(ae(t.date)), t.hours != null && n.setHours(ae(t.hours)), t.minutes != null && n.setMinutes(ae(t.minutes)), t.seconds != null && n.setSeconds(ae(t.seconds)), t.milliseconds != null && n.setMilliseconds(ae(t.milliseconds)), n);
}
function Uu(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t);
  return n.setHours(r), n;
}
function No(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t);
  return n.setMilliseconds(r), n;
}
function Vu(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t);
  return n.setMinutes(r), n;
}
function Fu(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t);
  return n.setSeconds(r), n;
}
function Tt(e, t) {
  J(2, arguments);
  var n = oe(e), r = ae(t);
  return isNaN(n.getTime()) ? new Date(NaN) : (n.setFullYear(r), n);
}
function Et(e, t) {
  J(2, arguments);
  var n = ae(t);
  return at(e, -n);
}
function qn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? qn = function(n) {
    return typeof n;
  } : qn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, qn(e);
}
function Oy(e, t) {
  if (J(2, arguments), !t || qn(t) !== "object")
    return new Date(NaN);
  var n = t.years ? ae(t.years) : 0, r = t.months ? ae(t.months) : 0, a = t.weeks ? ae(t.weeks) : 0, o = t.days ? ae(t.days) : 0, i = t.hours ? ae(t.hours) : 0, l = t.minutes ? ae(t.minutes) : 0, f = t.seconds ? ae(t.seconds) : 0, d = Et(e, r + n * 12), m = oy(d, o + a * 7), p = l + i * 60, s = f + p * 60, w = s * 1e3, A = new Date(m.getTime() - w);
  return A;
}
function $y(e, t) {
  J(2, arguments);
  var n = ae(t);
  return wu(e, -n);
}
const Rt = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [r, a] of t)
    n[r] = a;
  return n;
}, ky = {}, Py = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Ty = /* @__PURE__ */ ie("path", { d: "M29.333 8c0-2.208-1.792-4-4-4h-18.667c-2.208 0-4 1.792-4 4v18.667c0 2.208 1.792 4 4 4h18.667c2.208 0 4-1.792 4-4v-18.667zM26.667 8v18.667c0 0.736-0.597 1.333-1.333 1.333 0 0-18.667 0-18.667 0-0.736 0-1.333-0.597-1.333-1.333 0 0 0-18.667 0-18.667 0-0.736 0.597-1.333 1.333-1.333 0 0 18.667 0 18.667 0 0.736 0 1.333 0.597 1.333 1.333z" }, null, -1), Dy = /* @__PURE__ */ ie("path", { d: "M20 2.667v5.333c0 0.736 0.597 1.333 1.333 1.333s1.333-0.597 1.333-1.333v-5.333c0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), Sy = /* @__PURE__ */ ie("path", { d: "M9.333 2.667v5.333c0 0.736 0.597 1.333 1.333 1.333s1.333-0.597 1.333-1.333v-5.333c0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), Ry = /* @__PURE__ */ ie("path", { d: "M4 14.667h24c0.736 0 1.333-0.597 1.333-1.333s-0.597-1.333-1.333-1.333h-24c-0.736 0-1.333 0.597-1.333 1.333s0.597 1.333 1.333 1.333z" }, null, -1), My = [
  Ty,
  Dy,
  Sy,
  Ry
];
function xy(e, t) {
  return b(), E("svg", Py, My);
}
const Ir = /* @__PURE__ */ Rt(ky, [["render", xy]]), Ny = {}, Cy = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Ey = /* @__PURE__ */ ie("path", { d: "M23.057 7.057l-16 16c-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0l16-16c0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0z" }, null, -1), Ay = /* @__PURE__ */ ie("path", { d: "M7.057 8.943l16 16c0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885l-16-16c-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885z" }, null, -1), Iy = [
  Ey,
  Ay
];
function By(e, t) {
  return b(), E("svg", Cy, Iy);
}
const Yy = /* @__PURE__ */ Rt(Ny, [["render", By]]), Uy = {}, Vy = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Fy = /* @__PURE__ */ ie("path", { d: "M20.943 23.057l-7.057-7.057c0 0 7.057-7.057 7.057-7.057 0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0l-8 8c-0.521 0.521-0.521 1.365 0 1.885l8 8c0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885z" }, null, -1), Ly = [
  Fy
];
function Wy(e, t) {
  return b(), E("svg", Vy, Ly);
}
const Ji = /* @__PURE__ */ Rt(Uy, [["render", Wy]]), zy = {}, jy = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Hy = /* @__PURE__ */ ie("path", { d: "M12.943 24.943l8-8c0.521-0.521 0.521-1.365 0-1.885l-8-8c-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885l7.057 7.057c0 0-7.057 7.057-7.057 7.057-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0z" }, null, -1), qy = [
  Hy
];
function Gy(e, t) {
  return b(), E("svg", jy, qy);
}
const Zi = /* @__PURE__ */ Rt(zy, [["render", Gy]]), Qy = {}, Xy = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Ky = /* @__PURE__ */ ie("path", { d: "M16 1.333c-8.095 0-14.667 6.572-14.667 14.667s6.572 14.667 14.667 14.667c8.095 0 14.667-6.572 14.667-14.667s-6.572-14.667-14.667-14.667zM16 4c6.623 0 12 5.377 12 12s-5.377 12-12 12c-6.623 0-12-5.377-12-12s5.377-12 12-12z" }, null, -1), Jy = /* @__PURE__ */ ie("path", { d: "M14.667 8v8c0 0.505 0.285 0.967 0.737 1.193l5.333 2.667c0.658 0.329 1.46 0.062 1.789-0.596s0.062-1.46-0.596-1.789l-4.596-2.298c0 0 0-7.176 0-7.176 0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), Zy = [
  Ky,
  Jy
];
function em(e, t) {
  return b(), E("svg", Xy, Zy);
}
const Lu = /* @__PURE__ */ Rt(Qy, [["render", em]]), tm = {}, nm = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, rm = /* @__PURE__ */ ie("path", { d: "M24.943 19.057l-8-8c-0.521-0.521-1.365-0.521-1.885 0l-8 8c-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0l7.057-7.057c0 0 7.057 7.057 7.057 7.057 0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885z" }, null, -1), am = [
  rm
];
function om(e, t) {
  return b(), E("svg", nm, am);
}
const Wu = /* @__PURE__ */ Rt(tm, [["render", om]]), im = {}, um = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, lm = /* @__PURE__ */ ie("path", { d: "M7.057 12.943l8 8c0.521 0.521 1.365 0.521 1.885 0l8-8c0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0l-7.057 7.057c0 0-7.057-7.057-7.057-7.057-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885z" }, null, -1), sm = [
  lm
];
function fm(e, t) {
  return b(), E("svg", um, sm);
}
const zu = /* @__PURE__ */ Rt(im, [["render", fm]]), eu = (e, t) => {
  const n = ho(e, t.slice(0, e.length), new Date());
  return Ht(n) && Ou(n) ? n : null;
}, cm = (e, t) => {
  if (typeof t == "string")
    return eu(e, t);
  if (Array.isArray(t)) {
    let n = null;
    for (const r of t)
      if (n = eu(e, r), n)
        break;
    return n;
  }
  return typeof t == "function" ? t(e) : null;
}, M = (e) => e ? new Date(e) : new Date(), dm = (e, t) => {
  if (t) {
    const r = (e.getMonth() + 1).toString().padStart(2, "0"), a = e.getDate().toString().padStart(2, "0"), o = e.getHours().toString().padStart(2, "0"), i = e.getMinutes().toString().padStart(2, "0");
    return `${e.getFullYear()}-${r}-${a}T${o}:${i}:00.000Z`;
  }
  const n = Date.UTC(
    e.getUTCFullYear(),
    e.getUTCMonth(),
    e.getUTCDate(),
    e.getUTCHours(),
    e.getUTCMinutes(),
    e.getUTCSeconds()
  );
  return new Date(n).toISOString();
}, ot = (e) => {
  let t = M(JSON.parse(JSON.stringify(e)));
  return t = Uu(t, 0), t = Vu(t, 0), t = Fu(t, 0), t = No(t, 0), t;
}, Je = (e, t, n, r) => {
  let a = e ? M(e) : M();
  return (t || t === 0) && (a = Uu(a, +t)), (n || n === 0) && (a = Vu(a, +n)), (r || r === 0) && (a = Fu(a, +r)), No(a, 0);
}, Fe = (e, t) => !e || !t ? !1 : Do(ot(e), ot(t)), Te = (e, t) => !e || !t ? !1 : xu(ot(e), ot(t)), He = (e, t) => !e || !t ? !1 : To(ot(e), ot(t)), ju = (e, t, n) => e && e[0] && e[1] ? He(n, e[0]) && Fe(n, e[1]) : e && e[0] && t ? He(n, e[0]) && Fe(n, t) || Fe(n, e[0]) && He(n, t) : !1, jt = Xt({
  menuFocused: !1,
  shiftKeyInMenu: !1
}), Hu = () => {
  const e = (n) => {
    jt.menuFocused = n;
  }, t = (n) => {
    jt.shiftKeyInMenu !== n && (jt.shiftKeyInMenu = n);
  };
  return {
    control: W(() => ({ shiftKeyInMenu: jt.shiftKeyInMenu, menuFocused: jt.menuFocused })),
    setMenuFocused: e,
    setShiftKey: t
  };
};
function Co(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var xr = {}, pm = {
  get exports() {
    return xr;
  },
  set exports(e) {
    xr = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r) {
    if (r === null || r === !0 || r === !1)
      return NaN;
    var a = Number(r);
    return isNaN(a) ? a : a < 0 ? Math.ceil(a) : Math.floor(a);
  }
  e.exports = t.default;
})(pm, xr);
const ym = /* @__PURE__ */ Co(xr);
var Nr = {}, mm = {
  get exports() {
    return Nr;
  },
  set exports(e) {
    Nr = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r) {
    var a = new Date(Date.UTC(r.getFullYear(), r.getMonth(), r.getDate(), r.getHours(), r.getMinutes(), r.getSeconds(), r.getMilliseconds()));
    return a.setUTCFullYear(r.getFullYear()), r.getTime() - a.getTime();
  }
  e.exports = t.default;
})(mm, Nr);
const tu = /* @__PURE__ */ Co(Nr);
function vm(e, t) {
  var n = _m(t);
  return n.formatToParts ? bm(n, e) : gm(n, e);
}
var hm = {
  year: 0,
  month: 1,
  day: 2,
  hour: 3,
  minute: 4,
  second: 5
};
function bm(e, t) {
  try {
    for (var n = e.formatToParts(t), r = [], a = 0; a < n.length; a++) {
      var o = hm[n[a].type];
      o >= 0 && (r[o] = parseInt(n[a].value, 10));
    }
    return r;
  } catch (i) {
    if (i instanceof RangeError)
      return [NaN];
    throw i;
  }
}
function gm(e, t) {
  var n = e.format(t).replace(/\u200E/g, ""), r = /(\d+)\/(\d+)\/(\d+),? (\d+):(\d+):(\d+)/.exec(n);
  return [r[3], r[1], r[2], r[4], r[5], r[6]];
}
var Gr = {};
function _m(e) {
  if (!Gr[e]) {
    var t = new Intl.DateTimeFormat("en-US", {
      hour12: !1,
      timeZone: "America/New_York",
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    }).format(new Date("2014-06-25T04:00:00.123Z")), n = t === "06/25/2014, 00:00:00" || t === "‎06‎/‎25‎/‎2014‎ ‎00‎:‎00‎:‎00";
    Gr[e] = n ? new Intl.DateTimeFormat("en-US", {
      hour12: !1,
      timeZone: e,
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    }) : new Intl.DateTimeFormat("en-US", {
      hourCycle: "h23",
      timeZone: e,
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    });
  }
  return Gr[e];
}
function Eo(e, t, n, r, a, o, i) {
  var l = new Date(0);
  return l.setUTCFullYear(e, t, n), l.setUTCHours(r, a, o, i), l;
}
var nu = 36e5, wm = 6e4, Qr = {
  timezone: /([Z+-].*)$/,
  timezoneZ: /^(Z)$/,
  timezoneHH: /^([+-]\d{2})$/,
  timezoneHHMM: /^([+-]\d{2}):?(\d{2})$/
};
function Ao(e, t, n) {
  var r, a;
  if (e === "" || (r = Qr.timezoneZ.exec(e), r))
    return 0;
  var o;
  if (r = Qr.timezoneHH.exec(e), r)
    return o = parseInt(r[1], 10), ru(o) ? -(o * nu) : NaN;
  if (r = Qr.timezoneHHMM.exec(e), r) {
    o = parseInt(r[1], 10);
    var i = parseInt(r[2], 10);
    return ru(o, i) ? (a = Math.abs(o) * nu + i * wm, o > 0 ? -a : a) : NaN;
  }
  if (km(e)) {
    t = new Date(t || Date.now());
    var l = n ? t : Om(t), f = bo(l, e), d = n ? f : $m(t, f, e);
    return -d;
  }
  return NaN;
}
function Om(e) {
  return Eo(
    e.getFullYear(),
    e.getMonth(),
    e.getDate(),
    e.getHours(),
    e.getMinutes(),
    e.getSeconds(),
    e.getMilliseconds()
  );
}
function bo(e, t) {
  var n = vm(e, t), r = Eo(
    n[0],
    n[1] - 1,
    n[2],
    n[3] % 24,
    n[4],
    n[5],
    0
  ).getTime(), a = e.getTime(), o = a % 1e3;
  return a -= o >= 0 ? o : 1e3 + o, r - a;
}
function $m(e, t, n) {
  var r = e.getTime(), a = r - t, o = bo(new Date(a), n);
  if (t === o)
    return t;
  a -= o - t;
  var i = bo(new Date(a), n);
  return o === i ? o : Math.max(o, i);
}
function ru(e, t) {
  return -23 <= e && e <= 23 && (t == null || 0 <= t && t <= 59);
}
var au = {};
function km(e) {
  if (au[e])
    return !0;
  try {
    return new Intl.DateTimeFormat(void 0, { timeZone: e }), au[e] = !0, !0;
  } catch {
    return !1;
  }
}
var qu = /(Z|[+-]\d{2}(?::?\d{2})?| UTC| [a-zA-Z]+\/[a-zA-Z_]+(?:\/[a-zA-Z_]+)?)$/, Xr = 36e5, ou = 6e4, Pm = 2, je = {
  dateTimePattern: /^([0-9W+-]+)(T| )(.*)/,
  datePattern: /^([0-9W+-]+)(.*)/,
  plainTime: /:/,
  YY: /^(\d{2})$/,
  YYY: [
    /^([+-]\d{2})$/,
    /^([+-]\d{3})$/,
    /^([+-]\d{4})$/
  ],
  YYYY: /^(\d{4})/,
  YYYYY: [
    /^([+-]\d{4})/,
    /^([+-]\d{5})/,
    /^([+-]\d{6})/
  ],
  MM: /^-(\d{2})$/,
  DDD: /^-?(\d{3})$/,
  MMDD: /^-?(\d{2})-?(\d{2})$/,
  Www: /^-?W(\d{2})$/,
  WwwD: /^-?W(\d{2})-?(\d{1})$/,
  HH: /^(\d{2}([.,]\d*)?)$/,
  HHMM: /^(\d{2}):?(\d{2}([.,]\d*)?)$/,
  HHMMSS: /^(\d{2}):?(\d{2}):?(\d{2}([.,]\d*)?)$/,
  timeZone: qu
};
function go(e, t) {
  if (arguments.length < 1)
    throw new TypeError("1 argument required, but only " + arguments.length + " present");
  if (e === null)
    return new Date(NaN);
  var n = t || {}, r = n.additionalDigits == null ? Pm : ym(n.additionalDigits);
  if (r !== 2 && r !== 1 && r !== 0)
    throw new RangeError("additionalDigits must be 0, 1 or 2");
  if (e instanceof Date || typeof e == "object" && Object.prototype.toString.call(e) === "[object Date]")
    return new Date(e.getTime());
  if (typeof e == "number" || Object.prototype.toString.call(e) === "[object Number]")
    return new Date(e);
  if (!(typeof e == "string" || Object.prototype.toString.call(e) === "[object String]"))
    return new Date(NaN);
  var a = Tm(e), o = Dm(a.date, r), i = o.year, l = o.restDateString, f = Sm(l, i);
  if (isNaN(f))
    return new Date(NaN);
  if (f) {
    var d = f.getTime(), m = 0, p;
    if (a.time && (m = Rm(a.time), isNaN(m)))
      return new Date(NaN);
    if (a.timeZone || n.timeZone) {
      if (p = Ao(a.timeZone || n.timeZone, new Date(d + m)), isNaN(p))
        return new Date(NaN);
    } else
      p = tu(new Date(d + m)), p = tu(new Date(d + m + p));
    return new Date(d + m + p);
  } else
    return new Date(NaN);
}
function Tm(e) {
  var t = {}, n = je.dateTimePattern.exec(e), r;
  if (n ? (t.date = n[1], r = n[3]) : (n = je.datePattern.exec(e), n ? (t.date = n[1], r = n[2]) : (t.date = null, r = e)), r) {
    var a = je.timeZone.exec(r);
    a ? (t.time = r.replace(a[1], ""), t.timeZone = a[1].trim()) : t.time = r;
  }
  return t;
}
function Dm(e, t) {
  var n = je.YYY[t], r = je.YYYYY[t], a;
  if (a = je.YYYY.exec(e) || r.exec(e), a) {
    var o = a[1];
    return {
      year: parseInt(o, 10),
      restDateString: e.slice(o.length)
    };
  }
  if (a = je.YY.exec(e) || n.exec(e), a) {
    var i = a[1];
    return {
      year: parseInt(i, 10) * 100,
      restDateString: e.slice(i.length)
    };
  }
  return {
    year: null
  };
}
function Sm(e, t) {
  if (t === null)
    return null;
  var n, r, a, o;
  if (e.length === 0)
    return r = new Date(0), r.setUTCFullYear(t), r;
  if (n = je.MM.exec(e), n)
    return r = new Date(0), a = parseInt(n[1], 10) - 1, uu(t, a) ? (r.setUTCFullYear(t, a), r) : new Date(NaN);
  if (n = je.DDD.exec(e), n) {
    r = new Date(0);
    var i = parseInt(n[1], 10);
    return Nm(t, i) ? (r.setUTCFullYear(t, 0, i), r) : new Date(NaN);
  }
  if (n = je.MMDD.exec(e), n) {
    r = new Date(0), a = parseInt(n[1], 10) - 1;
    var l = parseInt(n[2], 10);
    return uu(t, a, l) ? (r.setUTCFullYear(t, a, l), r) : new Date(NaN);
  }
  if (n = je.Www.exec(e), n)
    return o = parseInt(n[1], 10) - 1, lu(t, o) ? iu(t, o) : new Date(NaN);
  if (n = je.WwwD.exec(e), n) {
    o = parseInt(n[1], 10) - 1;
    var f = parseInt(n[2], 10) - 1;
    return lu(t, o, f) ? iu(t, o, f) : new Date(NaN);
  }
  return null;
}
function Rm(e) {
  var t, n, r;
  if (t = je.HH.exec(e), t)
    return n = parseFloat(t[1].replace(",", ".")), Kr(n) ? n % 24 * Xr : NaN;
  if (t = je.HHMM.exec(e), t)
    return n = parseInt(t[1], 10), r = parseFloat(t[2].replace(",", ".")), Kr(n, r) ? n % 24 * Xr + r * ou : NaN;
  if (t = je.HHMMSS.exec(e), t) {
    n = parseInt(t[1], 10), r = parseInt(t[2], 10);
    var a = parseFloat(t[3].replace(",", "."));
    return Kr(n, r, a) ? n % 24 * Xr + r * ou + a * 1e3 : NaN;
  }
  return null;
}
function iu(e, t, n) {
  t = t || 0, n = n || 0;
  var r = new Date(0);
  r.setUTCFullYear(e, 0, 4);
  var a = r.getUTCDay() || 7, o = t * 7 + n + 1 - a;
  return r.setUTCDate(r.getUTCDate() + o), r;
}
var Mm = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], xm = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
function Gu(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function uu(e, t, n) {
  if (t < 0 || t > 11)
    return !1;
  if (n != null) {
    if (n < 1)
      return !1;
    var r = Gu(e);
    if (r && n > xm[t] || !r && n > Mm[t])
      return !1;
  }
  return !0;
}
function Nm(e, t) {
  if (t < 1)
    return !1;
  var n = Gu(e);
  return !(n && t > 366 || !n && t > 365);
}
function lu(e, t, n) {
  return !(t < 0 || t > 52 || n != null && (n < 0 || n > 6));
}
function Kr(e, t, n) {
  return !(e != null && (e < 0 || e >= 25) || t != null && (t < 0 || t >= 60) || n != null && (n < 0 || n >= 60));
}
var Cr = {}, Cm = {
  get exports() {
    return Cr;
  },
  set exports(e) {
    Cr = e;
  }
}, Er = {}, Em = {
  get exports() {
    return Er;
  },
  set exports(e) {
    Er = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r, a) {
    if (r == null)
      throw new TypeError("assign requires that input parameter not be null or undefined");
    for (var o in a)
      Object.prototype.hasOwnProperty.call(a, o) && (r[o] = a[o]);
    return r;
  }
  e.exports = t.default;
})(Em, Er);
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = a;
  var n = r(Er);
  function r(o) {
    return o && o.__esModule ? o : { default: o };
  }
  function a(o) {
    return (0, n.default)({}, o);
  }
  e.exports = t.default;
})(Cm, Cr);
const Am = /* @__PURE__ */ Co(Cr);
function Im(e, t, n) {
  var r = go(e, n), a = Ao(t, r, !0), o = new Date(r.getTime() - a), i = new Date(0);
  return i.setFullYear(o.getUTCFullYear(), o.getUTCMonth(), o.getUTCDate()), i.setHours(o.getUTCHours(), o.getUTCMinutes(), o.getUTCSeconds(), o.getUTCMilliseconds()), i;
}
function Bm(e, t, n) {
  if (typeof e == "string" && !e.match(qu)) {
    var r = Am(n);
    return r.timeZone = t, go(e, r);
  }
  var a = go(e, n), o = Eo(
    a.getFullYear(),
    a.getMonth(),
    a.getDate(),
    a.getHours(),
    a.getMinutes(),
    a.getSeconds(),
    a.getMilliseconds()
  ).getTime(), i = Ao(t, new Date(o));
  return new Date(o + i);
}
const Ym = (e, t = 3) => {
  const n = [];
  for (let r = 0; r < e.length; r += t)
    n.push([e[r], e[r + 1], e[r + 2]]);
  return n;
}, Um = (e, t) => {
  const n = [1, 2, 3, 4, 5, 6, 7].map((o) => new Intl.DateTimeFormat(e, { weekday: "short", timeZone: "UTC" }).format(new Date(`2017-01-0${o}T00:00:00+00:00`)).slice(0, 2)), r = n.slice(0, t), a = n.slice(t + 1, n.length);
  return [n[t]].concat(...a).concat(...r);
}, Vm = (e) => {
  const t = [];
  for (let n = +e[0]; n <= +e[1]; n++)
    t.push({ value: +n, text: `${n}` });
  return t;
}, Fm = (e, t) => {
  const n = new Intl.DateTimeFormat(e, { month: t, timeZone: "UTC" });
  return [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12].map((r) => {
    const a = r < 10 ? `0${r}` : r;
    return new Date(`2017-${a}-01T00:00:00+00:00`);
  }).map((r, a) => ({
    text: n.format(r),
    value: a
  }));
}, Lm = (e) => [12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11][e], Ue = (e) => {
  const t = v(e);
  return (t == null ? void 0 : t.$el) ?? t;
}, Wm = (e) => Object.assign({ type: "dot" }, e), Qu = (e) => Array.isArray(e) ? !!e[0] && !!e[1] : !1, Ar = {
  prop: (e) => `"${e}" prop must be enabled!`,
  dateArr: (e) => `You need to use array as "model-value" binding in order to support "${e}"`
}, Ve = (e) => e, su = (e) => e === 0 ? e : !e || isNaN(+e) ? null : +e, fu = (e) => Object.assign(
  {
    menuAppear: "dp-menu-appear",
    open: "dp-slide-down",
    close: "dp-slide-up",
    next: "calendar-next",
    previous: "calendar-prev",
    vNext: "dp-slide-up",
    vPrevious: "dp-slide-down"
  },
  e
), zm = (e) => Object.assign(
  {
    toggleOverlay: "Toggle overlay",
    menu: "Datepicker menu",
    input: "Datepicker input",
    calendarWrap: "Calendar wrapper",
    calendarDays: "Calendar days",
    openTimePicker: "Open time picker",
    closeTimePicker: "Close time Picker",
    incrementValue: (t) => `Increment ${t}`,
    decrementValue: (t) => `Decrement ${t}`,
    openTpOverlay: (t) => `Open ${t} overlay`,
    amPmButton: "Switch AM/PM mode",
    openYearsOverlay: "Open years overlay",
    openMonthsOverlay: "Open months overlay",
    nextMonth: "Next month",
    prevMonth: "Previous month",
    day: () => ""
  },
  e
), jm = (e) => e === null ? 0 : typeof e == "boolean" ? e ? 2 : 0 : +e >= 2 ? +e : 2, Hm = (e, t, n) => e || (typeof n == "string" ? n : t), qm = (e) => typeof e == "boolean" ? e ? fu({}) : !1 : fu(e), Gm = () => ({
  enterSubmit: !0,
  tabSubmit: !0,
  openMenu: !0,
  rangeSeparator: " - "
}), Qm = (e) => Object.assign({ months: [], years: [], times: { hours: [], minutes: [], seconds: [] } }, e), Ke = (e) => {
  const t = () => {
    if (e.partialRange)
      return null;
    throw new Error(Ar.prop("partial-range"));
  }, n = W(() => ({
    ariaLabels: zm(e.ariaLabels),
    textInputOptions: Object.assign(Gm(), e.textInputOptions),
    multiCalendars: jm(e.multiCalendars),
    previewFormat: Hm(e.previewFormat, e.format, o()),
    filters: Qm(e.filters),
    transitions: qm(e.transitions),
    startTime: s()
  })), r = (u) => {
    if (e.range)
      return u();
    throw new Error(Ar.prop("range"));
  }, a = () => {
    const u = e.enableSeconds ? ":ss" : "";
    return e.is24 ? `HH:mm${u}` : `hh:mm${u} aa`;
  }, o = () => e.format ? e.format : e.monthPicker ? "MM/yyyy" : e.timePicker ? a() : e.weekPicker ? "MM/dd/yyyy" : e.yearPicker ? "yyyy" : e.enableTimePicker ? `MM/dd/yyyy, ${a()}` : "MM/dd/yyyy", i = (u, g) => {
    if (typeof e.format == "function")
      return e.format(u);
    const S = g || o(), I = e.formatLocale ? { locale: e.formatLocale } : void 0;
    return Array.isArray(u) ? `${qt(u[0], S, I)} ${e.modelAuto && !u[1] ? "" : n.value.textInputOptions.rangeSeparator || "-"} ${u[1] ? qt(u[1], S, I) : ""}` : qt(u, S, I);
  }, l = (u) => e.timezone ? Im(u, e.timezone) : u, f = (u) => e.timezone ? Bm(u, e.timezone) : u, d = W(() => (u) => {
    var g;
    return (g = e.hideNavigation) == null ? void 0 : g.includes(u);
  }), m = (u) => {
    const g = e.maxDate ? He(l(u), l(M(e.maxDate))) : !1, S = e.minDate ? Fe(l(u), l(M(e.minDate))) : !1, I = ee(u, e.disabledDates), V = n.value.filters.months.map((B) => +B).includes(ke(u)), _ = e.disabledWeekDays.length ? e.disabledWeekDays.some((B) => +B === Ns(u)) : !1, le = e.allowedDates.length ? !e.allowedDates.some((B) => Te(l(M(B)), l(u))) : !1, de = Pe(u), h = de < +e.yearRange[0] || de > +e.yearRange[1];
    return !(g || S || I || V || h || _ || le);
  }, p = (u) => {
    const g = {
      hours: ut(M()),
      minutes: lt(M()),
      seconds: It(M())
    };
    return Object.assign(g, u);
  }, s = () => e.range ? e.startTime && Array.isArray(e.startTime) ? [p(e.startTime[0]), p(e.startTime[1])] : null : e.startTime && !Array.isArray(e.startTime) ? p(e.startTime) : null, w = (u) => !m(u), A = (u) => Array.isArray(u) ? Ht(u[0]) && (u[1] ? Ht(u[1]) : !0) : u ? Ht(u) : !1, U = (u) => u instanceof Date ? u : iy(u), G = (u) => {
    const g = oa(l(u), { weekStartsOn: +e.weekStart }), S = Dl(l(u), { weekStartsOn: +e.weekStart });
    return [g, S];
  }, ee = (u, g) => Array.isArray(g) ? g.some((S) => Te(l(M(S)), l(u))) : g(u), Q = (u, g, S) => {
    let I = u ? M(u) : M();
    return (g || g === 0) && (I = Gt(I, g)), S && (I = Tt(I, S)), I;
  }, C = (u) => ze(M(), { hours: ut(u), minutes: lt(u), seconds: It(u) }), z = (u) => ze(M(), {
    hours: +u.hours || 0,
    minutes: +u.minutes || 0,
    seconds: +u.seconds || 0
  }), te = (u, g, S, I) => {
    if (!u)
      return !0;
    if (I) {
      const V = S === "max" ? Do(u, g) : To(u, g), _ = { seconds: 0, milliseconds: 0 };
      return V || xu(ze(u, _), ze(g, _));
    }
    return S === "max" ? u.getTime() <= g.getTime() : u.getTime() >= g.getTime();
  }, k = () => !e.enableTimePicker || e.monthPicker || e.yearPicker || e.ignoreTimeValidation, $ = (u) => Array.isArray(u) ? [u[0] ? C(u[0]) : null, u[1] ? C(u[1]) : null] : C(u), x = (u) => {
    const g = e.maxTime ? z(e.maxTime) : M(e.maxDate);
    return Array.isArray(u) ? te(u[0], g, "max", !!e.maxDate) && te(u[1], g, "max", !!e.maxDate) : te(u, g, "max", !!e.maxDate);
  }, F = (u, g) => {
    const S = e.minTime ? z(e.minTime) : M(e.minDate);
    return Array.isArray(u) ? te(u[0], S, "min", !!e.minDate) && te(u[1], S, "min", !!e.minDate) && g : te(u, S, "min", !!e.minDate) && g;
  }, H = (u) => {
    let g = !0;
    if (!u || k())
      return !0;
    const S = !e.minDate && !e.maxDate ? $(u) : u;
    return (e.maxTime || e.maxDate) && (g = x(Ve(S))), (e.minTime || e.minDate) && (g = F(Ve(S), g)), g;
  }, Y = (u, g) => {
    const S = M(JSON.parse(JSON.stringify(u))), I = [];
    for (let V = 0; V < 7; V++) {
      const _ = dt(S, V), le = ke(_) !== g;
      I.push({
        text: e.hideOffsetDates && le ? "" : _.getDate(),
        value: _,
        current: !le,
        classData: {}
      });
    }
    return I;
  }, X = (u, g) => {
    const S = [], I = M(l(new Date(g, u))), V = M(l(new Date(g, u + 1, 0))), _ = oa(I, { weekStartsOn: e.weekStart }), le = (de) => {
      const h = Y(de, u);
      if (S.push({ days: h }), !S[S.length - 1].days.some(
        (B) => Te(ot(B.value), ot(V))
      )) {
        const B = dt(de, 7);
        le(B);
      }
    };
    if (le(_), e.sixWeeks && S.length < 6) {
      const de = 6 - S.length;
      for (let h = 1; h <= de; h++) {
        const B = S[S.length - 1], Me = B.days[B.days.length - 1], me = Y(dt(Me.value, 1), ke(I));
        S.push({ days: me });
      }
    }
    return S;
  }, O = (u, g, S) => [ze(M(u), { date: 1 }), ze(M(), { month: g, year: S, date: 1 })], y = (u, g) => Fe(...O(e.minDate, u, g)) || Te(...O(e.minDate, u, g)), P = (u, g) => He(...O(e.maxDate, u, g)) || Te(...O(e.maxDate, u, g)), D = (u, g, S) => {
    let I = !1;
    return e.maxDate && S && P(u, g) && (I = !0), e.minDate && !S && y(u, g) && (I = !0), I;
  };
  return {
    checkPartialRangeValue: t,
    checkRangeEnabled: r,
    getZonedDate: l,
    getZonedToUtc: f,
    formatDate: i,
    getDefaultPattern: o,
    validateDate: m,
    getDefaultStartTime: s,
    isDisabled: w,
    isValidDate: A,
    sanitizeDate: U,
    getWeekFromDate: G,
    matchDate: ee,
    setDateMonthOrYear: Q,
    isValidTime: H,
    getCalendarDays: X,
    validateMonthYearInRange: (u, g, S, I) => {
      let V = !1;
      return I ? e.minDate && e.maxDate ? V = D(u, g, S) : (e.minDate && y(u, g) || e.maxDate && P(u, g)) && (V = !0) : V = !0, V;
    },
    validateMaxDate: P,
    validateMinDate: y,
    defaults: n,
    hideNavigationButtons: d
  };
}, $e = Xt({
  monthYear: [],
  calendar: [],
  time: [],
  actionRow: [],
  selectionGrid: [],
  timePicker: {
    0: [],
    1: []
  },
  monthPicker: []
}), Jr = j(null), rn = j(!1), Zr = j(!1), ea = j(!1), ta = j(!1), We = j(0), Be = j(0), bt = () => {
  const e = W(() => rn.value ? [...$e.selectionGrid, $e.actionRow].filter((p) => p.length) : Zr.value ? [
    ...$e.timePicker[0],
    ...$e.timePicker[1],
    ta.value ? [] : [Jr.value],
    $e.actionRow
  ].filter((p) => p.length) : ea.value ? [...$e.monthPicker, $e.actionRow] : [$e.monthYear, ...$e.calendar, $e.time, $e.actionRow].filter((p) => p.length)), t = (p) => {
    We.value = p ? We.value + 1 : We.value - 1;
    let s = null;
    e.value[Be.value] && (s = e.value[Be.value][We.value]), s || (We.value = p ? We.value - 1 : We.value + 1);
  }, n = (p) => {
    Be.value === 0 && !p || Be.value === e.value.length && p || (Be.value = p ? Be.value + 1 : Be.value - 1, e.value[Be.value] ? e.value[Be.value] && !e.value[Be.value][We.value] && We.value !== 0 && (We.value = e.value[Be.value].length - 1) : Be.value = p ? Be.value - 1 : Be.value + 1);
  }, r = (p) => {
    let s = null;
    e.value[Be.value] && (s = e.value[Be.value][We.value]), s ? s.focus({ preventScroll: !rn.value }) : We.value = p ? We.value - 1 : We.value + 1;
  }, a = () => {
    t(!0), r(!0);
  }, o = () => {
    t(!1), r(!1);
  }, i = () => {
    n(!1), r(!0);
  }, l = () => {
    n(!0), r(!0);
  }, f = (p, s) => {
    $e[s] = p;
  }, d = (p, s) => {
    $e[s] = p;
  }, m = () => {
    We.value = 0, Be.value = 0;
  };
  return {
    buildMatrix: f,
    buildMultiLevelMatrix: d,
    setTimePickerBackRef: (p) => {
      Jr.value = p;
    },
    setSelectionGrid: (p) => {
      rn.value = p, m(), p || ($e.selectionGrid = []);
    },
    setTimePicker: (p, s = !1) => {
      Zr.value = p, ta.value = s, m(), p || ($e.timePicker[0] = [], $e.timePicker[1] = []);
    },
    setTimePickerElements: (p, s = 0) => {
      $e.timePicker[s] = p;
    },
    arrowRight: a,
    arrowLeft: o,
    arrowUp: i,
    arrowDown: l,
    clearArrowNav: () => {
      $e.monthYear = [], $e.calendar = [], $e.time = [], $e.actionRow = [], $e.selectionGrid = [], $e.timePicker[0] = [], $e.timePicker[1] = [], rn.value = !1, Zr.value = !1, ta.value = !1, ea.value = !1, m(), Jr.value = null;
    },
    setMonthPicker: (p) => {
      ea.value = p, m();
    },
    refSets: $e
  };
}, cu = (e) => Array.isArray(e), Ot = (e) => Array.isArray(e), du = (e) => Array.isArray(e) && e.length === 2, Xm = (e, t, n, r, a) => {
  const {
    getDefaultStartTime: o,
    isDisabled: i,
    sanitizeDate: l,
    getWeekFromDate: f,
    setDateMonthOrYear: d,
    validateMonthYearInRange: m,
    defaults: p
  } = Ke(e), s = W({
    get: () => e.internalModelValue,
    set: (c) => {
      !e.readonly && !e.disabled && t("update:internal-model-value", c);
    }
  }), w = j([]), A = j([{ month: ke(M()), year: Pe(M()) }]), U = Xt({
    hours: e.range ? [ut(M()), ut(M())] : ut(M()),
    minutes: e.range ? [lt(M()), lt(M())] : lt(M()),
    seconds: e.range ? [0, 0] : 0
  }), G = W(
    () => (c) => A.value[c] ? A.value[c].month : 0
  ), ee = W(
    () => (c) => A.value[c] ? A.value[c].year : 0
  ), Q = W(() => e.flow ? a.value === e.flow.length : !0), C = (c, N, Z) => {
    A.value[c].month = N === null ? A.value[c].month : N, A.value[c].year = Z === null ? A.value[c].year : Z;
  }, z = (c, N) => {
    U[c] = N;
  };
  et(() => {
    s.value || (e.startDate && (C(0, ke(M(e.startDate)), Pe(M(e.startDate))), p.value.multiCalendars && Ut(0)), p.value.startTime && P()), te(!0);
  });
  const te = (c = !1) => {
    if (s.value)
      return Array.isArray(s.value) ? H(c) : $(s.value);
    if (e.timePicker)
      return Y();
    if (e.monthPicker && !e.range)
      return X();
    if (e.yearPicker && !e.range)
      return O();
    if (p.value.multiCalendars)
      return k(M(), c);
  }, k = (c, N = !1) => {
    if ((!p.value.multiCalendars || !e.multiStatic || N) && C(0, ke(c), Pe(c)), p.value.multiCalendars)
      for (let Z = 1; Z < p.value.multiCalendars; Z++) {
        const fe = ze(M(), { month: G.value(Z - 1), year: ee.value(Z - 1) }), Se = _u(fe, { months: 1 });
        A.value[Z] = { month: ke(Se), year: Pe(Se) };
      }
  }, $ = (c) => {
    k(c), z("hours", ut(c)), z("minutes", lt(c)), z("seconds", It(c));
  }, x = (c, N) => {
    k(c[0], N);
    const Z = (fe, Se) => [
      fe(c[0]),
      c[1] ? fe(c[1]) : U[Se][1]
    ];
    z("hours", Z(ut, "hours")), z("minutes", Z(lt, "minutes")), z("seconds", Z(It, "seconds"));
  }, F = (c, N) => {
    if (e.range && !e.multiDates)
      return x(c, N);
    if (e.multiDates) {
      const Z = c[c.length - 1];
      return $(Z);
    }
  }, H = (c) => {
    const N = s.value;
    F(N, c), p.value.multiCalendars && e.multiCalendarsSolo && u();
  }, Y = () => {
    if (P(), !e.range)
      s.value = Je(M(), U.hours, U.minutes, y());
    else {
      const c = U.hours, N = U.minutes;
      s.value = [
        Je(M(), c[0], N[0], y()),
        Je(M(), c[1], N[1], y(!1))
      ];
    }
  }, X = () => {
    s.value = d(M(), G.value(0), ee.value(0));
  }, O = () => {
    s.value = M();
  }, y = (c = !0) => e.enableSeconds ? Array.isArray(U.seconds) ? c ? U.seconds[0] : U.seconds[1] : U.seconds : 0, P = () => {
    const c = o();
    if (c) {
      const N = Array.isArray(c), Z = N ? [+c[0].hours, +c[1].hours] : +c.hours, fe = N ? [+c[0].minutes, +c[1].minutes] : +c.minutes, Se = N ? [+c[0].seconds, +c[1].seconds] : +c.seconds;
      z("hours", Z), z("minutes", fe), e.enableSeconds && z("seconds", Se);
    }
  }, D = () => Array.isArray(s.value) && s.value.length ? s.value[s.value.length - 1] : null, u = () => {
    if (Array.isArray(s.value) && s.value.length === 2) {
      const c = M(
        M(s.value[1] ? s.value[1] : at(s.value[0], 1))
      ), [N, Z] = [ke(s.value[0]), Pe(s.value[0])], [fe, Se] = [ke(s.value[1]), Pe(s.value[1])];
      (N !== fe || N === fe && Z !== Se) && e.multiCalendarsSolo && C(1, ke(c), Pe(c));
    }
  }, g = (c) => {
    const N = at(c, 1);
    return { month: ke(N), year: Pe(N) };
  }, S = (c) => {
    const N = ke(M(c)), Z = Pe(M(c));
    if (C(0, N, Z), p.value.multiCalendars > 0)
      for (let fe = 1; fe < p.value.multiCalendars; fe++) {
        const Se = g(
          ze(M(c), { year: G.value(fe - 1), month: ee.value(fe - 1) })
        );
        C(fe, Se.month, Se.year);
      }
  }, I = (c) => {
    if (s.value && Array.isArray(s.value))
      if (s.value.some((N) => Te(c, N))) {
        const N = s.value.filter((Z) => !Te(Z, c));
        s.value = N.length ? N : null;
      } else
        (e.multiDatesLimit && +e.multiDatesLimit > s.value.length || !e.multiDatesLimit) && s.value.push(c);
    else
      s.value = [c];
  }, V = (c, N) => {
    const Z = He(c, N) ? N : c, fe = He(N, c) ? N : c;
    return Yo({ start: Z, end: fe });
  }, _ = (c) => {
    if (Array.isArray(s.value) && s.value[0]) {
      const N = Pl(c, s.value[0]), Z = V(s.value[0], c), fe = Z.length === 1 ? 0 : Z.filter((tt) => i(tt)).length, Se = Math.abs(N) - fe;
      if (e.minRange && e.maxRange)
        return Se >= +e.minRange && Se <= +e.maxRange;
      if (e.minRange)
        return Se >= +e.minRange;
      if (e.maxRange)
        return Se <= +e.maxRange;
    }
    return !0;
  }, le = (c) => Array.isArray(s.value) && s.value.length === 2 ? e.fixedStart && (He(c, s.value[0]) || Te(c, s.value[0])) ? [s.value[0], c] : e.fixedEnd && (Fe(c, s.value[1]) || Te(c, s.value[1])) ? [c, s.value[1]] : s.value : [], de = () => {
    e.autoApply && Q.value && t("auto-apply");
  }, h = () => {
    e.autoApply && t("select-date");
  }, B = (c) => !Yo({ start: c[0], end: c[1] }).some((N) => i(N)), Me = (c) => (s.value = f(M(c.value)), de()), me = (c) => {
    const N = Je(M(c.value), U.hours, U.minutes, y());
    e.multiDates ? I(N) : s.value = N, n(), de();
  }, ue = () => {
    w.value = s.value ? s.value.slice() : [], w.value.length === 2 && !(e.fixedStart || e.fixedEnd) && (w.value = []);
  }, De = (c, N) => {
    const Z = [M(c.value), dt(M(c.value), +e.autoRange)];
    B(Z) && (N && S(c.value), w.value = Z);
  }, Qe = (c) => {
    w.value = le(M(c.value));
  }, se = (c) => e.noDisabledRange ? V(w.value[0], c).some((N) => i(N)) : !1, ce = (c, N) => {
    if (ue(), e.autoRange)
      return De(c, N);
    if (e.fixedStart || e.fixedEnd)
      return Qe(c);
    w.value[0] ? _(M(c.value)) && !se(c.value) && (Fe(M(c.value), M(w.value[0])) ? w.value.unshift(M(c.value)) : w.value[1] = M(c.value)) : w.value[0] = M(c.value);
  }, Oe = (c) => {
    w.value[c] = Je(
      w.value[c],
      U.hours[c],
      U.minutes[c],
      y(c !== 1)
    );
  }, be = () => {
    w.value.length && (w.value[0] && !w.value[1] ? Oe(0) : (Oe(0), Oe(1), n()), s.value = w.value.slice(), w.value[0] && w.value[1] && e.autoApply && t("auto-apply"), w.value[0] && !w.value[1] && e.modelAuto && e.autoApply && t("auto-apply"));
  }, Yt = (c, N = !1) => {
    if (!(i(c.value) || !c.current && e.hideOffsetDates)) {
      if (e.weekPicker)
        return Me(c);
      if (!e.range)
        return me(c);
      Ot(U.hours) && Ot(U.minutes) && !e.multiDates && (ce(c, N), be());
    }
  }, it = (c) => {
    const N = c.find((Z) => Z.current);
    return N ? As(N.value) : "";
  }, Ut = (c) => {
    for (let N = c - 1; N >= 0; N--) {
      const Z = Et(ze(M(), { month: G.value(N + 1), year: ee.value(N + 1) }), 1);
      C(N, ke(Z), Pe(Z));
    }
    for (let N = c + 1; N <= p.value.multiCalendars - 1; N++) {
      const Z = at(ze(M(), { month: G.value(N - 1), year: ee.value(N - 1) }), 1);
      C(N, ke(Z), Pe(Z));
    }
  }, _t = (c) => d(M(), G.value(c), ee.value(c)), Vt = (c) => Je(c, U.hours, U.minutes, y()), Yr = (c, N) => {
    const Z = e.monthPicker ? G.value(c) !== N.month || !N.fromNav : ee.value(c) !== N.year;
    if (C(c, N.month, N.year), p.value.multiCalendars && !e.multiCalendarsSolo && Ut(c), e.monthPicker || e.yearPicker)
      if (e.range) {
        if (Z) {
          let fe = s.value ? s.value.slice() : [];
          fe.length === 2 && fe[1] !== null && (fe = []), fe.length ? Fe(_t(c), fe[0]) ? fe.unshift(_t(c)) : fe[1] = _t(c) : fe = [_t(c)], s.value = fe;
        }
      } else
        s.value = _t(c);
    t("update-month-year", { instance: c, month: N.month, year: N.year }), r(e.multiCalendarsSolo ? c : void 0);
  }, Ur = async (c = !1) => {
    if (e.autoApply && (e.monthPicker || e.yearPicker)) {
      await Jt();
      const N = e.monthPicker ? c : !1;
      e.range ? t("auto-apply", N || !s.value || s.value.length === 1) : t("auto-apply", N);
    }
    n();
  }, Zt = (c, N) => {
    const Z = ze(M(), { month: G.value(N), year: ee.value(N) }), fe = c < 0 ? at(Z, 1) : Et(Z, 1);
    m(ke(fe), Pe(fe), c < 0, e.preventMinMaxNavigation) && (C(N, ke(fe), Pe(fe)), p.value.multiCalendars && !e.multiCalendarsSolo && Ut(N), r());
  }, Ft = (c) => {
    cu(c) && cu(s.value) && Ot(U.hours) && Ot(U.minutes) ? (c[0] && s.value[0] && (s.value[0] = Je(c[0], U.hours[0], U.minutes[0], y())), c[1] && s.value[1] && (s.value[1] = Je(c[1], U.hours[1], U.minutes[1], y(!1)))) : e.multiDates && Array.isArray(s.value) ? s.value[s.value.length - 1] = Vt(c) : !e.range && !du(c) && (s.value = Vt(c)), t("time-update");
  }, Vr = (c, N = !0, Z = !1) => {
    const fe = N ? c : U.hours, Se = !N && !Z ? c : U.minutes, tt = Z ? c : U.seconds;
    if (e.range && du(s.value) && Ot(fe) && Ot(Se) && Ot(tt) && !e.disableTimeRangeValidation) {
      const wt = (K) => Je(s.value[K], fe[K], Se[K], tt[K]), T = (K) => No(s.value[K], 0);
      if (Te(s.value[0], s.value[1]) && (To(wt(0), T(1)) || Do(wt(1), T(0))))
        return;
    }
    if (z("hours", fe), z("minutes", Se), z("seconds", tt), s.value)
      if (e.multiDates) {
        const wt = D();
        wt && Ft(wt);
      } else
        Ft(s.value);
    else
      e.timePicker && Ft(e.range ? [M(), M()] : M());
    n();
  }, Fr = (c, N) => {
    e.monthChangeOnScroll && Zt(e.monthChangeOnScroll !== "inverse" ? -c.deltaY : c.deltaY, N);
  }, Lr = (c, N, Z = !1) => {
    e.monthChangeOnArrows && e.vertical === Z && en(c, N);
  }, en = (c, N) => {
    Zt(c === "right" ? -1 : 1, N);
  };
  return {
    time: U,
    month: G,
    year: ee,
    modelValue: s,
    calendars: A,
    monthYearSelect: Ur,
    isDisabled: i,
    updateTime: Vr,
    getWeekNum: it,
    selectDate: Yt,
    updateMonthYear: Yr,
    handleScroll: Fr,
    getMarker: (c) => e.markers.find((N) => Te(l(c.value), l(N.date))),
    handleArrow: Lr,
    handleSwipe: en,
    selectCurrentDate: () => {
      e.range ? s.value && Array.isArray(s.value) && s.value[0] ? s.value = Fe(M(), s.value[0]) ? [M(), s.value[0]] : [s.value[0], M()] : s.value = [M()] : s.value = M(), h();
    },
    presetDateRange: (c, N) => {
      N || c.length && c.length <= 2 && e.range && (s.value = c.map((Z) => M(Z)), h());
    }
  };
}, Km = (e, t, n) => {
  const r = j(), {
    getZonedToUtc: a,
    getZonedDate: o,
    formatDate: i,
    getDefaultPattern: l,
    checkRangeEnabled: f,
    checkPartialRangeValue: d,
    isValidDate: m,
    setDateMonthOrYear: p,
    defaults: s
  } = Ke(t), w = j("");
  Kt(r, () => {
    e("internal-model-change", r.value);
  });
  const A = (_) => {
    const le = _ || M();
    return {
      hours: ut(le),
      minutes: lt(le),
      seconds: t.enableSeconds ? It(le) : 0
    };
  }, U = (_) => ({ month: ke(_), year: Pe(_) }), G = (_) => Array.isArray(_) ? f(() => [
    Tt(M(), _[0]),
    _[1] ? Tt(M(), _[1]) : d()
  ]) : Tt(M(), +_), ee = (_) => Array.isArray(_) ? [
    Je(null, +_[0].hours, +_[0].minutes, _[0].seconds),
    Je(null, +_[1].hours, +_[1].minutes, _[1].seconds)
  ] : Je(null, _.hours, _.minutes, _ == null ? void 0 : _.seconds), Q = (_) => Array.isArray(_) ? f(() => [
    p(null, +_[0].month, +_[0].year),
    _[1] ? p(null, +_[1].month, +_[1].year) : d()
  ]) : p(null, +_.month, +_.year), C = (_) => {
    if (Array.isArray(_))
      return _.map((le) => u(le));
    throw new Error(Ar.dateArr("multi-dates"));
  }, z = (_) => {
    if (Array.isArray(_))
      return [M(_[0]), M(_[1])];
    throw new Error(Ar.dateArr("week-picker"));
  }, te = (_) => t.modelAuto ? Array.isArray(_) ? [u(_[0]), u(_[1])] : t.autoApply ? [u(_)] : [u(_), null] : Array.isArray(_) ? f(() => [
    u(_[0]),
    _[1] ? u(_[1]) : d()
  ]) : u(_), k = () => {
    Array.isArray(r.value) && t.range && r.value.length === 1 && r.value.push(d());
  }, $ = () => {
    const _ = r.value;
    return [
      g(_[0]),
      _[1] ? g(_[1]) : d()
    ];
  }, x = () => r.value[1] ? $() : g(Ve(r.value[0])), F = () => (r.value || []).map((_) => g(_)), H = () => (k(), t.modelAuto ? x() : t.multiDates ? F() : Array.isArray(r.value) ? f(() => $()) : g(Ve(r.value))), Y = (_) => _ ? t.timePicker ? ee(Ve(_)) : t.monthPicker ? Q(Ve(_)) : t.yearPicker ? G(Ve(_)) : t.multiDates ? C(Ve(_)) : t.weekPicker ? z(Ve(_)) : te(Ve(_)) : null, X = (_) => {
    const le = Y(_);
    m(Ve(le)) ? (r.value = Ve(le), D()) : (r.value = null, w.value = "");
  }, O = () => {
    var _;
    const le = (de) => {
      var h;
      return qt(de, (h = s.value.textInputOptions) == null ? void 0 : h.format);
    };
    return `${le(r.value[0])} ${(_ = s.value.textInputOptions) == null ? void 0 : _.rangeSeparator} ${r.value[1] ? le(r.value[1]) : ""}`;
  }, y = () => {
    var _;
    return n.value && r.value ? Array.isArray(r.value) ? O() : qt(r.value, (_ = s.value.textInputOptions) == null ? void 0 : _.format) : i(r.value);
  }, P = () => {
    var _;
    return r.value ? t.multiDates ? r.value.map((le) => i(le)).join("; ") : t.textInput && typeof ((_ = s.value.textInputOptions) == null ? void 0 : _.format) == "string" ? y() : i(r.value) : "";
  }, D = () => {
    !t.format || typeof t.format == "string" ? w.value = P() : w.value = t.format(r.value);
  }, u = (_) => {
    if (t.utc) {
      const le = new Date(_);
      return t.utc === "preserve" ? new Date(le.getTime() + le.getTimezoneOffset() * 6e4) : le;
    }
    return t.modelType ? t.modelType === "date" || t.modelType === "timestamp" ? o(new Date(_)) : t.modelType === "format" && (typeof t.format == "string" || !t.format) ? ho(_, l(), new Date()) : o(ho(_, t.modelType, new Date())) : o(new Date(_));
  }, g = (_) => t.utc ? dm(_, t.utc === "preserve") : t.modelType ? t.modelType === "timestamp" ? +a(_) : t.modelType === "format" && (typeof t.format == "string" || !t.format) ? i(a(_)) : i(a(_), t.modelType) : a(_), S = (_) => {
    e("update:model-value", _);
  }, I = (_) => Array.isArray(r.value) ? [
    _(r.value[0]),
    r.value[1] ? _(r.value[1]) : d()
  ] : _(Ve(r.value)), V = (_) => S(Ve(I(_)));
  return {
    inputValue: w,
    internalModelValue: r,
    checkBeforeEmit: () => r.value ? t.range ? t.partialRange ? r.value.length >= 1 : r.value.length === 2 : !!r.value : !1,
    parseExternalModelValue: X,
    formatInputValue: D,
    emitModelValue: () => (D(), t.monthPicker ? V(U) : t.timePicker ? V(A) : t.yearPicker ? V(Pe) : t.weekPicker ? S(r.value) : S(H()))
  };
}, Jm = (e, t) => {
  const { validateMonthYearInRange: n, validateMaxDate: r, validateMinDate: a, defaults: o } = Ke(e), i = (p, s) => {
    let w = p;
    return o.value.filters.months.includes(ke(w)) ? (w = s ? at(p, 1) : Et(p, 1), i(w, s)) : w;
  }, l = (p, s) => {
    let w = p;
    return o.value.filters.years.includes(Pe(w)) ? (w = s ? wu(p, 1) : $y(p, 1), l(w, s)) : w;
  }, f = (p) => {
    const s = ze(new Date(), { month: e.month, year: e.year });
    let w = p ? at(s, 1) : Et(s, 1), A = ke(w), U = Pe(w);
    o.value.filters.months.includes(A) && (w = i(w, p), A = ke(w), U = Pe(w)), o.value.filters.years.includes(U) && (w = l(w, p), U = Pe(w)), n(A, U, p, e.preventMinMaxNavigation) && d(A, U);
  }, d = (p, s) => {
    t("update-month-year", { month: p, year: s });
  }, m = W(() => (p) => {
    if (!e.preventMinMaxNavigation || p && !e.maxDate || !p && !e.minDate)
      return !1;
    const s = ze(new Date(), { month: e.month, year: e.year }), w = p ? at(s, 1) : Et(s, 1), A = [ke(w), Pe(w)];
    return p ? !r(...A) : !a(...A);
  });
  return { handleMonthYearChange: f, isDisabled: m, updateMonthYear: d };
};
var Gn = /* @__PURE__ */ ((e) => (e.center = "center", e.left = "left", e.right = "right", e))(Gn || {});
const Zm = (e, t, n, r) => {
  const a = j({
    top: "0",
    left: "0",
    transform: "none"
  }), o = j(!1), i = aa(r, "teleportCenter");
  Kt(i, () => {
    G();
  });
  const l = ($) => {
    const x = $.getBoundingClientRect();
    return {
      left: x.left + window.scrollX,
      top: x.top + window.scrollY
    };
  }, f = ($) => {
    const x = $.getBoundingClientRect();
    let F = 0, H = 0;
    for (; $ && !isNaN($.offsetLeft) && !isNaN($.offsetTop); )
      F += $.offsetLeft - $.scrollLeft, H = x.top + $.scrollTop, $ = $.offsetParent;
    return { top: H, left: F };
  }, d = ($, x) => {
    a.value.left = `${$ + x}px`, a.value.transform = "translateX(-100%)";
  }, m = ($) => {
    a.value.left = `${$}px`, a.value.transform = "translateX(0)";
  }, p = ($, x, F = !1) => {
    r.position === Gn.left && m($), r.position === Gn.right && d($, x), r.position === Gn.center && (a.value.left = `${$ + x / 2}px`, a.value.transform = F ? "translate(-50%, -50%)" : "translateX(-50%)");
  }, s = ($) => {
    const { width: x, height: F } = $.getBoundingClientRect(), { top: H, left: Y } = r.altPosition ? f($) : l($);
    return { top: H, left: Y, width: x, height: F };
  }, w = () => {
    const $ = Ue(t);
    if ($) {
      const { top: x, left: F, width: H, height: Y } = s($);
      a.value.top = `${x + Y / 2}px`, a.value.transform = "translateY(-50%)", p(F, H, !0);
    }
  }, A = () => {
    a.value.left = "50%", a.value.top = "50%", a.value.transform = "translate(-50%, -50%)", a.value.position = "fixed";
  }, U = () => {
    const $ = Ue(t);
    a.value = r.altPosition($);
  }, G = ($ = !0) => {
    if (!r.inline)
      return i.value ? A() : r.altPosition && typeof r.altPosition != "boolean" ? U() : ($ && n("recalculate-position"), k());
  }, ee = ({
    inputEl: $,
    menuEl: x,
    left: F,
    width: H
  }) => {
    window.screen.width > 768 && p(F, H), z($, x);
  }, Q = ($, x) => {
    const { top: F, left: H, height: Y, width: X } = s($);
    a.value.top = `${Y + F + +r.offset}px`, ee({ inputEl: $, menuEl: x, left: H, width: X }), o.value = !1;
  }, C = ($, x) => {
    const { top: F, left: H, width: Y } = s($), { height: X } = x.getBoundingClientRect();
    a.value.top = `${F - X - +r.offset}px`, ee({ inputEl: $, menuEl: x, left: H, width: Y }), o.value = !0;
  }, z = ($, x) => {
    if (r.autoPosition) {
      const { left: F, width: H } = s($), { left: Y, right: X } = x.getBoundingClientRect();
      if (Y < 0)
        return m(F);
      if (X > document.documentElement.clientWidth)
        return d(F, H);
    }
  }, te = ($, x) => {
    const { height: F } = x.getBoundingClientRect(), { top: H, height: Y } = $.getBoundingClientRect(), X = window.innerHeight - H - Y, O = H;
    return F <= X ? Q($, x) : F > X && F <= O ? C($, x) : X >= O ? Q($, x) : C($, x);
  }, k = () => {
    const $ = Ue(t), x = Ue(e);
    if ($ && x)
      return r.autoPosition ? te($, x) : Q($, x);
  };
  return { openOnTop: o, menuPosition: a, setMenuPosition: G, setInitialPosition: w };
}, Nt = [
  { name: "clock-icon", use: ["time", "calendar"] },
  { name: "arrow-left", use: ["month-year", "calendar"] },
  { name: "arrow-right", use: ["month-year", "calendar"] },
  { name: "arrow-up", use: ["time", "calendar"] },
  { name: "arrow-down", use: ["time", "calendar"] },
  { name: "calendar-icon", use: ["month-year", "time", "calendar"] },
  { name: "day", use: ["calendar"] },
  { name: "month-overlay-value", use: ["calendar", "month-year"] },
  { name: "year-overlay-value", use: ["calendar", "month-year"] },
  { name: "year-overlay", use: ["month-year"] },
  { name: "month-overlay", use: ["month-year"] },
  { name: "month-overlay-header", use: ["month-year"] },
  { name: "year-overlay-header", use: ["month-year"] },
  { name: "hours-overlay-value", use: ["calendar", "time"] },
  { name: "minutes-overlay-value", use: ["calendar", "time"] },
  { name: "seconds-overlay-value", use: ["calendar", "time"] },
  { name: "hours", use: ["calendar", "time"] },
  { name: "minutes", use: ["calendar", "time"] },
  { name: "month", use: ["calendar", "month-year"] },
  { name: "year", use: ["calendar", "month-year"] },
  { name: "action-select", use: ["action"] },
  { name: "action-preview", use: ["action"] },
  { name: "calendar-header", use: ["calendar"] },
  { name: "marker-tooltip", use: ["calendar"] },
  { name: "now-button", use: [] },
  { name: "time-picker-overlay", use: ["calendar", "time"] },
  { name: "am-pm-button", use: ["calendar", "time"] },
  { name: "left-sidebar", use: ["menu"] },
  { name: "right-sidebar", use: ["menu"] },
  { name: "month-year", use: ["month-year"] },
  { name: "time-picker", use: ["menu"] },
  { name: "action-row", use: ["action"] }
], ev = [{ name: "trigger" }, { name: "input-icon" }, { name: "clear-icon" }, { name: "dp-input" }], tv = {
  all: () => Nt,
  monthYear: () => Nt.filter((e) => e.use.includes("month-year")),
  input: () => ev,
  timePicker: () => Nt.filter((e) => e.use.includes("time")),
  action: () => Nt.filter((e) => e.use.includes("action")),
  calendar: () => Nt.filter((e) => e.use.includes("calendar")),
  menu: () => Nt.filter((e) => e.use.includes("menu"))
}, Pt = (e, t, n) => {
  const r = [];
  return tv[t]().forEach((a) => {
    e[a.name] && r.push(a.name);
  }), n && n.length && n.forEach((a) => {
    a.slot && r.push(a.slot);
  }), r;
}, Br = (e) => ({ transitionName: W(() => (t) => e && typeof e != "boolean" ? t ? e.open : e.close : ""), showTransition: !!e }), gt = {
  multiCalendars: { type: [Boolean, Number, String], default: null },
  modelValue: { type: [String, Date, Array, Object, Number], default: null },
  modelType: { type: String, default: null },
  position: { type: String, default: "center" },
  dark: { type: Boolean, default: !1 },
  format: {
    type: [String, Function],
    default: () => null
  },
  closeOnScroll: { type: Boolean, default: !1 },
  autoPosition: { type: Boolean, default: !0 },
  closeOnAutoApply: { type: Boolean, default: !0 },
  teleport: { type: [String, Object], default: "body" },
  altPosition: { type: [Boolean, Function], default: !1 },
  transitions: { type: [Boolean, Object], default: !0 },
  formatLocale: { type: Object, default: null },
  utc: { type: [Boolean, String], default: !1 },
  ariaLabels: { type: Object, default: () => ({}) },
  offset: { type: [Number, String], default: 10 },
  hideNavigation: { type: Array, default: () => [] },
  timezone: { type: String, default: null },
  vertical: { type: Boolean, default: !1 },
  disableMonthYearSelect: { type: Boolean, default: !1 },
  menuClassName: { type: String, default: null },
  dayClass: { type: Function, default: null },
  yearRange: { type: Array, default: () => [1900, 2100] },
  multiCalendarsSolo: { type: Boolean, default: !1 },
  calendarCellClassName: { type: String, default: null },
  enableTimePicker: { type: Boolean, default: !0 },
  autoApply: { type: Boolean, default: !1 },
  disabledDates: { type: [Array, Function], default: () => [] },
  monthNameFormat: { type: String, default: "short" },
  startDate: { type: [Date, String], default: null },
  startTime: { type: [Object, Array], default: null },
  monthYearComponent: { type: Object, default: null },
  timePickerComponent: { type: Object, default: null },
  actionRowComponent: { type: Object, default: null },
  hideOffsetDates: { type: Boolean, default: !1 },
  autoRange: { type: [Number, String], default: null },
  noToday: { type: Boolean, default: !1 },
  disabledWeekDays: { type: Array, default: () => [] },
  allowedDates: { type: Array, default: () => [] },
  showNowButton: { type: Boolean, default: !1 },
  nowButtonLabel: { type: String, default: "Now" },
  markers: { type: Array, default: () => [] },
  modeHeight: { type: [Number, String], default: 255 },
  escClose: { type: Boolean, default: !0 },
  spaceConfirm: { type: Boolean, default: !0 },
  monthChangeOnArrows: { type: Boolean, default: !0 },
  presetRanges: { type: Array, default: () => [] },
  flow: { type: Array, default: () => [] },
  preventMinMaxNavigation: { type: Boolean, default: !1 },
  minRange: { type: [Number, String], default: null },
  maxRange: { type: [Number, String], default: null },
  multiDatesLimit: { type: [Number, String], default: null },
  reverseYears: { type: Boolean, default: !1 },
  keepActionRow: { type: Boolean, default: !1 },
  weekPicker: { type: Boolean, default: !1 },
  filters: { type: Object, default: () => ({}) },
  arrowNavigation: { type: Boolean, default: !1 },
  multiStatic: { type: Boolean, default: !0 },
  disableTimeRangeValidation: { type: Boolean, default: !1 },
  highlight: {
    type: [Array, Function],
    default: null
  },
  highlightWeekDays: {
    type: Array,
    default: null
  },
  highlightDisabledDays: { type: Boolean, default: !1 },
  teleportCenter: { type: Boolean, default: !1 },
  locale: { type: String, default: "en-Us" },
  weekNumName: { type: String, default: "W" },
  weekStart: { type: [Number, String], default: 1 },
  weekNumbers: { type: Boolean, default: !1 },
  calendarClassName: { type: String, default: null },
  noSwipe: { type: Boolean, default: !1 },
  monthChangeOnScroll: { type: [Boolean, String], default: !0 },
  dayNames: {
    type: [Function, Array],
    default: null
  },
  monthPicker: { type: Boolean, default: !1 },
  customProps: { type: Object, default: null },
  yearPicker: { type: Boolean, default: !1 },
  modelAuto: { type: Boolean, default: !1 },
  selectText: { type: String, default: "Select" },
  cancelText: { type: String, default: "Cancel" },
  previewFormat: {
    type: [String, Function],
    default: () => ""
  },
  multiDates: { type: Boolean, default: !1 },
  partialRange: { type: Boolean, default: !0 },
  ignoreTimeValidation: { type: Boolean, default: !1 },
  minDate: { type: [Date, String], default: null },
  maxDate: { type: [Date, String], default: null },
  minTime: { type: Object, default: null },
  maxTime: { type: Object, default: null },
  name: { type: String, default: null },
  placeholder: { type: String, default: "" },
  hideInputIcon: { type: Boolean, default: !1 },
  clearable: { type: Boolean, default: !0 },
  state: { type: Boolean, default: null },
  required: { type: Boolean, default: !1 },
  autocomplete: { type: String, default: "off" },
  inputClassName: { type: String, default: null },
  inlineWithInput: { type: Boolean, default: !1 },
  textInputOptions: { type: Object, default: () => null },
  fixedStart: { type: Boolean, default: !1 },
  fixedEnd: { type: Boolean, default: !1 },
  timePicker: { type: Boolean, default: !1 },
  enableSeconds: { type: Boolean, default: !1 },
  is24: { type: Boolean, default: !0 },
  noHoursOverlay: { type: Boolean, default: !1 },
  noMinutesOverlay: { type: Boolean, default: !1 },
  noSecondsOverlay: { type: Boolean, default: !1 },
  hoursGridIncrement: { type: [String, Number], default: 1 },
  minutesGridIncrement: { type: [String, Number], default: 5 },
  secondsGridIncrement: { type: [String, Number], default: 5 },
  hoursIncrement: { type: [Number, String], default: 1 },
  minutesIncrement: { type: [Number, String], default: 1 },
  secondsIncrement: { type: [Number, String], default: 1 },
  range: { type: Boolean, default: !1 },
  uid: { type: String, default: null },
  disabled: { type: Boolean, default: !1 },
  readonly: { type: Boolean, default: !1 },
  inline: { type: Boolean, default: !1 },
  textInput: { type: Boolean, default: !1 },
  onClickOutside: { type: Function, default: null },
  noDisabledRange: { type: Boolean, default: !1 },
  sixWeeks: { type: Boolean, default: !1 }
}, nv = ["aria-label", "aria-disabled", "aria-readonly"], rv = {
  key: 1,
  class: "dp__input_wrap"
}, av = ["id", "name", "inputmode", "placeholder", "disabled", "readonly", "required", "value", "autocomplete", "onKeydown"], ov = {
  key: 2,
  class: "dp__input_icon"
}, iv = {
  key: 4,
  class: "dp__clear_icon"
}, uv = /* @__PURE__ */ Ze({
  __name: "DatepickerInput",
  props: {
    isMenuOpen: { type: Boolean, default: !1 },
    inputValue: { type: String, default: "" },
    ...gt
  },
  emits: [
    "clear",
    "open",
    "update:input-value",
    "set-input-date",
    "close",
    "select-date",
    "set-empty-date",
    "toggle",
    "focus-prev",
    "focus",
    "blur"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { getDefaultPattern: a, isValidDate: o, defaults: i } = Ke(r), l = j(), f = j(null), d = j(!1), m = W(
      () => ({
        dp__pointer: !r.disabled && !r.readonly && !r.textInput,
        dp__disabled: r.disabled,
        dp__input_readonly: !r.textInput,
        dp__input: !0,
        dp__input_icon_pad: !r.hideInputIcon,
        dp__input_valid: r.state,
        dp__input_invalid: r.state === !1,
        dp__input_focus: d.value || r.isMenuOpen,
        dp__input_reg: !r.textInput,
        [r.inputClassName]: !!r.inputClassName
      })
    ), p = () => {
      n("set-input-date", null), r.autoApply && (n("set-empty-date"), l.value = null);
    }, s = (k) => {
      var $;
      return cm(k, (($ = i.value.textInputOptions) == null ? void 0 : $.format) || a());
    }, w = (k) => {
      const { rangeSeparator: $ } = i.value.textInputOptions;
      if (r.range) {
        const [x, F] = k.split(`${$}`);
        if (x && F) {
          const H = s(x.trim()), Y = s(F.trim());
          l.value = H && Y ? [H, Y] : null;
        }
      } else if (r.multiDates) {
        const x = k.split(";");
        l.value = x.map((F) => s(F.trim())).filter((F) => F);
      } else
        l.value = s(k);
    }, A = (k) => {
      var $;
      const { value: x } = k.target;
      x !== "" ? (($ = i.value.textInputOptions) != null && $.openMenu && !r.isMenuOpen && n("open"), w(x), n("set-input-date", l.value)) : p(), n("update:input-value", x);
    }, U = () => {
      var k, $;
      (k = i.value.textInputOptions) != null && k.enterSubmit && o(l.value) && r.inputValue !== "" ? (n("set-input-date", l.value, !0), l.value = null) : ($ = i.value.textInputOptions) != null && $.enterSubmit && r.inputValue === "" && (l.value = null, n("clear"));
    }, G = () => {
      var k, $;
      (k = i.value.textInputOptions) != null && k.tabSubmit && o(l.value) && r.inputValue !== "" ? (n("set-input-date", l.value, !0), l.value = null) : ($ = i.value.textInputOptions) != null && $.tabSubmit && r.inputValue === "" && (l.value = null, n("clear"));
    }, ee = () => {
      d.value = !0, n("focus");
    }, Q = (k) => {
      var $;
      k.preventDefault(), k.stopImmediatePropagation(), k.stopPropagation(), r.textInput && (($ = i.value.textInputOptions) != null && $.openMenu) && !r.inlineWithInput ? r.isMenuOpen ? i.value.textInputOptions.enterSubmit && n("select-date") : n("open") : r.textInput || n("toggle");
    }, C = () => {
      d.value = !1, r.isMenuOpen || n("blur"), r.autoApply && r.textInput && l.value && (n("set-input-date", l.value), n("select-date"), l.value = null);
    }, z = () => {
      n("clear");
    }, te = (k) => {
      r.textInput || k.preventDefault();
    };
    return t({
      focusInput: () => {
        f.value && f.value.focus({ preventScroll: !0 });
      }
    }), (k, $) => {
      var x;
      return b(), E("div", {
        onClick: Q,
        "aria-label": (x = v(i).ariaLabels) == null ? void 0 : x.input,
        role: "textbox",
        "aria-multiline": "false",
        "aria-disabled": k.disabled,
        "aria-readonly": k.readonly
      }, [
        k.$slots.trigger && !k.$slots["dp-input"] && !k.inline ? L(k.$slots, "trigger", { key: 0 }) : R("", !0),
        !k.$slots.trigger && (!k.inline || k.inlineWithInput) ? (b(), E("div", rv, [
          k.$slots["dp-input"] && !k.$slots.trigger && !k.inline ? L(k.$slots, "dp-input", {
            key: 0,
            value: e.inputValue,
            onInput: A,
            onEnter: U,
            onTab: G,
            onClear: z
          }) : R("", !0),
          k.$slots["dp-input"] ? R("", !0) : (b(), E("input", {
            key: 1,
            ref_key: "inputRef",
            ref: f,
            id: k.uid ? `dp-input-${k.uid}` : void 0,
            name: k.name,
            class: ye(v(m)),
            inputmode: k.textInput ? "text" : "none",
            placeholder: k.placeholder,
            disabled: k.disabled,
            readonly: k.readonly,
            required: k.required,
            value: e.inputValue,
            autocomplete: k.autocomplete,
            onInput: A,
            onKeydown: [
              pe(Q, ["enter"]),
              pe(G, ["tab"])
            ],
            onBlur: C,
            onFocus: ee,
            onKeypress: te
          }, null, 42, av)),
          k.$slots["input-icon"] && !k.hideInputIcon ? (b(), E("span", ov, [
            L(k.$slots, "input-icon")
          ])) : R("", !0),
          !k.$slots["input-icon"] && !k.hideInputIcon && !k.$slots["dp-input"] ? (b(), re(v(Ir), {
            key: 3,
            class: "dp__input_icon dp__input_icons"
          })) : R("", !0),
          k.$slots["clear-icon"] && e.inputValue && k.clearable && !k.disabled && !k.readonly ? (b(), E("span", iv, [
            L(k.$slots, "clear-icon", { clear: z })
          ])) : R("", !0),
          k.clearable && !k.$slots["clear-icon"] && e.inputValue && !k.disabled && !k.readonly ? (b(), re(v(Yy), {
            key: 5,
            class: "dp__clear_icon dp__input_icons",
            "data-test": "clear-icon",
            onClick: ft(z, ["stop", "prevent"])
          }, null, 8, ["onClick"])) : R("", !0)
        ])) : R("", !0)
      ], 8, nv);
    };
  }
}), lv = { class: "dp__selection_preview" }, sv = { class: "dp__action_buttons" }, fv = ["onKeydown"], cv = /* @__PURE__ */ Ze({
  __name: "ActionRow",
  props: {
    calendarWidth: { type: Number, default: 0 },
    menuMount: { type: Boolean, default: !1 },
    internalModelValue: { type: [Date, Array], default: null },
    ...gt
  },
  emits: ["close-picker", "select-date", "invalid-select"],
  setup(e, { emit: t }) {
    const n = e, { formatDate: r, isValidTime: a, defaults: o } = Ke(n), { buildMatrix: i } = bt(), l = j(null), f = j(null);
    et(() => {
      n.arrowNavigation && i([Ue(l), Ue(f)], "actionRow");
    });
    const d = W(() => n.range && !n.partialRange && n.internalModelValue ? n.internalModelValue.length === 2 : !0), m = W(() => !s.value || !w.value || !d.value), p = W(() => ({
      dp__action: !0,
      dp__select: !0,
      dp__action_disabled: m.value
    })), s = W(() => !n.enableTimePicker || n.ignoreTimeValidation ? !0 : a(n.internalModelValue)), w = W(() => n.monthPicker ? ee(n.internalModelValue) : !0), A = () => {
      const C = o.value.previewFormat;
      return n.timePicker || n.monthPicker, C(Ve(n.internalModelValue));
    }, U = () => {
      const C = n.internalModelValue;
      return o.value.multiCalendars > 0 ? `${r(C[0])} - ${r(C[1])}` : [r(C[0]), r(C[1])];
    }, G = W(() => !n.internalModelValue || !n.menuMount ? "" : typeof o.value.previewFormat == "string" ? Array.isArray(n.internalModelValue) ? n.internalModelValue.length === 2 && n.internalModelValue[1] ? U() : n.multiDates ? n.internalModelValue.map((C) => `${r(C)}`) : n.modelAuto ? `${r(n.internalModelValue[0])}` : `${r(n.internalModelValue[0])} -` : r(n.internalModelValue) : A()), ee = (C) => {
      if (!n.monthPicker)
        return !0;
      let z = !0;
      return n.minDate && n.maxDate ? He(M(C), M(n.minDate)) && Fe(M(C), M(n.maxDate)) : (n.minDate && (z = He(M(C), M(n.minDate))), n.maxDate && (z = Fe(M(C), M(n.maxDate))), z);
    }, Q = () => {
      s.value && w.value && d.value ? t("select-date") : t("invalid-select");
    };
    return (C, z) => (b(), E("div", {
      class: "dp__action_row",
      style: Ct(e.calendarWidth ? { width: `${e.calendarWidth}px` } : {})
    }, [
      C.$slots["action-row"] ? L(C.$slots, "action-row", Xe(Ye({ key: 0 }, {
        internalModelValue: e.internalModelValue,
        disabled: v(m),
        selectDate: () => C.$emit("select-date"),
        closePicker: () => C.$emit("close-picker")
      }))) : (b(), E(he, { key: 1 }, [
        ie("div", lv, [
          C.$slots["action-preview"] ? L(C.$slots, "action-preview", {
            key: 0,
            value: e.internalModelValue
          }) : R("", !0),
          C.$slots["action-preview"] ? R("", !0) : (b(), E(he, { key: 1 }, [
            Array.isArray(v(G)) ? R("", !0) : (b(), E(he, { key: 0 }, [
              Ie(we(v(G)), 1)
            ], 64)),
            Array.isArray(v(G)) ? (b(!0), E(he, { key: 1 }, Ae(v(G), (te, k) => (b(), E("div", { key: k }, we(te), 1))), 128)) : R("", !0)
          ], 64))
        ]),
        ie("div", sv, [
          C.$slots["action-select"] ? L(C.$slots, "action-select", {
            key: 0,
            value: e.internalModelValue
          }) : R("", !0),
          C.$slots["action-select"] ? R("", !0) : (b(), E(he, { key: 1 }, [
            C.inline ? R("", !0) : (b(), E("span", {
              key: 0,
              class: "dp__action dp__cancel",
              ref_key: "cancelButtonRef",
              ref: l,
              tabindex: "0",
              onClick: z[0] || (z[0] = (te) => C.$emit("close-picker")),
              onKeydown: [
                z[1] || (z[1] = pe((te) => C.$emit("close-picker"), ["enter"])),
                z[2] || (z[2] = pe((te) => C.$emit("close-picker"), ["space"]))
              ]
            }, we(C.cancelText), 545)),
            ie("span", {
              class: ye(v(p)),
              tabindex: "0",
              onKeydown: [
                pe(Q, ["enter"]),
                pe(Q, ["space"])
              ],
              onClick: Q,
              "data-test": "select-button",
              ref_key: "selectButtonRef",
              ref: f
            }, we(C.selectText), 43, fv)
          ], 64))
        ])
      ], 64))
    ], 4));
  }
}), dv = ["aria-label"], pv = {
  class: "dp__calendar_header",
  role: "row"
}, yv = {
  key: 0,
  class: "dp__calendar_header_item",
  role: "gridcell"
}, mv = /* @__PURE__ */ ie("div", { class: "dp__calendar_header_separator" }, null, -1), vv = ["aria-label"], hv = {
  key: 0,
  role: "gridcell",
  class: "dp__calendar_item dp__week_num"
}, bv = { class: "dp__cell_inner" }, gv = ["aria-selected", "aria-disabled", "aria-label", "data-test", "onClick", "onKeydown", "onMouseover"], _v = /* @__PURE__ */ ie("div", { class: "dp__arrow_bottom_tp" }, null, -1), wv = /* @__PURE__ */ Ze({
  __name: "Calendar",
  props: {
    mappedDates: { type: Array, default: () => [] },
    getWeekNum: {
      type: Function,
      default: () => ""
    },
    specificMode: { type: Boolean, default: !1 },
    instance: { type: Number, default: 0 },
    month: { type: Number, default: 0 },
    year: { type: Number, default: 0 },
    ...gt
  },
  emits: [
    "select-date",
    "set-hover-date",
    "handle-scroll",
    "mount",
    "handle-swipe",
    "handle-space"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { buildMultiLevelMatrix: a } = bt(), { setDateMonthOrYear: o, defaults: i } = Ke(r), l = j(null), f = j({ bottom: "", left: "", transform: "" }), d = j([]), m = j(null), p = j(!0), s = j(""), w = j({ startX: 0, endX: 0, startY: 0, endY: 0 }), A = W(() => r.dayNames ? Array.isArray(r.dayNames) ? r.dayNames : r.dayNames(r.locale, +r.weekStart) : Um(r.locale, +r.weekStart));
    et(() => {
      n("mount", { cmp: "calendar", refs: d }), r.noSwipe || m.value && (m.value.addEventListener("touchstart", x, { passive: !1 }), m.value.addEventListener("touchend", F, { passive: !1 }), m.value.addEventListener("touchmove", H, { passive: !1 })), r.monthChangeOnScroll && m.value && m.value.addEventListener("wheel", O, { passive: !1 });
    });
    const U = (y) => y ? r.vertical ? "vNext" : "next" : r.vertical ? "vPrevious" : "previous", G = (y, P) => {
      if (r.transitions) {
        const D = ot(o(M(), r.month, r.year));
        s.value = He(ot(o(M(), y, P)), D) ? i.value.transitions[U(!0)] : i.value.transitions[U(!1)], p.value = !1, Jt(() => {
          p.value = !0;
        });
      }
    }, ee = W(
      () => ({
        dp__calendar_wrap: !0,
        [r.calendarClassName]: !!r.calendarClassName
      })
    ), Q = W(() => (y) => {
      const P = Wm(y);
      return {
        dp__marker_dot: P.type === "dot",
        dp__marker_line: P.type === "line"
      };
    }), C = W(() => (y) => Te(y, l.value)), z = W(() => ({
      dp__calendar: !0,
      dp__calendar_next: i.value.multiCalendars > 0 && r.instance !== 0
    })), te = W(() => r.specificMode ? { height: `${r.modeHeight}px` } : void 0), k = (y, P, D) => {
      var u, g;
      if (n("set-hover-date", y), (g = (u = y.marker) == null ? void 0 : u.tooltip) != null && g.length) {
        const S = Ue(d.value[P][D]);
        if (S) {
          const { width: I, height: V } = S.getBoundingClientRect();
          f.value = {
            bottom: `${V}px`,
            left: `${I / 2}px`,
            transform: "translateX(-50%)"
          }, l.value = y.value;
        }
      }
    }, $ = () => {
      l.value = null;
    }, x = (y) => {
      w.value.startX = y.changedTouches[0].screenX, w.value.startY = y.changedTouches[0].screenY;
    }, F = (y) => {
      w.value.endX = y.changedTouches[0].screenX, w.value.endY = y.changedTouches[0].screenY, Y();
    }, H = (y) => {
      r.vertical && !r.inline && y.preventDefault();
    }, Y = () => {
      const y = r.vertical ? "Y" : "X";
      Math.abs(w.value[`start${y}`] - w.value[`end${y}`]) > 10 && n("handle-swipe", w.value[`start${y}`] > w.value[`end${y}`] ? "right" : "left");
    }, X = (y, P, D) => {
      y && (Array.isArray(d.value[P]) ? d.value[P][D] = y : d.value[P] = [y]), r.arrowNavigation && a(d.value, "calendar");
    }, O = (y) => {
      r.monthChangeOnScroll && (y.preventDefault(), n("handle-scroll", y));
    };
    return t({ triggerTransition: G }), (y, P) => {
      var D;
      return b(), E("div", {
        class: ye(v(z))
      }, [
        ie("div", {
          style: Ct(v(te))
        }, [
          e.specificMode ? R("", !0) : (b(), E("div", {
            key: 0,
            ref_key: "calendarWrapRef",
            ref: m,
            class: ye(v(ee)),
            role: "grid",
            "aria-label": (D = v(i).ariaLabels) == null ? void 0 : D.calendarWrap
          }, [
            ie("div", pv, [
              y.weekNumbers ? (b(), E("div", yv, we(y.weekNumName), 1)) : R("", !0),
              (b(!0), E(he, null, Ae(v(A), (u, g) => (b(), E("div", {
                class: "dp__calendar_header_item",
                role: "gridcell",
                key: g,
                "data-test": "calendar-header"
              }, [
                y.$slots["calendar-header"] ? L(y.$slots, "calendar-header", {
                  key: 0,
                  day: u,
                  index: g
                }) : R("", !0),
                y.$slots["calendar-header"] ? R("", !0) : (b(), E(he, { key: 1 }, [
                  Ie(we(u), 1)
                ], 64))
              ]))), 128))
            ]),
            mv,
            xe(Bt, {
              name: s.value,
              css: !!y.transitions
            }, {
              default: q(() => {
                var u;
                return [
                  p.value ? (b(), E("div", {
                    key: 0,
                    class: "dp__calendar",
                    role: "grid",
                    "aria-label": (u = v(i).ariaLabels) == null ? void 0 : u.calendarDays
                  }, [
                    (b(!0), E(he, null, Ae(e.mappedDates, (g, S) => (b(), E("div", {
                      class: "dp__calendar_row",
                      role: "row",
                      key: S
                    }, [
                      y.weekNumbers ? (b(), E("div", hv, [
                        ie("div", bv, we(e.getWeekNum(g.days)), 1)
                      ])) : R("", !0),
                      (b(!0), E(he, null, Ae(g.days, (I, V) => {
                        var _, le, de;
                        return b(), E("div", {
                          role: "gridcell",
                          class: "dp__calendar_item",
                          ref_for: !0,
                          ref: (h) => X(h, S, V),
                          key: V + S,
                          "aria-selected": I.classData.dp__active_date || I.classData.dp__range_start || I.classData.dp__range_start,
                          "aria-disabled": I.classData.dp__cell_disabled,
                          "aria-label": (le = (_ = v(i).ariaLabels) == null ? void 0 : _.day) == null ? void 0 : le.call(_, I),
                          tabindex: "0",
                          "data-test": I.value,
                          onClick: ft((h) => y.$emit("select-date", I), ["stop", "prevent"]),
                          onKeydown: [
                            pe((h) => y.$emit("select-date", I), ["enter"]),
                            pe((h) => y.$emit("handle-space", I), ["space"])
                          ],
                          onMouseover: (h) => k(I, S, V),
                          onMouseleave: $
                        }, [
                          ie("div", {
                            class: ye(["dp__cell_inner", I.classData])
                          }, [
                            y.$slots.day ? L(y.$slots, "day", {
                              key: 0,
                              day: +I.text,
                              date: I.value
                            }) : R("", !0),
                            y.$slots.day ? R("", !0) : (b(), E(he, { key: 1 }, [
                              Ie(we(I.text), 1)
                            ], 64)),
                            I.marker && (!y.hideOffsetDates || I.current) ? (b(), E("div", {
                              key: 2,
                              class: ye(v(Q)(I.marker)),
                              style: Ct(I.marker.color ? { backgroundColor: I.marker.color } : {})
                            }, null, 6)) : R("", !0),
                            v(C)(I.value) ? (b(), E("div", {
                              key: 3,
                              class: "dp__marker_tooltip",
                              style: Ct(f.value)
                            }, [
                              (de = I.marker) != null && de.tooltip ? (b(), E("div", {
                                key: 0,
                                class: "dp__tooltip_content",
                                onClick: P[0] || (P[0] = ft(() => {
                                }, ["stop"]))
                              }, [
                                (b(!0), E(he, null, Ae(I.marker.tooltip, (h, B) => (b(), E("div", {
                                  key: B,
                                  class: "dp__tooltip_text"
                                }, [
                                  y.$slots["marker-tooltip"] ? L(y.$slots, "marker-tooltip", {
                                    key: 0,
                                    tooltop: h,
                                    day: I.value
                                  }) : R("", !0),
                                  y.$slots["marker-tooltip"] ? R("", !0) : (b(), E(he, { key: 1 }, [
                                    ie("div", {
                                      class: "dp__tooltip_mark",
                                      style: Ct(h.color ? { backgroundColor: h.color } : {})
                                    }, null, 4),
                                    ie("div", null, we(h.text), 1)
                                  ], 64))
                                ]))), 128)),
                                _v
                              ])) : R("", !0)
                            ], 4)) : R("", !0)
                          ], 2)
                        ], 40, gv);
                      }), 128))
                    ]))), 128))
                  ], 8, vv)) : R("", !0)
                ];
              }),
              _: 3
            }, 8, ["name", "css"])
          ], 10, dv))
        ], 4)
      ], 2);
    };
  }
}), Ov = ["aria-label", "aria-disabled"], na = /* @__PURE__ */ Ze({
  __name: "ActionIcon",
  props: {
    ariaLabel: { type: String, default: "" },
    disabled: { type: Boolean, default: !1 }
  },
  emits: ["activate", "set-ref"],
  setup(e, { emit: t }) {
    const n = j(null);
    return et(() => t("set-ref", n)), (r, a) => (b(), E("div", {
      class: "dp__month_year_col_nav",
      onClick: a[0] || (a[0] = (o) => r.$emit("activate")),
      onKeydown: [
        a[1] || (a[1] = pe((o) => r.$emit("activate"), ["enter"])),
        a[2] || (a[2] = pe((o) => r.$emit("activate"), ["space"]))
      ],
      tabindex: "0",
      role: "button",
      "aria-label": e.ariaLabel,
      "aria-disabled": e.disabled,
      ref_key: "elRef",
      ref: n
    }, [
      ie("div", {
        class: ye(["dp__inner_nav", { dp__inner_nav_disabled: e.disabled }])
      }, [
        L(r.$slots, "default")
      ], 2)
    ], 40, Ov));
  }
}), $v = ["onKeydown"], kv = { class: "dp__selection_grid_header" }, Pv = ["aria-selected", "aria-disabled", "data-test", "onClick", "onKeydown", "onMouseover"], Tv = ["aria-label", "onKeydown"], Qt = /* @__PURE__ */ Ze({
  __name: "SelectionGrid",
  props: {
    items: { type: Array, default: () => [] },
    modelValue: { type: [String, Number], default: null },
    multiModelValue: { type: Array, default: () => [] },
    disabledValues: { type: Array, default: () => [] },
    minValue: { type: [Number, String], default: null },
    maxValue: { type: [Number, String], default: null },
    year: { type: Number, default: 0 },
    skipActive: { type: Boolean, default: !1 },
    headerRefs: { type: Array, default: () => [] },
    skipButtonRef: { type: Boolean, default: !1 },
    monthPicker: { type: Boolean, default: !1 },
    yearPicker: { type: Boolean, default: !1 },
    escClose: { type: Boolean, default: !0 },
    type: { type: String, default: null },
    arrowNavigation: { type: Boolean, default: !1 },
    autoApply: { type: Boolean, default: !1 },
    textInput: { type: Boolean, default: !1 },
    ariaLabels: { type: Object, default: () => ({}) },
    hideNavigation: { type: Array, default: () => [] }
  },
  emits: ["update:model-value", "selected", "toggle", "reset-flow"],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setSelectionGrid: a, buildMultiLevelMatrix: o, setMonthPicker: i } = bt(), { hideNavigationButtons: l } = Ke(r), f = j(!1), d = j(null), m = j(null), p = j([]), s = j(), w = j(null);
    sl(() => {
      d.value = null;
    }), et(() => {
      Jt().then(() => $()), U(), A(!0);
    }), Oo(() => A(!1));
    const A = (y) => {
      var P;
      r.arrowNavigation && ((P = r.headerRefs) != null && P.length ? i(y) : a(y));
    }, U = () => {
      const y = Ue(m);
      y && (r.textInput || y.focus({ preventScroll: !0 }), f.value = y.clientHeight < y.scrollHeight);
    }, G = W(
      () => ({
        dp__overlay: !0
      })
    ), ee = W(() => ({
      dp__overlay_col: !0
    })), Q = (y) => r.skipActive ? !1 : y.value === r.modelValue, C = W(() => r.items.map((y) => y.filter((P) => P).map((P) => {
      var D, u, g;
      const S = r.disabledValues.some((V) => V === P.value) || k(P.value), I = (D = r.multiModelValue) != null && D.length ? (u = r.multiModelValue) == null ? void 0 : u.some(
        (V) => Te(
          V,
          Tt(
            r.monthPicker ? Gt(new Date(), P.value) : new Date(),
            r.monthPicker ? r.year : P.value
          )
        )
      ) : Q(P);
      return {
        ...P,
        className: {
          dp__overlay_cell_active: I,
          dp__overlay_cell: !I,
          dp__overlay_cell_disabled: S,
          dp__overlay_cell_active_disabled: S && I,
          dp__overlay_cell_pad: !0,
          dp__cell_in_between: (g = r.multiModelValue) != null && g.length ? F(P.value) : !1
        }
      };
    }))), z = W(
      () => ({
        dp__button: !0,
        dp__overlay_action: !0,
        dp__over_action_scroll: f.value,
        dp__button_bottom: r.autoApply
      })
    ), te = W(() => {
      var y, P;
      return {
        dp__overlay_container: !0,
        dp__container_flex: ((y = r.items) == null ? void 0 : y.length) <= 6,
        dp__container_block: ((P = r.items) == null ? void 0 : P.length) > 6
      };
    }), k = (y) => {
      const P = r.maxValue || r.maxValue === 0, D = r.minValue || r.minValue === 0;
      return !P && !D ? !1 : P && D ? +y > +r.maxValue || +y < +r.minValue : P ? +y > +r.maxValue : D ? +y < +r.minValue : !1;
    }, $ = () => {
      const y = Ue(d);
      if (y) {
        const P = Ue(m);
        P && (P.scrollTop = y.offsetTop - P.offsetTop - (P.getBoundingClientRect().height / 2 - y.getBoundingClientRect().height));
      }
    }, x = (y) => {
      !r.disabledValues.some((P) => P === y) && !k(y) && (n("update:model-value", y), n("selected"));
    }, F = (y) => {
      const P = r.monthPicker ? r.year : y;
      return ju(
        r.multiModelValue,
        Tt(
          r.monthPicker ? Gt(new Date(), s.value || 0) : new Date(),
          r.monthPicker ? P : s.value || P
        ),
        Tt(r.monthPicker ? Gt(new Date(), y) : new Date(), P)
      );
    }, H = () => {
      n("toggle"), n("reset-flow");
    }, Y = () => {
      r.escClose && H();
    }, X = (y, P, D, u) => {
      y && (P.value === +r.modelValue && !r.disabledValues.includes(P.value) && (d.value = y), r.arrowNavigation && (Array.isArray(p.value[D]) ? p.value[D][u] = y : p.value[D] = [y], O()));
    }, O = () => {
      var y, P;
      const D = (y = r.headerRefs) != null && y.length ? [r.headerRefs].concat(p.value) : p.value.concat([r.skipButtonRef ? [] : [w.value]]);
      o(Ve(D), (P = r.headerRefs) != null && P.length ? "monthPicker" : "selectionGrid");
    };
    return t({ focusGrid: U }), (y, P) => {
      var D;
      return b(), E("div", {
        ref_key: "gridWrapRef",
        ref: m,
        class: ye(v(G)),
        role: "dialog",
        tabindex: "0",
        onKeydown: pe(Y, ["esc"])
      }, [
        ie("div", {
          class: ye(v(te)),
          role: "grid"
        }, [
          ie("div", kv, [
            L(y.$slots, "header")
          ]),
          y.$slots.overlay ? L(y.$slots, "overlay", { key: 0 }) : (b(), E(he, { key: 1 }, [
            (b(!0), E(he, null, Ae(v(C), (u, g) => (b(), E("div", {
              class: "dp__overlay_row",
              key: g,
              role: "row"
            }, [
              (b(!0), E(he, null, Ae(u, (S, I) => (b(), E("div", {
                role: "gridcell",
                class: ye(v(ee)),
                key: S.value,
                "aria-selected": S.value === e.modelValue && !e.disabledValues.includes(S.value),
                "aria-disabled": S.className.dp__overlay_cell_disabled,
                ref_for: !0,
                ref: (V) => X(V, S, g, I),
                tabindex: "0",
                "data-test": S.text,
                onClick: (V) => x(S.value),
                onKeydown: [
                  pe((V) => x(S.value), ["enter"]),
                  pe((V) => x(S.value), ["space"])
                ],
                onMouseover: (V) => s.value = S.value
              }, [
                ie("div", {
                  class: ye(S.className)
                }, [
                  y.$slots.item ? L(y.$slots, "item", {
                    key: 0,
                    item: S
                  }) : R("", !0),
                  y.$slots.item ? R("", !0) : (b(), E(he, { key: 1 }, [
                    Ie(we(S.text), 1)
                  ], 64))
                ], 2)
              ], 42, Pv))), 128))
            ]))), 128)),
            y.$slots["button-icon"] ? on((b(), E("div", {
              key: 0,
              role: "button",
              "aria-label": (D = e.ariaLabels) == null ? void 0 : D.toggleOverlay,
              class: ye(v(z)),
              tabindex: "0",
              ref_key: "toggleButton",
              ref: w,
              onClick: H,
              onKeydown: pe(H, ["enter"])
            }, [
              L(y.$slots, "button-icon")
            ], 42, Tv)), [
              [un, !v(l)(e.type)]
            ]) : R("", !0)
          ], 64))
        ], 2)
      ], 42, $v);
    };
  }
}), Dv = ["aria-label"], pu = /* @__PURE__ */ Ze({
  __name: "RegularPicker",
  props: {
    ariaLabel: { type: String, default: "" },
    showSelectionGrid: { type: Boolean, default: !1 },
    modelValue: { type: Number, default: null },
    items: { type: Array, default: () => [] },
    disabledValues: { type: Array, default: () => [] },
    minValue: { type: Number, default: null },
    maxValue: { type: Number, default: null },
    slotName: { type: String, default: "" },
    overlaySlot: { type: String, default: "" },
    headerRefs: { type: Array, default: () => [] },
    escClose: { type: Boolean, default: !0 },
    type: { type: String, default: null },
    transitions: { type: [Object, Boolean], default: !1 },
    arrowNavigation: { type: Boolean, default: !1 },
    autoApply: { type: Boolean, default: !1 },
    textInput: { type: Boolean, default: !1 },
    ariaLabels: { type: Object, default: () => ({}) },
    hideNavigation: { type: Array, default: () => [] }
  },
  emits: ["update:model-value", "toggle", "set-ref"],
  setup(e, { emit: t }) {
    const n = e, { transitionName: r, showTransition: a } = Br(n.transitions), o = j(null);
    return et(() => t("set-ref", o)), (i, l) => (b(), E(he, null, [
      ie("div", {
        class: "dp__month_year_select",
        onClick: l[0] || (l[0] = (f) => i.$emit("toggle")),
        onKeydown: [
          l[1] || (l[1] = pe((f) => i.$emit("toggle"), ["enter"])),
          l[2] || (l[2] = pe((f) => i.$emit("toggle"), ["space"]))
        ],
        role: "button",
        "aria-label": e.ariaLabel,
        tabindex: "0",
        ref_key: "elRef",
        ref: o
      }, [
        L(i.$slots, "default")
      ], 40, Dv),
      xe(Bt, {
        name: v(r)(e.showSelectionGrid),
        css: v(a)
      }, {
        default: q(() => [
          e.showSelectionGrid ? (b(), re(Qt, Ye({ key: 0 }, {
            modelValue: e.modelValue,
            items: e.items,
            disabledValues: e.disabledValues,
            minValue: e.minValue,
            maxValue: e.maxValue,
            escClose: e.escClose,
            type: e.type,
            arrowNavigation: e.arrowNavigation,
            textInput: e.textInput,
            autoApply: e.autoApply,
            ariaLabels: e.ariaLabels,
            hideNavigation: e.hideNavigation
          }, {
            "header-refs": [],
            "onUpdate:modelValue": l[3] || (l[3] = (f) => i.$emit("update:model-value", f)),
            onToggle: l[4] || (l[4] = (f) => i.$emit("toggle"))
          }), Ge({
            "button-icon": q(() => [
              i.$slots["calendar-icon"] ? L(i.$slots, "calendar-icon", { key: 0 }) : R("", !0),
              i.$slots["calendar-icon"] ? R("", !0) : (b(), re(v(Ir), { key: 1 }))
            ]),
            _: 2
          }, [
            i.$slots[e.slotName] ? {
              name: "item",
              fn: q(({ item: f }) => [
                L(i.$slots, e.slotName, { item: f })
              ]),
              key: "0"
            } : void 0,
            i.$slots[e.overlaySlot] ? {
              name: "overlay",
              fn: q(() => [
                L(i.$slots, e.overlaySlot)
              ]),
              key: "1"
            } : void 0,
            i.$slots[`${e.overlaySlot}-header`] ? {
              name: "header",
              fn: q(() => [
                L(i.$slots, `${e.overlaySlot}-header`)
              ]),
              key: "2"
            } : void 0
          ]), 1040)) : R("", !0)
        ]),
        _: 3
      }, 8, ["name", "css"])
    ], 64));
  }
}), Sv = { class: "dp__month_year_row" }, Rv = { class: "dp__month_year_wrap" }, Mv = { class: "dp__month_picker_header" }, xv = ["aria-label"], Nv = ["aria-label"], Cv = ["aria-label"], Ev = /* @__PURE__ */ Ze({
  __name: "MonthYearPicker",
  props: {
    month: { type: Number, default: 0 },
    year: { type: Number, default: 0 },
    instance: { type: Number, default: 0 },
    years: { type: Array, default: () => [] },
    months: { type: Array, default: () => [] },
    internalModelValue: { type: [Date, Array], default: null },
    ...gt
  },
  emits: ["update-month-year", "month-year-select", "mount", "reset-flow", "overlay-closed"],
  setup(e, { expose: t, emit: n }) {
    const r = e, { defaults: a } = Ke(r), { transitionName: o, showTransition: i } = Br(a.value.transitions), { buildMatrix: l } = bt(), { handleMonthYearChange: f, isDisabled: d, updateMonthYear: m } = Jm(r, n), p = j(!1), s = j(!1), w = j([null, null, null, null]), A = j(null), U = j(null), G = j(null);
    et(() => {
      n("mount");
    });
    const ee = (h) => ({
      get: () => r[h],
      set: (B) => {
        const Me = h === "month" ? "year" : "month";
        n("update-month-year", { [h]: B, [Me]: r[Me] }), n("month-year-select", h === "year"), h === "month" ? I(!0) : V(!0);
      }
    }), Q = W(ee("month")), C = W(ee("year")), z = (h) => {
      const B = Pe(M(h));
      return r.year === B;
    }, te = W(() => r.monthPicker ? Array.isArray(r.disabledDates) ? r.disabledDates.map((h) => M(h)).filter((h) => z(h)).map((h) => ke(h)) : [] : []), k = W(() => (h) => {
      const B = h === "month";
      return {
        showSelectionGrid: (B ? p : s).value,
        items: (B ? D : u).value,
        disabledValues: a.value.filters[B ? "months" : "years"].concat(te.value),
        minValue: (B ? H : x).value,
        maxValue: (B ? Y : F).value,
        headerRefs: B && r.monthPicker ? [A.value, U.value, G.value] : [],
        escClose: r.escClose,
        transitions: a.value.transitions,
        ariaLabels: a.value.ariaLabels,
        textInput: r.textInput,
        autoApply: r.autoApply,
        arrowNavigation: r.arrowNavigation,
        hideNavigation: r.hideNavigation
      };
    }), $ = W(() => (h) => ({
      month: r.month,
      year: r.year,
      items: h === "month" ? r.months : r.years,
      instance: r.instance,
      updateMonthYear: m,
      toggle: h === "month" ? I : V
    })), x = W(() => r.minDate ? Pe(M(r.minDate)) : null), F = W(() => r.maxDate ? Pe(M(r.maxDate)) : null), H = W(() => {
      if (r.minDate && x.value) {
        if (x.value > r.year)
          return 12;
        if (x.value === r.year)
          return ke(M(r.minDate));
      }
      return null;
    }), Y = W(() => r.maxDate && F.value ? F.value < r.year ? -1 : F.value === r.year ? ke(M(r.maxDate)) : null : null), X = W(() => r.range && r.internalModelValue && (r.monthPicker || r.yearPicker) ? r.internalModelValue : []), O = (h) => h.reverse(), y = (h, B = !1) => {
      const Me = [], me = (ue) => B ? O(ue) : ue;
      for (let ue = 0; ue < h.length; ue += 3) {
        const De = [h[ue], h[ue + 1], h[ue + 2]];
        Me.push(me(De));
      }
      return B ? Me.reverse() : Me;
    }, P = W(() => r.months.find((B) => B.value === r.month) || { text: "", value: 0 }), D = W(() => y(r.months)), u = W(() => y(r.years, r.reverseYears)), g = W(() => a.value.multiCalendars ? r.multiCalendarsSolo ? !0 : r.instance === 0 : !0), S = W(() => a.value.multiCalendars ? r.multiCalendarsSolo ? !0 : r.instance === a.value.multiCalendars - 1 : !0), I = (h = !1) => {
      _(h), p.value = !p.value, p.value || n("overlay-closed");
    }, V = (h = !1) => {
      _(h), s.value = !s.value, s.value || n("overlay-closed");
    }, _ = (h) => {
      h || n("reset-flow");
    }, le = (h = !1) => {
      d.value(h) || n("update-month-year", {
        year: h ? r.year + 1 : r.year - 1,
        month: r.month,
        fromNav: !0
      });
    }, de = (h, B) => {
      r.arrowNavigation && (w.value[B] = Ue(h), l(w.value, "monthYear"));
    };
    return t({
      toggleMonthPicker: I,
      toggleYearPicker: V
    }), (h, B) => {
      var Me, me, ue, De, Qe;
      return b(), E("div", Sv, [
        h.$slots["month-year"] ? L(h.$slots, "month-year", Xe(Ye({ key: 0 }, { month: e.month, year: e.year, months: e.months, years: e.years, updateMonthYear: v(m), handleMonthYearChange: v(f), instance: e.instance }))) : (b(), E(he, { key: 1 }, [
          !h.monthPicker && !h.yearPicker ? (b(), E(he, { key: 0 }, [
            v(g) && !h.vertical ? (b(), re(na, {
              key: 0,
              "aria-label": (Me = v(a).ariaLabels) == null ? void 0 : Me.prevMonth,
              disabled: v(d)(!1),
              onActivate: B[0] || (B[0] = (se) => v(f)(!1)),
              onSetRef: B[1] || (B[1] = (se) => de(se, 0))
            }, {
              default: q(() => [
                h.$slots["arrow-left"] ? L(h.$slots, "arrow-left", { key: 0 }) : R("", !0),
                h.$slots["arrow-left"] ? R("", !0) : (b(), re(v(Ji), { key: 1 }))
              ]),
              _: 3
            }, 8, ["aria-label", "disabled"])) : R("", !0),
            ie("div", Rv, [
              xe(pu, Ye({
                type: "month",
                "slot-name": "month-overlay-val",
                "overlay-slot": "overlay-month",
                "aria-label": (me = v(a).ariaLabels) == null ? void 0 : me.openMonthsOverlay,
                modelValue: v(Q),
                "onUpdate:modelValue": B[2] || (B[2] = (se) => kt(Q) ? Q.value = se : null)
              }, v(k)("month"), {
                onToggle: I,
                onSetRef: B[3] || (B[3] = (se) => de(se, 1))
              }), Ge({
                default: q(() => [
                  h.$slots.month ? L(h.$slots, "month", Xe(Ye({ key: 0 }, v(P)))) : R("", !0),
                  h.$slots.month ? R("", !0) : (b(), E(he, { key: 1 }, [
                    Ie(we(v(P).text), 1)
                  ], 64))
                ]),
                _: 2
              }, [
                h.$slots["calendar-icon"] ? {
                  name: "calendar-icon",
                  fn: q(() => [
                    L(h.$slots, "calendar-icon")
                  ]),
                  key: "0"
                } : void 0,
                h.$slots["month-overlay-value"] ? {
                  name: "month-overlay-val",
                  fn: q(({ item: se }) => [
                    L(h.$slots, "month-overlay-value", {
                      text: se.text,
                      value: se.value
                    })
                  ]),
                  key: "1"
                } : void 0,
                h.$slots["month-overlay"] ? {
                  name: "overlay-month",
                  fn: q(() => [
                    L(h.$slots, "month-overlay", Xe(st(v($)("month"))))
                  ]),
                  key: "2"
                } : void 0,
                h.$slots["month-overlay-header"] ? {
                  name: "overlay-month-header",
                  fn: q(() => [
                    L(h.$slots, "month-overlay-header", { toggle: I })
                  ]),
                  key: "3"
                } : void 0
              ]), 1040, ["aria-label", "modelValue"]),
              xe(pu, Ye({
                type: "year",
                "slot-name": "year-overlay-val",
                "overlay-slot": "overlay-year",
                "aria-label": (ue = v(a).ariaLabels) == null ? void 0 : ue.openYearsOverlay,
                modelValue: v(C),
                "onUpdate:modelValue": B[4] || (B[4] = (se) => kt(C) ? C.value = se : null)
              }, v(k)("year"), {
                onToggle: V,
                onSetRef: B[5] || (B[5] = (se) => de(se, 2))
              }), Ge({
                default: q(() => [
                  h.$slots.year ? L(h.$slots, "year", {
                    key: 0,
                    year: e.year
                  }) : R("", !0),
                  h.$slots.year ? R("", !0) : (b(), E(he, { key: 1 }, [
                    Ie(we(e.year), 1)
                  ], 64))
                ]),
                _: 2
              }, [
                h.$slots["calendar-icon"] ? {
                  name: "calendar-icon",
                  fn: q(() => [
                    L(h.$slots, "calendar-icon")
                  ]),
                  key: "0"
                } : void 0,
                h.$slots["year-overlay-value"] ? {
                  name: "year-overlay-val",
                  fn: q(({ item: se }) => [
                    L(h.$slots, "year-overlay-value", {
                      text: se.text,
                      value: se.value
                    })
                  ]),
                  key: "1"
                } : void 0,
                h.$slots["year-overlay"] ? {
                  name: "overlay-year",
                  fn: q(() => [
                    L(h.$slots, "year-overlay", Xe(st(v($)("year"))))
                  ]),
                  key: "2"
                } : void 0,
                h.$slots["year-overlay-header"] ? {
                  name: "overlay-year-header",
                  fn: q(() => [
                    L(h.$slots, "year-overlay-header", { toggle: V })
                  ]),
                  key: "3"
                } : void 0
              ]), 1040, ["aria-label", "modelValue"])
            ]),
            v(g) && h.vertical ? (b(), re(na, {
              key: 1,
              "aria-label": (De = v(a).ariaLabels) == null ? void 0 : De.prevMonth,
              disabled: v(d)(!1),
              onActivate: B[6] || (B[6] = (se) => v(f)(!1))
            }, {
              default: q(() => [
                h.$slots["arrow-up"] ? L(h.$slots, "arrow-up", { key: 0 }) : R("", !0),
                h.$slots["arrow-up"] ? R("", !0) : (b(), re(v(Wu), { key: 1 }))
              ]),
              _: 3
            }, 8, ["aria-label", "disabled"])) : R("", !0),
            v(S) ? (b(), re(na, {
              key: 2,
              ref: "rightIcon",
              disabled: v(d)(!0),
              "aria-label": (Qe = v(a).ariaLabels) == null ? void 0 : Qe.nextMonth,
              onActivate: B[7] || (B[7] = (se) => v(f)(!0)),
              onSetRef: B[8] || (B[8] = (se) => de(se, 3))
            }, {
              default: q(() => [
                h.$slots[h.vertical ? "arrow-down" : "arrow-right"] ? L(h.$slots, h.vertical ? "arrow-down" : "arrow-right", { key: 0 }) : R("", !0),
                h.$slots[h.vertical ? "arrow-down" : "arrow-right"] ? R("", !0) : (b(), re(an(h.vertical ? v(zu) : v(Zi)), { key: 1 }))
              ]),
              _: 3
            }, 8, ["disabled", "aria-label"])) : R("", !0)
          ], 64)) : R("", !0),
          h.monthPicker ? (b(), re(Qt, Ye({ key: 1 }, v(k)("month"), {
            "skip-active": h.range,
            year: e.year,
            "multi-model-value": v(X),
            "month-picker": "",
            modelValue: v(Q),
            "onUpdate:modelValue": B[17] || (B[17] = (se) => kt(Q) ? Q.value = se : null),
            onToggle: I,
            onSelected: B[18] || (B[18] = (se) => h.$emit("overlay-closed"))
          }), Ge({
            header: q(() => {
              var se, ce, Oe;
              return [
                ie("div", Mv, [
                  ie("div", {
                    class: "dp__month_year_col_nav",
                    tabindex: "0",
                    ref_key: "mpPrevIconRef",
                    ref: A,
                    onClick: B[9] || (B[9] = (be) => le(!1)),
                    onKeydown: B[10] || (B[10] = pe((be) => le(!1), ["enter"]))
                  }, [
                    ie("div", {
                      class: ye(["dp__inner_nav", { dp__inner_nav_disabled: v(d)(!1) }]),
                      role: "button",
                      "aria-label": (se = v(a).ariaLabels) == null ? void 0 : se.prevMonth
                    }, [
                      h.$slots["arrow-left"] ? L(h.$slots, "arrow-left", { key: 0 }) : R("", !0),
                      h.$slots["arrow-left"] ? R("", !0) : (b(), re(v(Ji), { key: 1 }))
                    ], 10, xv)
                  ], 544),
                  ie("div", {
                    class: "dp__pointer",
                    role: "button",
                    ref_key: "mpYearButtonRef",
                    ref: U,
                    "aria-label": (ce = v(a).ariaLabels) == null ? void 0 : ce.openYearsOverlay,
                    tabindex: "0",
                    onClick: B[11] || (B[11] = () => V(!1)),
                    onKeydown: B[12] || (B[12] = pe(() => V(!1), ["enter"]))
                  }, [
                    h.$slots.year ? L(h.$slots, "year", {
                      key: 0,
                      year: e.year
                    }) : R("", !0),
                    h.$slots.year ? R("", !0) : (b(), E(he, { key: 1 }, [
                      Ie(we(e.year), 1)
                    ], 64))
                  ], 40, Nv),
                  ie("div", {
                    class: "dp__month_year_col_nav",
                    tabindex: "0",
                    ref_key: "mpNextIconRef",
                    ref: G,
                    onClick: B[13] || (B[13] = (be) => le(!0)),
                    onKeydown: B[14] || (B[14] = pe((be) => le(!0), ["enter"]))
                  }, [
                    ie("div", {
                      class: ye(["dp__inner_nav", { dp__inner_nav_disabled: v(d)(!0) }]),
                      role: "button",
                      "aria-label": (Oe = v(a).ariaLabels) == null ? void 0 : Oe.nextMonth
                    }, [
                      h.$slots["arrow-right"] ? L(h.$slots, "arrow-right", { key: 0 }) : R("", !0),
                      h.$slots["arrow-right"] ? R("", !0) : (b(), re(v(Zi), { key: 1 }))
                    ], 10, Cv)
                  ], 544)
                ]),
                xe(Bt, {
                  name: v(o)(s.value),
                  css: v(i)
                }, {
                  default: q(() => [
                    s.value ? (b(), re(Qt, Ye({ key: 0 }, v(k)("year"), {
                      modelValue: v(C),
                      "onUpdate:modelValue": B[15] || (B[15] = (be) => kt(C) ? C.value = be : null),
                      onToggle: V,
                      onSelected: B[16] || (B[16] = (be) => h.$emit("overlay-closed"))
                    }), Ge({
                      "button-icon": q(() => [
                        h.$slots["calendar-icon"] ? L(h.$slots, "calendar-icon", { key: 0 }) : R("", !0),
                        h.$slots["calendar-icon"] ? R("", !0) : (b(), re(v(Ir), { key: 1 }))
                      ]),
                      _: 2
                    }, [
                      h.$slots["year-overlay-value"] ? {
                        name: "item",
                        fn: q(({ item: be }) => [
                          L(h.$slots, "year-overlay-value", {
                            text: be.text,
                            value: be.value
                          })
                        ]),
                        key: "0"
                      } : void 0
                    ]), 1040, ["modelValue"])) : R("", !0)
                  ]),
                  _: 3
                }, 8, ["name", "css"])
              ];
            }),
            _: 2
          }, [
            h.$slots["month-overlay-value"] ? {
              name: "item",
              fn: q(({ item: se }) => [
                L(h.$slots, "month-overlay-value", {
                  text: se.text,
                  value: se.value
                })
              ]),
              key: "0"
            } : void 0
          ]), 1040, ["skip-active", "year", "multi-model-value", "modelValue"])) : R("", !0),
          h.yearPicker ? (b(), re(Qt, Ye({ key: 2 }, v(k)("year"), {
            modelValue: v(C),
            "onUpdate:modelValue": B[19] || (B[19] = (se) => kt(C) ? C.value = se : null),
            "multi-model-value": v(X),
            "skip-active": h.range,
            "skip-button-ref": "",
            "year-picker": "",
            onToggle: V,
            onSelected: B[20] || (B[20] = (se) => h.$emit("overlay-closed"))
          }), Ge({ _: 2 }, [
            h.$slots["year-overlay-value"] ? {
              name: "item",
              fn: q(({ item: se }) => [
                L(h.$slots, "year-overlay-value", {
                  text: se.text,
                  value: se.value
                })
              ]),
              key: "0"
            } : void 0
          ]), 1040, ["modelValue", "multi-model-value", "skip-active"])) : R("", !0)
        ], 64))
      ]);
    };
  }
}), Av = {
  key: 0,
  class: "dp__time_input"
}, Iv = ["aria-label", "onKeydown", "onClick"], Bv = ["aria-label", "onKeydown", "onClick"], Yv = ["aria-label", "onKeydown", "onClick"], Uv = { key: 0 }, Vv = ["aria-label", "onKeydown"], Fv = /* @__PURE__ */ Ze({
  __name: "TimeInput",
  props: {
    hours: { type: Number, default: 0 },
    minutes: { type: Number, default: 0 },
    seconds: { type: Number, default: 0 },
    closeTimePickerBtn: { type: Object, default: null },
    order: { type: Number, default: 0 },
    ...gt
  },
  emits: [
    "set-hours",
    "set-minutes",
    "update:hours",
    "update:minutes",
    "update:seconds",
    "reset-flow",
    "mounted",
    "overlay-closed"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setTimePickerElements: a, setTimePickerBackRef: o } = bt(), { defaults: i } = Ke(r), { transitionName: l, showTransition: f } = Br(i.value.transitions), d = Xt({
      hours: !1,
      minutes: !1,
      seconds: !1
    }), m = j("AM"), p = j(null), s = j([]);
    et(() => {
      n("mounted");
    });
    const w = (O, y) => _u(ze(M(), O), y), A = (O, y) => Oy(ze(M(), O), y), U = W(
      () => ({
        dp__time_col: !0,
        dp__time_col_reg: !r.enableSeconds && r.is24,
        dp__time_col_reg_with_button: !r.enableSeconds && !r.is24,
        dp__time_col_sec: r.enableSeconds && r.is24,
        dp__time_col_sec_with_button: r.enableSeconds && !r.is24
      })
    ), G = W(() => {
      const O = [{ type: "hours" }, { type: "", separator: !0 }, { type: "minutes" }];
      return r.enableSeconds ? O.concat([{ type: "", separator: !0 }, { type: "seconds" }]) : O;
    }), ee = W(() => G.value.filter((O) => !O.separator)), Q = W(() => (O) => {
      if (O === "hours") {
        const y = x(r.hours);
        return { text: y < 10 ? `0${y}` : `${y}`, value: y };
      }
      return { text: r[O] < 10 ? `0${r[O]}` : `${r[O]}`, value: r[O] };
    }), C = (O) => {
      const y = r.is24 ? 24 : 12, P = O === "hours" ? y : 60, D = +r[`${O}GridIncrement`], u = O === "hours" && !r.is24 ? D : 0, g = [];
      for (let S = u; S < P; S += D)
        g.push({ value: S, text: S < 10 ? `0${S}` : `${S}` });
      return O === "hours" && !r.is24 && g.push({ value: 0, text: "12" }), Ym(g);
    }, z = (O) => r[`no${O[0].toUpperCase() + O.slice(1)}Overlay`], te = (O) => {
      z(O) || (d[O] = !d[O], d[O] || n("overlay-closed"));
    }, k = (O) => O === "hours" ? ut : O === "minutes" ? lt : It, $ = (O, y = !0) => {
      const P = y ? w : A;
      n(
        `update:${O}`,
        k(O)(P({ [O]: +r[O] }, { [O]: +r[`${O}Increment`] }))
      );
    }, x = (O) => r.is24 ? O : (O >= 12 ? m.value = "PM" : m.value = "AM", Lm(O)), F = () => {
      m.value === "PM" ? (m.value = "AM", n("update:hours", r.hours - 12)) : (m.value = "PM", n("update:hours", r.hours + 12));
    }, H = (O) => {
      d[O] = !0;
    }, Y = (O, y, P) => {
      if (O && r.arrowNavigation) {
        Array.isArray(s.value[y]) ? s.value[y][P] = O : s.value[y] = [O];
        const D = s.value.reduce(
          (u, g) => g.map((S, I) => [...u[I] || [], g[I]]),
          []
        );
        o(r.closeTimePickerBtn), p.value && (D[1] = D[1].concat(p.value)), a(D, r.order);
      }
    }, X = (O, y) => O === "hours" && !r.is24 ? n(`update:${O}`, m.value === "PM" ? y + 12 : y) : n(`update:${O}`, y);
    return t({ openChildCmp: H }), (O, y) => {
      var P;
      return O.disabled ? R("", !0) : (b(), E("div", Av, [
        (b(!0), E(he, null, Ae(v(G), (D, u) => {
          var g, S, I;
          return b(), E("div", {
            key: u,
            class: ye(v(U))
          }, [
            D.separator ? (b(), E(he, { key: 0 }, [
              Ie(" : ")
            ], 64)) : (b(), E(he, { key: 1 }, [
              ie("div", {
                class: "dp__inc_dec_button",
                role: "button",
                "aria-label": (g = v(i).ariaLabels) == null ? void 0 : g.incrementValue(D.type),
                tabindex: "0",
                onKeydown: [
                  pe((V) => $(D.type), ["enter"]),
                  pe((V) => $(D.type), ["space"])
                ],
                onClick: (V) => $(D.type),
                ref_for: !0,
                ref: (V) => Y(V, u, 0)
              }, [
                O.$slots["arrow-up"] ? L(O.$slots, "arrow-up", { key: 0 }) : R("", !0),
                O.$slots["arrow-up"] ? R("", !0) : (b(), re(v(Wu), { key: 1 }))
              ], 40, Iv),
              ie("div", {
                role: "button",
                "aria-label": (S = v(i).ariaLabels) == null ? void 0 : S.openTpOverlay(D.type),
                class: ye(z(D.type) ? "" : "dp__time_display"),
                tabindex: "0",
                onKeydown: [
                  pe((V) => te(D.type), ["enter"]),
                  pe((V) => te(D.type), ["space"])
                ],
                onClick: (V) => te(D.type),
                ref_for: !0,
                ref: (V) => Y(V, u, 1)
              }, [
                O.$slots[D.type] ? L(O.$slots, D.type, {
                  key: 0,
                  text: v(Q)(D.type).text,
                  value: v(Q)(D.type).value
                }) : R("", !0),
                O.$slots[D.type] ? R("", !0) : (b(), E(he, { key: 1 }, [
                  Ie(we(v(Q)(D.type).text), 1)
                ], 64))
              ], 42, Bv),
              ie("div", {
                class: "dp__inc_dec_button",
                role: "button",
                "aria-label": (I = v(i).ariaLabels) == null ? void 0 : I.decrementValue(D.type),
                tabindex: "0",
                onKeydown: [
                  pe((V) => $(D.type, !1), ["enter"]),
                  pe((V) => $(D.type, !1), ["space"])
                ],
                onClick: (V) => $(D.type, !1),
                ref_for: !0,
                ref: (V) => Y(V, u, 2)
              }, [
                O.$slots["arrow-down"] ? L(O.$slots, "arrow-down", { key: 0 }) : R("", !0),
                O.$slots["arrow-down"] ? R("", !0) : (b(), re(v(zu), { key: 1 }))
              ], 40, Yv)
            ], 64))
          ], 2);
        }), 128)),
        O.is24 ? R("", !0) : (b(), E("div", Uv, [
          O.$slots["am-pm-button"] ? L(O.$slots, "am-pm-button", {
            key: 0,
            toggle: F,
            value: m.value
          }) : R("", !0),
          O.$slots["am-pm-button"] ? R("", !0) : (b(), E("button", {
            key: 1,
            ref_key: "amPmButton",
            ref: p,
            type: "button",
            class: "dp__pm_am_button",
            role: "button",
            "aria-label": (P = v(i).ariaLabels) == null ? void 0 : P.amPmButton,
            tabindex: "0",
            onClick: F,
            onKeydown: [
              pe(ft(F, ["prevent"]), ["enter"]),
              pe(ft(F, ["prevent"]), ["space"])
            ]
          }, we(m.value), 41, Vv))
        ])),
        (b(!0), E(he, null, Ae(v(ee), (D, u) => (b(), re(Bt, {
          key: u,
          name: v(l)(d[D.type]),
          css: v(f)
        }, {
          default: q(() => [
            d[D.type] ? (b(), re(Qt, {
              key: 0,
              items: C(D.type),
              "disabled-values": v(i).filters.times[D.type],
              "esc-close": O.escClose,
              "aria-labels": v(i).ariaLabels,
              "hide-navigation": O.hideNavigation,
              "onUpdate:modelValue": (g) => X(D.type, g),
              onSelected: (g) => te(D.type),
              onToggle: (g) => te(D.type),
              onResetFlow: y[0] || (y[0] = (g) => O.$emit("reset-flow")),
              type: D.type
            }, Ge({
              "button-icon": q(() => [
                O.$slots["clock-icon"] ? L(O.$slots, "clock-icon", { key: 0 }) : R("", !0),
                O.$slots["clock-icon"] ? R("", !0) : (b(), re(v(Lu), { key: 1 }))
              ]),
              _: 2
            }, [
              O.$slots[`${D.type}-overlay-value`] ? {
                name: "item",
                fn: q(({ item: g }) => [
                  L(O.$slots, `${D.type}-overlay-value`, {
                    text: g.text,
                    value: g.value
                  })
                ]),
                key: "0"
              } : void 0
            ]), 1032, ["items", "disabled-values", "esc-close", "aria-labels", "hide-navigation", "onUpdate:modelValue", "onSelected", "onToggle", "type"])) : R("", !0)
          ]),
          _: 2
        }, 1032, ["name", "css"]))), 128))
      ]));
    };
  }
}), Lv = ["aria-label"], Wv = { class: "dp__overlay_container dp__container_flex" }, zv = {
  key: 1,
  class: "dp__overlay_row"
}, jv = ["aria-label"], Hv = /* @__PURE__ */ Ze({
  __name: "TimePicker",
  props: {
    hours: { type: [Number, Array], default: 0 },
    minutes: { type: [Number, Array], default: 0 },
    seconds: { type: [Number, Array], default: 0 },
    internalModelValue: { type: [Date, Array], default: null },
    ...gt
  },
  emits: [
    "update:hours",
    "update:minutes",
    "update:seconds",
    "mount",
    "reset-flow",
    "overlay-closed"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { buildMatrix: a, setTimePicker: o } = bt(), i = wo(), { hideNavigationButtons: l, defaults: f } = Ke(r), { transitionName: d, showTransition: m } = Br(f.value.transitions), p = j(null), s = j(null), w = j([]), A = j(null);
    et(() => {
      n("mount"), !r.timePicker && r.arrowNavigation ? a([Ue(p.value)], "time") : o(!0, r.timePicker);
    });
    const U = W(() => r.range && r.modelAuto ? Qu(r.internalModelValue) : !0), G = j(!1), ee = (Y) => ({
      hours: Array.isArray(r.hours) ? r.hours[Y] : r.hours,
      minutes: Array.isArray(r.minutes) ? r.minutes[Y] : r.minutes,
      seconds: Array.isArray(r.seconds) ? r.seconds[Y] : r.seconds
    }), Q = W(() => {
      const Y = [];
      if (r.range)
        for (let X = 0; X < 2; X++)
          Y.push(ee(X));
      else
        Y.push(ee(0));
      return Y;
    }), C = (Y, X = !1, O = "") => {
      X || n("reset-flow"), G.value = Y, r.arrowNavigation && (o(Y), Y || n("overlay-closed")), Jt(() => {
        O !== "" && w.value[0] && w.value[0].openChildCmp(O);
      });
    }, z = W(() => ({
      dp__button: !0,
      dp__button_bottom: r.autoApply
    })), te = Pt(i, "timePicker"), k = (Y, X, O) => r.range ? X === 0 ? [Y, Q.value[1][O]] : [Q.value[0][O], Y] : Y, $ = (Y) => {
      n("update:hours", Y);
    }, x = (Y) => {
      n("update:minutes", Y);
    }, F = (Y) => {
      n("update:seconds", Y);
    }, H = () => {
      A.value && r.arrowNavigation && A.value.focus({ preventScroll: !0 });
    };
    return t({ toggleTimePicker: C }), (Y, X) => {
      var O;
      return b(), E("div", null, [
        Y.timePicker ? R("", !0) : on((b(), E("div", {
          key: 0,
          class: ye(v(z)),
          role: "button",
          "aria-label": (O = v(f).ariaLabels) == null ? void 0 : O.openTimePicker,
          tabindex: "0",
          ref_key: "openTimePickerBtn",
          ref: p,
          onKeydown: [
            X[0] || (X[0] = pe((y) => C(!0), ["enter"])),
            X[1] || (X[1] = pe((y) => C(!0), ["space"]))
          ],
          onClick: X[2] || (X[2] = (y) => C(!0))
        }, [
          Y.$slots["clock-icon"] ? L(Y.$slots, "clock-icon", { key: 0 }) : R("", !0),
          Y.$slots["clock-icon"] ? R("", !0) : (b(), re(v(Lu), { key: 1 }))
        ], 42, Lv)), [
          [un, !v(l)("time")]
        ]),
        xe(Bt, {
          name: v(d)(G.value),
          css: v(m)
        }, {
          default: q(() => {
            var y;
            return [
              G.value || Y.timePicker ? (b(), E("div", {
                key: 0,
                class: "dp__overlay",
                ref_key: "overlayRef",
                ref: A,
                tabindex: "0"
              }, [
                ie("div", Wv, [
                  Y.$slots["time-picker-overlay"] ? L(Y.$slots, "time-picker-overlay", {
                    key: 0,
                    hours: e.hours,
                    minutes: e.minutes,
                    seconds: e.seconds,
                    setHours: $,
                    setMinutes: x,
                    setSeconds: F
                  }) : R("", !0),
                  Y.$slots["time-picker-overlay"] ? R("", !0) : (b(), E("div", zv, [
                    (b(!0), E(he, null, Ae(v(Q), (P, D) => on((b(), re(Fv, Ye({ key: D }, {
                      ...Y.$props,
                      order: D,
                      hours: P.hours,
                      minutes: P.minutes,
                      seconds: P.seconds,
                      closeTimePickerBtn: s.value,
                      disabled: D === 0 ? Y.fixedStart : Y.fixedEnd
                    }, {
                      ref_for: !0,
                      ref_key: "timeInputRefs",
                      ref: w,
                      "onUpdate:hours": (u) => $(k(u, D, "hours")),
                      "onUpdate:minutes": (u) => x(k(u, D, "minutes")),
                      "onUpdate:seconds": (u) => F(k(u, D, "seconds")),
                      onMounted: H,
                      onOverlayClosed: H
                    }), Ge({ _: 2 }, [
                      Ae(v(te), (u, g) => ({
                        name: u,
                        fn: q((S) => [
                          L(Y.$slots, u, Xe(st(S)))
                        ])
                      }))
                    ]), 1040, ["onUpdate:hours", "onUpdate:minutes", "onUpdate:seconds"])), [
                      [un, D === 0 ? !0 : v(U)]
                    ])), 128))
                  ])),
                  Y.timePicker ? R("", !0) : on((b(), E("div", {
                    key: 2,
                    ref_key: "closeTimePickerBtn",
                    ref: s,
                    class: ye(v(z)),
                    role: "button",
                    "aria-label": (y = v(f).ariaLabels) == null ? void 0 : y.closeTimePicker,
                    tabindex: "0",
                    onKeydown: [
                      X[3] || (X[3] = pe((P) => C(!1), ["enter"])),
                      X[4] || (X[4] = pe((P) => C(!1), ["space"]))
                    ],
                    onClick: X[5] || (X[5] = (P) => C(!1))
                  }, [
                    Y.$slots["calendar-icon"] ? L(Y.$slots, "calendar-icon", { key: 0 }) : R("", !0),
                    Y.$slots["calendar-icon"] ? R("", !0) : (b(), re(v(Ir), { key: 1 }))
                  ], 42, jv)), [
                    [un, !v(l)("time")]
                  ])
                ])
              ], 512)) : R("", !0)
            ];
          }),
          _: 3
        }, 8, ["name", "css"])
      ]);
    };
  }
}), qv = (e, t) => {
  const { isDisabled: n, matchDate: r, getWeekFromDate: a } = Ke(t), o = j(null), i = j(M()), l = (u) => {
    !u.current && t.hideOffsetDates || (o.value = u.value);
  }, f = () => {
    o.value = null;
  }, d = (u) => Array.isArray(e.value) && t.range && e.value[0] && o.value ? u ? He(o.value, e.value[0]) : Fe(o.value, e.value[0]) : !0, m = (u, g) => {
    const S = () => e.value ? g ? e.value[0] || null : e.value[1] : null, I = e.value && Array.isArray(e.value) ? S() : null;
    return Te(M(u.value), I);
  }, p = (u) => {
    const g = Array.isArray(e.value) ? e.value[0] : null;
    return u ? !Fe(o.value || null, g) : !0;
  }, s = (u, g = !0) => (t.range || t.weekPicker) && Array.isArray(e.value) ? t.hideOffsetDates && !u.current ? !1 : Te(M(u.value), e.value[g ? 0 : 1]) : t.range ? m(u, g) && p(g) || Te(u.value, Array.isArray(e.value) ? e.value[0] : null) && d(g) : !1, w = (u, g, S) => Array.isArray(e.value) && e.value[0] && e.value.length === 1 ? u ? !1 : S ? He(e.value[0], g.value) : Fe(e.value[0], g.value) : !1, A = (u) => !e.value || t.hideOffsetDates && !u.current ? !1 : t.range ? t.modelAuto && Array.isArray(e.value) ? Te(u.value, e.value[0] ? e.value[0] : i.value) : !1 : t.multiDates && Array.isArray(e.value) ? e.value.some((g) => Te(g, u.value)) : Te(u.value, e.value ? e.value : i.value), U = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        if (t.hideOffsetDates && !u.current)
          return !1;
        const g = dt(o.value, +t.autoRange), S = a(M(o.value));
        return t.weekPicker ? Te(S[1], M(u.value)) : Te(g, M(u.value));
      }
      return !1;
    }
    return !1;
  }, G = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        const g = dt(o.value, +t.autoRange);
        if (t.hideOffsetDates && !u.current)
          return !1;
        const S = a(M(o.value));
        return t.weekPicker ? He(u.value, S[0]) && Fe(u.value, S[1]) : He(u.value, o.value) && Fe(u.value, g);
      }
      return !1;
    }
    return !1;
  }, ee = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        if (t.hideOffsetDates && !u.current)
          return !1;
        const g = a(M(o.value));
        return t.weekPicker ? Te(g[0], u.value) : Te(o.value, u.value);
      }
      return !1;
    }
    return !1;
  }, Q = (u) => ju(e.value, o.value, u.value), C = () => t.modelAuto && Array.isArray(t.internalModelValue) ? !!t.internalModelValue[0] : !1, z = () => t.modelAuto ? Qu(t.internalModelValue) : !0, te = (u) => {
    if (Array.isArray(e.value) && e.value.length || t.weekPicker)
      return !1;
    const g = t.range ? !s(u) && !s(u, !1) : !0;
    return !n(u.value) && !A(u) && !(!u.current && t.hideOffsetDates) && g;
  }, k = (u) => t.range ? t.modelAuto ? C() && A(u) : !1 : A(u), $ = (u) => t.highlight ? r(u.value, t.highlight) : !1, x = (u) => n(u.value) && t.highlightDisabledDays === !1, F = (u) => t.highlightWeekDays && t.highlightWeekDays.includes(u.value.getDay()), H = (u) => (t.range || t.weekPicker) && (!(t.multiCalendars > 0) || u.current) && z() && !(!u.current && t.hideOffsetDates) && !A(u) ? Q(u) : !1, Y = (u) => ({
    dp__cell_offset: !u.current,
    dp__pointer: !t.disabled && !(!u.current && t.hideOffsetDates) && !n(u.value),
    dp__cell_disabled: n(u.value),
    dp__cell_highlight: !x(u) && ($(u) || F(u)) && !k(u),
    dp__cell_highlight_active: !x(u) && ($(u) || F(u)) && k(u),
    dp__today: !t.noToday && Te(u.value, i.value) && u.current
  }), X = (u) => ({
    dp__active_date: k(u),
    dp__date_hover: te(u)
  }), O = (u) => ({
    ...y(u),
    ...P(u),
    dp__range_between_week: H(u) && t.weekPicker
  }), y = (u) => ({
    dp__range_start: t.multiCalendars > 0 ? u.current && s(u) && z() : s(u) && z(),
    dp__range_end: t.multiCalendars > 0 ? u.current && s(u, !1) && z() : s(u, !1) && z(),
    dp__range_between: H(u) && !t.weekPicker,
    dp__date_hover_start: w(te(u), u, !0),
    dp__date_hover_end: w(te(u), u, !1)
  }), P = (u) => ({
    ...y(u),
    dp__cell_auto_range: G(u),
    dp__cell_auto_range_start: ee(u),
    dp__cell_auto_range_end: U(u)
  }), D = (u) => t.range ? t.autoRange ? P(u) : t.modelAuto ? { ...X(u), ...y(u) } : y(u) : t.weekPicker ? O(u) : X(u);
  return {
    setHoverDate: l,
    clearHoverDate: f,
    getDayClassData: (u) => ({
      ...Y(u),
      ...D(u),
      [t.dayClass ? t.dayClass(u.value) : ""]: !0,
      [t.calendarCellClassName]: !!t.calendarCellClassName
    })
  };
}, Gv = ["id", "onKeydown"], Qv = {
  key: 0,
  class: "dp__sidebar_left"
}, Xv = {
  key: 1,
  class: "dp__preset_ranges"
}, Kv = ["onClick"], Jv = {
  key: 2,
  class: "dp__sidebar_right"
}, Zv = {
  key: 3,
  class: "dp__now_wrap"
}, eh = /* @__PURE__ */ Ze({
  __name: "DatepickerMenu",
  props: {
    openOnTop: { type: Boolean, default: !1 },
    internalModelValue: { type: [Date, Array], default: null },
    ...gt
  },
  emits: [
    "close-picker",
    "select-date",
    "auto-apply",
    "time-update",
    "flow-step",
    "update-month-year",
    "invalid-select",
    "update:internal-model-value",
    "recalculate-position"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setMenuFocused: a, setShiftKey: o, control: i } = Hu(), { getCalendarDays: l, defaults: f } = Ke(r), d = wo(), m = j(null), p = Xt({
      timePicker: !!(!r.enableTimePicker || r.timePicker || r.monthPicker),
      monthYearInput: !!r.timePicker,
      calendar: !1
    }), s = j([]), w = j([]), A = j(null), U = j(null), G = j(0), ee = j(!1), Q = j(0);
    et(() => {
      var T;
      ee.value = !0, !((T = r.presetRanges) != null && T.length) && !d["left-sidebar"] && !d["right-sidebar"] && it();
      const K = Ue(U);
      if (K && !r.textInput && !r.inline && (a(!0), x()), K) {
        const Le = (qe) => {
          !r.monthYearComponent && !r.timePickerComponent && !Object.keys(d).length && qe.preventDefault(), qe.stopImmediatePropagation(), qe.stopPropagation();
        };
        K.addEventListener("pointerdown", Le), K.addEventListener("mousedown", Le);
      }
      document.addEventListener("resize", it);
    }), Oo(() => {
      document.removeEventListener("resize", it);
    });
    const { arrowRight: C, arrowLeft: z, arrowDown: te, arrowUp: k } = bt(), $ = (T) => {
      T || T === 0 ? w.value[T].triggerTransition(
        O.value(T),
        y.value(T)
      ) : w.value.forEach(
        (K, Le) => K.triggerTransition(O.value(Le), y.value(Le))
      );
    }, x = () => {
      const T = Ue(U);
      T && T.focus({ preventScroll: !0 });
    }, F = () => {
      var T;
      (T = r.flow) != null && T.length && Q.value !== -1 && (Q.value += 1, n("flow-step", Q.value), Se());
    }, H = () => {
      Q.value = -1;
    }, {
      calendars: Y,
      modelValue: X,
      month: O,
      year: y,
      time: P,
      updateTime: D,
      updateMonthYear: u,
      selectDate: g,
      getWeekNum: S,
      monthYearSelect: I,
      handleScroll: V,
      handleArrow: _,
      handleSwipe: le,
      getMarker: de,
      selectCurrentDate: h,
      presetDateRange: B
    } = Xm(r, n, F, $, Q), { setHoverDate: Me, clearHoverDate: me, getDayClassData: ue } = qv(X, r);
    Kt(
      Y,
      () => {
        r.openOnTop && setTimeout(() => {
          n("recalculate-position");
        }, 0);
      },
      { deep: !0 }
    );
    const De = Pt(d, "calendar"), Qe = Pt(d, "action"), se = Pt(d, "timePicker"), ce = Pt(d, "monthYear"), Oe = W(() => r.openOnTop ? "dp__arrow_bottom" : "dp__arrow_top"), be = W(() => Vm(r.yearRange)), Yt = W(() => Fm(r.locale, r.monthNameFormat)), it = () => {
      const T = Ue(m);
      T && (G.value = T.getBoundingClientRect().width);
    }, Ut = W(() => (T) => l(O.value(T), y.value(T))), _t = W(
      () => f.value.multiCalendars > 0 && r.range ? [...Array(f.value.multiCalendars).keys()] : [0]
    ), Vt = W(
      () => (T) => T === 1
    ), Yr = W(() => r.monthPicker || r.timePicker || r.yearPicker), Ur = W(
      () => ({
        dp__flex_display: f.value.multiCalendars > 0
      })
    ), Zt = W(() => ({
      dp__instance_calendar: f.value.multiCalendars > 0
    })), Ft = W(() => ({
      dp__menu_disabled: r.disabled,
      dp__menu_readonly: r.readonly
    })), Vr = W(
      () => (T) => Lr(Ut, T)
    ), Fr = W(
      () => ({
        dp__menu: !0,
        dp__menu_index: !r.inline,
        dp__relative: r.inline,
        [r.menuClassName]: !!r.menuClassName
      })
    ), Lr = (T, K) => T.value(K).map((Le) => ({
      ...Le,
      days: Le.days.map((qe) => (qe.marker = de(qe), qe.classData = ue(qe), qe))
    })), en = (T) => {
      T.stopPropagation(), T.stopImmediatePropagation();
    }, c = () => {
      r.escClose && n("close-picker");
    }, N = (T, K = !1) => {
      g(T, K), r.spaceConfirm && n("select-date");
    }, Z = (T) => {
      var K;
      (K = r.flow) != null && K.length && (p[T] = !0, Object.keys(p).filter((Le) => !p[Le]).length || Se());
    }, fe = (T, K, Le, qe, ...tn) => {
      if (r.flow[Q.value] === T) {
        const ne = qe ? K.value[0] : K.value;
        ne && ne[Le](...tn);
      }
    }, Se = () => {
      fe("month", s, "toggleMonthPicker", !0, !0), fe("year", s, "toggleYearPicker", !0, !0), fe("calendar", A, "toggleTimePicker", !1, !1, !0), fe("time", A, "toggleTimePicker", !1, !0, !0);
      const T = r.flow[Q.value];
      (T === "hours" || T === "minutes" || T === "seconds") && fe(T, A, "toggleTimePicker", !1, !0, !0, T);
    }, tt = (T) => {
      if (r.arrowNavigation) {
        if (T === "up")
          return k();
        if (T === "down")
          return te();
        if (T === "left")
          return z();
        if (T === "right")
          return C();
      } else
        T === "left" || T === "up" ? _("left", 0, T === "up") : _("right", 0, T === "down");
    }, wt = (T) => {
      o(T.shiftKey), !r.disableMonthYearSelect && T.code === "Tab" && T.target.classList.contains("dp__menu") && i.value.shiftKeyInMenu && (T.preventDefault(), T.stopImmediatePropagation(), n("close-picker"));
    };
    return t({
      updateMonthYear: u
    }), (T, K) => {
      var Le;
      return b(), re(Bt, {
        appear: "",
        name: (Le = v(f).transitions) == null ? void 0 : Le.menuAppear,
        mode: "out-in",
        css: !!T.transitions
      }, {
        default: q(() => {
          var qe, tn;
          return [
            ie("div", {
              id: T.uid ? `dp-menu-${T.uid}` : void 0,
              tabindex: "0",
              ref_key: "dpMenuRef",
              ref: U,
              role: "dialog",
              class: ye(v(Fr)),
              onMouseleave: K[12] || (K[12] = (...ne) => v(me) && v(me)(...ne)),
              onClick: en,
              onKeydown: [
                pe(c, ["esc"]),
                K[13] || (K[13] = pe(ft((ne) => tt("left"), ["prevent"]), ["left"])),
                K[14] || (K[14] = pe(ft((ne) => tt("up"), ["prevent"]), ["up"])),
                K[15] || (K[15] = pe(ft((ne) => tt("down"), ["prevent"]), ["down"])),
                K[16] || (K[16] = pe(ft((ne) => tt("right"), ["prevent"]), ["right"])),
                wt
              ]
            }, [
              (T.disabled || T.readonly) && T.inline ? (b(), E("div", {
                key: 0,
                class: ye(v(Ft))
              }, null, 2)) : R("", !0),
              !T.inline && !T.teleportCenter ? (b(), E("div", {
                key: 1,
                class: ye(v(Oe))
              }, null, 2)) : R("", !0),
              ie("div", {
                class: ye({
                  dp__menu_content_wrapper: ((qe = T.presetRanges) == null ? void 0 : qe.length) || !!T.$slots["left-sidebar"] || !!T.$slots["right-sidebar"]
                })
              }, [
                T.$slots["left-sidebar"] ? (b(), E("div", Qv, [
                  L(T.$slots, "left-sidebar")
                ])) : R("", !0),
                (tn = T.presetRanges) != null && tn.length ? (b(), E("div", Xv, [
                  (b(!0), E(he, null, Ae(T.presetRanges, (ne, Mt) => (b(), E("div", {
                    key: Mt,
                    style: Ct(ne.style || {}),
                    class: "dp__preset_range",
                    onClick: (ve) => v(B)(ne.range, !!ne.slot)
                  }, [
                    ne.slot ? L(T.$slots, ne.slot, {
                      key: 0,
                      presetDateRange: v(B),
                      label: ne.label,
                      range: ne.range
                    }) : (b(), E(he, { key: 1 }, [
                      Ie(we(ne.label), 1)
                    ], 64))
                  ], 12, Kv))), 128))
                ])) : R("", !0),
                ie("div", {
                  class: "dp__instance_calendar",
                  ref_key: "calendarWrapperRef",
                  ref: m,
                  role: "document"
                }, [
                  ie("div", {
                    class: ye(v(Ur))
                  }, [
                    (b(!0), E(he, null, Ae(v(_t), (ne, Mt) => (b(), E("div", {
                      key: ne,
                      class: ye(v(Zt))
                    }, [
                      !T.disableMonthYearSelect && !T.timePicker ? (b(), re(an(T.monthYearComponent ? T.monthYearComponent : Ev), Ye({
                        key: 0,
                        ref_for: !0,
                        ref: (ve) => {
                          ve && (s.value[Mt] = ve);
                        },
                        months: v(Yt),
                        years: v(be),
                        month: v(O)(ne),
                        year: v(y)(ne),
                        instance: ne,
                        "internal-model-value": e.internalModelValue
                      }, T.$props, {
                        onMount: K[0] || (K[0] = (ve) => Z("monthYearInput")),
                        onResetFlow: H,
                        onUpdateMonthYear: (ve) => v(u)(ne, ve),
                        onMonthYearSelect: v(I),
                        onOverlayClosed: x
                      }), Ge({ _: 2 }, [
                        Ae(v(ce), (ve, Xu) => ({
                          name: ve,
                          fn: q((Wr) => [
                            L(T.$slots, ve, Xe(st(Wr)))
                          ])
                        }))
                      ]), 1040, ["months", "years", "month", "year", "instance", "internal-model-value", "onUpdateMonthYear", "onMonthYearSelect"])) : R("", !0),
                      xe(wv, Ye({
                        ref_for: !0,
                        ref: (ve) => {
                          ve && (w.value[Mt] = ve);
                        },
                        "specific-mode": v(Yr),
                        "get-week-num": v(S),
                        instance: ne,
                        "mapped-dates": v(Vr)(ne),
                        month: v(O)(ne),
                        year: v(y)(ne)
                      }, T.$props, {
                        "flow-step": Q.value,
                        "onUpdate:flow-step": K[1] || (K[1] = (ve) => Q.value = ve),
                        onSelectDate: (ve) => v(g)(ve, !v(Vt)(ne)),
                        onHandleSpace: (ve) => N(ve, !v(Vt)(ne)),
                        onSetHoverDate: K[2] || (K[2] = (ve) => v(Me)(ve)),
                        onHandleScroll: (ve) => v(V)(ve, ne),
                        onHandleSwipe: (ve) => v(le)(ve, ne),
                        onMount: K[3] || (K[3] = (ve) => Z("calendar")),
                        onResetFlow: H
                      }), Ge({ _: 2 }, [
                        Ae(v(De), (ve, Xu) => ({
                          name: ve,
                          fn: q((Wr) => [
                            L(T.$slots, ve, Xe(st({ ...Wr })))
                          ])
                        }))
                      ]), 1040, ["specific-mode", "get-week-num", "instance", "mapped-dates", "month", "year", "flow-step", "onSelectDate", "onHandleSpace", "onHandleScroll", "onHandleSwipe"])
                    ], 2))), 128))
                  ], 2),
                  ie("div", null, [
                    T.$slots["time-picker"] ? L(T.$slots, "time-picker", Xe(Ye({ key: 0 }, { time: v(P), updateTime: v(D) }))) : (b(), E(he, { key: 1 }, [
                      T.enableTimePicker && !T.monthPicker && !T.weekPicker ? (b(), re(an(T.timePickerComponent ? T.timePickerComponent : Hv), Ye({
                        key: 0,
                        ref_key: "timePickerRef",
                        ref: A,
                        hours: v(P).hours,
                        minutes: v(P).minutes,
                        seconds: v(P).seconds,
                        "internal-model-value": e.internalModelValue
                      }, T.$props, {
                        onMount: K[4] || (K[4] = (ne) => Z("timePicker")),
                        "onUpdate:hours": K[5] || (K[5] = (ne) => v(D)(ne)),
                        "onUpdate:minutes": K[6] || (K[6] = (ne) => v(D)(ne, !1)),
                        "onUpdate:seconds": K[7] || (K[7] = (ne) => v(D)(ne, !1, !0)),
                        onResetFlow: H,
                        onOverlayClosed: x
                      }), Ge({ _: 2 }, [
                        Ae(v(se), (ne, Mt) => ({
                          name: ne,
                          fn: q((ve) => [
                            L(T.$slots, ne, Xe(st(ve)))
                          ])
                        }))
                      ]), 1040, ["hours", "minutes", "seconds", "internal-model-value"])) : R("", !0)
                    ], 64))
                  ])
                ], 512),
                T.$slots["right-sidebar"] ? (b(), E("div", Jv, [
                  L(T.$slots, "right-sidebar")
                ])) : R("", !0),
                T.showNowButton ? (b(), E("div", Zv, [
                  T.$slots["now-button"] ? L(T.$slots, "now-button", {
                    key: 0,
                    selectCurrentDate: v(h)
                  }) : R("", !0),
                  T.$slots["now-button"] ? R("", !0) : (b(), E("button", {
                    key: 1,
                    type: "button",
                    role: "button",
                    class: "dp__now_button",
                    onClick: K[8] || (K[8] = (...ne) => v(h) && v(h)(...ne))
                  }, we(T.nowButtonLabel), 1))
                ])) : R("", !0)
              ], 2),
              !T.autoApply || T.keepActionRow ? (b(), re(an(T.actionRowComponent ? T.actionRowComponent : cv), Ye({
                key: 2,
                "menu-mount": ee.value,
                "calendar-width": G.value,
                "internal-model-value": e.internalModelValue
              }, T.$props, {
                onClosePicker: K[9] || (K[9] = (ne) => T.$emit("close-picker")),
                onSelectDate: K[10] || (K[10] = (ne) => T.$emit("select-date")),
                onInvalidSelect: K[11] || (K[11] = (ne) => T.$emit("invalid-select"))
              }), Ge({ _: 2 }, [
                Ae(v(Qe), (ne, Mt) => ({
                  name: ne,
                  fn: q((ve) => [
                    L(T.$slots, ne, Xe(st({ ...ve })))
                  ])
                }))
              ]), 1040, ["menu-mount", "calendar-width", "internal-model-value"])) : R("", !0)
            ], 42, Gv)
          ];
        }),
        _: 3
      }, 8, ["name", "css"]);
    };
  }
}), th = typeof window < "u" ? window : void 0, ra = () => {
}, nh = (e) => fl() ? (cl(e), !0) : !1, rh = (e, t, n, r) => {
  if (!e)
    return ra;
  let a = ra;
  const o = Kt(
    () => v(e),
    (l) => {
      a(), l && (l.addEventListener(t, n, r), a = () => {
        l.removeEventListener(t, n, r), a = ra;
      });
    },
    { immediate: !0, flush: "post" }
  ), i = () => {
    o(), a();
  };
  return nh(i), i;
}, ah = (e, t, n, r = {}) => {
  const { window: a = th, event: o = "pointerdown" } = r;
  return a ? rh(a, o, (i) => {
    const l = Ue(e), f = Ue(t);
    !l || !f || l === i.target || i.composedPath().includes(l) || i.composedPath().includes(f) || n(i);
  }, { passive: !0 }) : void 0;
}, oh = /* @__PURE__ */ Ze({
  __name: "VueDatePicker",
  props: {
    ...gt
  },
  emits: [
    "update:model-value",
    "text-submit",
    "closed",
    "cleared",
    "open",
    "focus",
    "blur",
    "internal-model-change",
    "recalculate-position",
    "flow-step",
    "update-month-year",
    "invalid-select"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, a = wo(), o = j(!1), i = aa(r, "modelValue"), l = aa(r, "timezone"), f = j(null), d = j(null), m = j(!1), { setMenuFocused: p, setShiftKey: s } = Hu(), { clearArrowNav: w } = bt(), { validateDate: A, isValidTime: U, defaults: G } = Ke(r);
    et(() => {
      F(r.modelValue), r.inline || (window.addEventListener("scroll", P), window.addEventListener("resize", D)), r.inline && (o.value = !0);
    }), Oo(() => {
      r.inline || (window.removeEventListener("scroll", P), window.removeEventListener("resize", D));
    });
    const ee = Pt(a, "all", r.presetRanges), Q = Pt(a, "input");
    Kt(
      [i, l],
      () => {
        F(i.value);
      },
      { deep: !0 }
    );
    const { openOnTop: C, menuPosition: z, setMenuPosition: te, setInitialPosition: k } = Zm(
      f,
      d,
      n,
      r
    ), {
      inputValue: $,
      internalModelValue: x,
      parseExternalModelValue: F,
      emitModelValue: H,
      formatInputValue: Y,
      checkBeforeEmit: X
    } = Km(n, r, m), O = W(
      () => ({
        dp__main: !0,
        dp__theme_dark: r.dark,
        dp__theme_light: !r.dark,
        dp__flex_display: r.inline,
        dp__flex_display_with_input: r.inlineWithInput
      })
    ), y = W(() => r.dark ? "dp__theme_dark" : "dp__theme_light"), P = () => {
      o.value && (r.closeOnScroll ? de() : r.autoPosition ? te() : window.removeEventListener("scroll", P));
    }, D = () => {
      o.value && te();
    }, u = () => {
      !r.disabled && !r.readonly && (k(), o.value = !0, Jt().then(() => {
        te(), o.value && n("open");
      }), o.value || le(), F(r.modelValue));
    }, g = () => {
      $.value = "", le(), n("update:model-value", null), n("cleared"), de();
    }, S = () => {
      const ce = x.value;
      return !ce || !Array.isArray(ce) && A(ce) ? !0 : Array.isArray(ce) ? ce.length === 2 && A(ce[0]) && A(ce[1]) ? !0 : A(ce[0]) : !1;
    }, I = () => {
      X() && S() ? (H(), de()) : n("invalid-select", x.value);
    }, V = (ce) => {
      H(), r.closeOnAutoApply && !ce && de();
    }, _ = (ce = !1) => {
      r.autoApply && U(x.value) && S() && (r.range && Array.isArray(x.value) ? (r.partialRange || x.value.length === 2) && V(ce) : V(ce));
    }, le = () => {
      r.textInput || (x.value = null);
    }, de = () => {
      r.inline || (o.value && (o.value = !1, p(!1), s(!1), w(), n("closed"), k(), $.value && F(i.value)), le(), d.value && d.value.focusInput());
    }, h = (ce, Oe) => {
      if (!ce) {
        x.value = null;
        return;
      }
      x.value = ce, Oe && (I(), n("text-submit"));
    }, B = () => {
      r.autoApply && U(x.value) && H();
    }, Me = () => o.value ? de() : u(), me = (ce) => {
      x.value = ce;
    }, ue = W(() => r.textInput && G.value.textInputOptions.format), De = () => {
      ue.value && (m.value = !0, Y()), n("focus");
    }, Qe = () => {
      ue.value && (m.value = !1, Y()), n("blur");
    }, se = (ce) => {
      f.value && f.value.updateMonthYear(0, {
        month: su(ce.month),
        year: su(ce.year)
      });
    };
    return ah(
      f,
      d,
      r.onClickOutside ? () => r.onClickOutside(S) : de
    ), t({
      closeMenu: de,
      selectDate: I,
      clearValue: g,
      openMenu: u,
      onScroll: P,
      formatInputValue: Y,
      updateInternalModelValue: me,
      setMonthYear: se
    }), (ce, Oe) => (b(), E("div", {
      class: ye(v(O))
    }, [
      xe(uv, Ye({
        ref_key: "inputRef",
        ref: d,
        "is-menu-open": o.value,
        "input-value": v($),
        "onUpdate:input-value": Oe[0] || (Oe[0] = (be) => kt($) ? $.value = be : null)
      }, ce.$props, {
        onClear: g,
        onOpen: u,
        onSetInputDate: h,
        onSetEmptyDate: v(H),
        onSelectDate: I,
        onToggle: Me,
        onClose: de,
        onFocus: De,
        onBlur: Qe
      }), Ge({ _: 2 }, [
        Ae(v(Q), (be, Yt) => ({
          name: be,
          fn: q((it) => [
            L(ce.$slots, be, Xe(st(it)))
          ])
        }))
      ]), 1040, ["is-menu-open", "input-value", "onSetEmptyDate"]),
      o.value ? (b(), re(ll, {
        key: 0,
        to: ce.teleport,
        disabled: ce.inline
      }, [
        o.value ? (b(), re(eh, Ye({
          key: 0,
          ref_key: "dpMenuRef",
          ref: f,
          class: v(y),
          style: v(z),
          "open-on-top": v(C)
        }, ce.$props, {
          "internal-model-value": v(x),
          "onUpdate:internal-model-value": Oe[1] || (Oe[1] = (be) => kt(x) ? x.value = be : null),
          onClosePicker: de,
          onSelectDate: I,
          onAutoApply: _,
          onTimeUpdate: B,
          onFlowStep: Oe[2] || (Oe[2] = (be) => ce.$emit("flow-step", be)),
          onUpdateMonthYear: Oe[3] || (Oe[3] = (be) => ce.$emit("update-month-year", be)),
          onInvalidSelect: Oe[4] || (Oe[4] = (be) => ce.$emit("invalid-select", v(x))),
          onRecalculatePosition: v(te)
        }), Ge({ _: 2 }, [
          Ae(v(ee), (be, Yt) => ({
            name: be,
            fn: q((it) => [
              L(ce.$slots, be, Xe(st({ ...it })))
            ])
          }))
        ]), 1040, ["class", "style", "open-on-top", "internal-model-value", "onRecalculatePosition"])) : R("", !0)
      ], 8, ["to", "disabled"])) : R("", !0)
    ], 2));
  }
}), Io = /* @__PURE__ */ (() => {
  const e = oh;
  return e.install = (t) => {
    t.component("Vue3DatePicker", e);
  }, e;
})(), ih = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: Io
}, Symbol.toStringTag, { value: "Module" }));
Object.entries(ih).forEach(([e, t]) => {
  e !== "default" && (Io[e] = t);
});
const uh = {
  name: "FormInputDatePicker",
  extends: St,
  components: {
    DatePicker: Io
  },
  props: {
    locale: {
      type: String,
      required: !1,
      default: "cs-CZ"
    },
    minDate: {
      type: Date,
      required: !1
    },
    maxDate: {
      type: Date,
      required: !1
    },
    enableTime: {
      type: Boolean,
      required: !1,
      default: !1
    },
    ignoreTimeValidation: {
      type: Boolean,
      required: !1,
      default: !0
    },
    dateFormat: {
      type: Function,
      required: !1
    }
    /*
    textToDate: {
        type: Function,
        required: false
    }
    */
  },
  data() {
    return {
      localDate: null
    };
  },
  computed: {
    dateFormatter() {
      return this.dateFormat ? this.dateFormat : this.enableTime ? gl : gu;
    },
    displayValue() {
      return this.model ? this.dateFormatter(this.model) : null;
    },
    model: {
      get() {
        if (!this.modelValue)
          return null;
        if (this.modelValue instanceof Date)
          return this.modelValue;
        const e = new Date(this.modelValue);
        return e && !isNaN(e.valueOf()) ? e : null;
      },
      set(e) {
        let t = e;
        !(e instanceof Date) && e && (t = new Date(e)), t && !this.enableTime && (t = new Date(`${t.toISOString().split("T")[0]}T00:00:00.000Z`)), this.$emit("update:modelValue", t), this.validation.$touch !== void 0 && typeof this.validation.$touch == "function" && this.validation.$touch();
      }
    }
  }
  /*
  methods: {
      onUpdateModelValue (value) {
          this.localDate = `${value}`
          const date = (typeof this.textToDate === 'function') ? this.textToDate(this.localDate) : textToDate(this.localDate)
          if (date instanceof Date) {
              this.model = date
          }
      }
  }
  */
};
function lh(e, t, n, r, a, o) {
  const i = _o, l = pt("date-picker"), f = pt("form-input-feedback-message"), d = yt, m = mt;
  return b(), re(m, {
    description: e.hint,
    "label-for": e.id ? `${e.id}_input` : void 0,
    class: ye({ "form-group-required": e.isRequired })
  }, {
    label: q(() => [
      Ie(we(e.label), 1)
    ]),
    default: q(() => [
      xe(l, {
        modelValue: o.model,
        "onUpdate:modelValue": t[0] || (t[0] = (p) => o.model = p),
        "text-input": "",
        "auto-apply": !0,
        "close-on-auto-apply": !n.enableTime,
        disabled: e.disabled,
        "enable-time-picker": n.enableTime,
        "min-date": n.minDate || void 0,
        "max-date": n.maxDate || void 0,
        "prevent-min-max-navigation": !!(n.minDate || n.maxDate),
        "ignore-time-validation": n.ignoreTimeValidation,
        format: o.dateFormatter,
        locale: n.locale,
        uid: e.id ? `dtpkr_${e.id}` : void 0
      }, {
        "dp-input": q(() => [
          xe(i, {
            type: "text",
            id: e.id ? `${e.id}_input` : void 0,
            placeholder: e.placeholder,
            size: e.size,
            state: e.invalid !== null ? !e.invalid : null,
            disabled: e.disabled,
            "model-value": o.displayValue,
            readonly: !0
          }, null, 8, ["id", "placeholder", "size", "state", "disabled", "model-value"])
        ]),
        _: 1
      }, 8, ["modelValue", "close-on-auto-apply", "disabled", "enable-time-picker", "min-date", "max-date", "prevent-min-max-navigation", "ignore-time-validation", "format", "locale", "uid"]),
      e.invalid ? (b(), re(d, { key: 0 }, {
        default: q(() => [
          xe(f, {
            "validation-model": e.validation,
            messages: e.validationMessages
          }, null, 8, ["validation-model", "messages"])
        ]),
        _: 1
      })) : R("", !0),
      L(e.$slots, "input-text")
    ]),
    _: 3
  }, 8, ["description", "label-for", "class"]);
}
const sh = /* @__PURE__ */ vt(uh, [["render", lh]]), fh = {
  name: "FormInputTextarea",
  extends: St
};
function ch(e, t, n, r, a, o) {
  const i = yu, l = pt("form-input-feedback-message"), f = yt, d = mt;
  return b(), re(d, {
    label: e.label,
    description: e.hint,
    "label-for": e.id,
    class: ye({ "form-group-required": e.isRequired })
  }, {
    label: q(() => [
      Ie(we(e.label), 1)
    ]),
    default: q(() => [
      xe(i, {
        modelValue: e.model,
        "onUpdate:modelValue": t[0] || (t[0] = (m) => e.model = m),
        modelModifiers: { trim: !0 },
        size: e.size,
        id: e.id,
        state: e.invalid !== null ? !e.invalid : null,
        disabled: e.disabled,
        formatter: e.formatValue,
        placeholder: e.placeholder,
        "lazy-formatter": "",
        onChange: t[1] || (t[1] = (m) => e.onEvent("change")),
        onUpdate: t[2] || (t[2] = (m) => e.onEvent("update")),
        onBlur: t[3] || (t[3] = (m) => e.onEvent("blur")),
        readonly: e.readOnly
      }, null, 8, ["modelValue", "size", "id", "state", "disabled", "formatter", "placeholder", "readonly"]),
      e.invalid ? (b(), re(f, { key: 0 }, {
        default: q(() => [
          xe(l, {
            "validation-model": e.validation,
            messages: e.validationMessages
          }, null, 8, ["validation-model", "messages"])
        ]),
        _: 1
      })) : R("", !0),
      L(e.$slots, "input-text")
    ]),
    _: 3
  }, 8, ["label", "description", "label-for", "class"]);
}
const dh = /* @__PURE__ */ vt(fh, [["render", ch]]), ph = {
  name: "FormInputSelect",
  extends: St,
  props: {
    options: {
      required: !0,
      validator(e) {
        return typeof e == "object" || Array.isArray(e);
      }
    },
    multi: {
      type: Boolean,
      required: !1,
      default: !1
    },
    selectSize: {
      required: !1
    }
  },
  computed: {
    arrayOptions() {
      if (this.options === null)
        return [];
      if (Array.isArray(this.options))
        return this.options;
      if (typeof this.options == "object") {
        const e = [];
        for (const t in this.options)
          e.push({
            value: t,
            text: `${this.options[t]}`
          });
        return e;
      }
      return [];
    }
  }
}, yh = { class: "input-group-append" };
function mh(e, t, n, r, a, o) {
  const i = mu, l = pt("form-input-feedback-message"), f = yt, d = mt;
  return b(), re(d, {
    description: e.hint,
    class: ye({ "form-group-required": e.isRequired }),
    "label-for": e.id
  }, {
    label: q(() => [
      Ie(we(e.label), 1)
    ]),
    default: q(() => [
      e.renderAsGroup ? (b(), E("div", {
        key: 0,
        class: ye({ "input-group": !0, "is-invalid": e.invalid !== null ? !e.invalid : null, "is-valid": e.invalid !== null ? !!e.invalid : null })
      }, [
        xe(i, {
          modelValue: e.model,
          "onUpdate:modelValue": t[0] || (t[0] = (m) => e.model = m),
          size: e.size,
          id: e.id,
          state: e.invalid !== null ? !e.invalid : null,
          disabled: e.disabled || e.readOnly,
          placeholder: e.placeholder,
          options: o.arrayOptions,
          onChange: t[1] || (t[1] = (m) => e.onEvent("change")),
          onUpdate: t[2] || (t[2] = (m) => e.onEvent("update")),
          onBlur: t[3] || (t[3] = (m) => e.onEvent("blur")),
          multiple: n.multi,
          "select-size": n.selectSize
        }, null, 8, ["modelValue", "size", "id", "state", "disabled", "placeholder", "options", "multiple", "select-size"]),
        ie("div", yh, [
          L(e.$slots, "default")
        ])
      ], 2)) : (b(), re(i, {
        key: 1,
        modelValue: e.model,
        "onUpdate:modelValue": t[4] || (t[4] = (m) => e.model = m),
        size: e.size,
        id: e.id,
        state: e.invalid !== null ? !e.invalid : null,
        disabled: e.disabled || e.readOnly,
        placeholder: e.placeholder,
        options: o.arrayOptions,
        onChange: t[5] || (t[5] = (m) => e.onEvent("change")),
        onUpdate: t[6] || (t[6] = (m) => e.onEvent("update")),
        onBlur: t[7] || (t[7] = (m) => e.onEvent("blur")),
        multiple: n.multi,
        "select-size": n.selectSize
      }, null, 8, ["modelValue", "size", "id", "state", "disabled", "placeholder", "options", "multiple", "select-size"])),
      e.invalid ? (b(), re(f, { key: 2 }, {
        default: q(() => [
          xe(l, {
            "validation-model": e.validation,
            messages: e.validationMessages
          }, null, 8, ["validation-model", "messages"])
        ]),
        _: 1
      })) : R("", !0)
    ]),
    _: 3
  }, 8, ["description", "class", "label-for"]);
}
const vh = /* @__PURE__ */ vt(ph, [["render", mh]]), hh = {
  name: "FormInputRadioGroup",
  extends: St,
  props: {
    options: {
      required: !0,
      validator(e) {
        return typeof e == "object" || Array.isArray(e);
      }
    },
    stacked: {
      type: Boolean,
      required: !1,
      default: !0
    }
  },
  computed: {
    arrayOptions() {
      if (this.options === null)
        return [];
      if (Array.isArray(this.options))
        return this.options;
      if (typeof this.options == "object") {
        const e = [];
        for (const t in this.options)
          e.push({
            value: t,
            text: `${this.options[t]}`
          });
        return e;
      }
      return [];
    }
  }
};
function bh(e, t, n, r, a, o) {
  const i = vu, l = pt("form-input-feedback-message"), f = yt, d = mt;
  return b(), re(d, {
    description: e.hint,
    class: ye({ "form-group-required": e.isRequired }),
    "label-for": e.id
  }, {
    label: q(() => [
      Ie(we(e.label), 1)
    ]),
    default: q(() => [
      xe(i, {
        modelValue: e.model,
        "onUpdate:modelValue": t[0] || (t[0] = (m) => e.model = m),
        id: e.id,
        size: e.size,
        state: e.invalid !== null ? !e.invalid : null,
        disabled: e.disabled || e.readOnly,
        options: o.arrayOptions,
        stacked: n.stacked,
        onChange: t[1] || (t[1] = (m) => e.onEvent("change")),
        onUpdate: t[2] || (t[2] = (m) => e.onEvent("update")),
        onBlur: t[3] || (t[3] = (m) => e.onEvent("blur"))
      }, null, 8, ["modelValue", "id", "size", "state", "disabled", "options", "stacked"]),
      e.invalid ? (b(), re(f, { key: 0 }, {
        default: q(() => [
          xe(l, {
            "validation-model": e.validation,
            messages: e.validationMessages
          }, null, 8, ["validation-model", "messages"])
        ]),
        _: 1
      })) : R("", !0)
    ]),
    _: 1
  }, 8, ["description", "class", "label-for"]);
}
const gh = /* @__PURE__ */ vt(hh, [["render", bh]]), _h = {
  name: "FormInputCheckboxGroup",
  extends: St,
  props: {
    options: {
      required: !0,
      validator(e) {
        return typeof e == "object" || Array.isArray(e);
      }
    },
    stacked: {
      type: Boolean,
      required: !1,
      default: !0
    }
  },
  computed: {
    arrayOptions() {
      if (this.options === null)
        return [];
      if (Array.isArray(this.options))
        return this.options;
      if (typeof this.options == "object") {
        const e = [];
        for (const t in this.options)
          e.push({
            value: t,
            text: `${this.options[t]}`
          });
        return e;
      }
      return [];
    }
  }
};
function wh(e, t, n, r, a, o) {
  const i = hu, l = pt("form-input-feedback-message"), f = yt, d = mt;
  return b(), re(d, {
    description: e.hint,
    class: ye({ "form-group-required": e.isRequired }),
    "label-for": e.id
  }, {
    label: q(() => [
      Ie(we(e.label), 1)
    ]),
    default: q(() => [
      xe(i, {
        modelValue: e.model,
        "onUpdate:modelValue": t[0] || (t[0] = (m) => e.model = m),
        id: e.id,
        size: e.size,
        state: e.invalid !== null ? !e.invalid : null,
        disabled: e.disabled || e.readOnly,
        options: o.arrayOptions,
        stacked: n.stacked,
        onChange: t[1] || (t[1] = (m) => e.onEvent("change")),
        onUpdate: t[2] || (t[2] = (m) => e.onEvent("update")),
        onBlur: t[3] || (t[3] = (m) => e.onEvent("blur"))
      }, null, 8, ["modelValue", "id", "size", "state", "disabled", "options", "stacked"]),
      e.invalid ? (b(), re(f, { key: 0 }, {
        default: q(() => [
          xe(l, {
            "validation-model": e.validation,
            messages: e.validationMessages
          }, null, 8, ["validation-model", "messages"])
        ]),
        _: 1
      })) : R("", !0)
    ]),
    _: 1
  }, 8, ["description", "class", "label-for"]);
}
const Oh = /* @__PURE__ */ vt(_h, [["render", wh]]), $h = {
  name: "FormInputCheckbox",
  extends: St,
  props: {
    renderAsSwitch: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
};
function kh(e, t, n, r, a, o) {
  const i = bu, l = pt("form-input-feedback-message"), f = yt, d = mt;
  return b(), re(d, {
    description: e.hint,
    class: ye({ "form-group-required": e.isRequired })
  }, {
    default: q(() => [
      n.renderAsSwitch ? (b(), re(i, {
        key: 0,
        modelValue: e.model,
        "onUpdate:modelValue": t[0] || (t[0] = (m) => e.model = m),
        id: e.id,
        size: e.size,
        state: e.invalid !== null ? !e.invalid : null,
        switch: "",
        disabled: e.disabled || e.readOnly,
        onChange: t[1] || (t[1] = (m) => e.onEvent("change")),
        onUpdate: t[2] || (t[2] = (m) => e.onEvent("update")),
        onBlur: t[3] || (t[3] = (m) => e.onEvent("blur"))
      }, {
        default: q(() => [
          L(e.$slots, "default", {}, () => [
            Ie(we(e.label), 1)
          ])
        ]),
        _: 3
      }, 8, ["modelValue", "id", "size", "state", "disabled"])) : (b(), re(i, {
        key: 1,
        modelValue: e.model,
        "onUpdate:modelValue": t[4] || (t[4] = (m) => e.model = m),
        id: e.id,
        size: e.size,
        state: e.invalid !== null ? !e.invalid : null,
        disabled: e.disabled || e.readOnly,
        onChange: t[5] || (t[5] = (m) => e.onEvent("change")),
        onUpdate: t[6] || (t[6] = (m) => e.onEvent("update")),
        onBlur: t[7] || (t[7] = (m) => e.onEvent("blur"))
      }, {
        default: q(() => [
          L(e.$slots, "default", {}, () => [
            Ie(we(e.label), 1)
          ])
        ]),
        _: 3
      }, 8, ["modelValue", "id", "size", "state", "disabled"])),
      e.invalid ? (b(), re(f, { key: 2 }, {
        default: q(() => [
          xe(l, {
            "validation-model": e.validation,
            messages: e.validationMessages
          }, null, 8, ["validation-model", "messages"])
        ]),
        _: 1
      })) : R("", !0)
    ]),
    _: 3
  }, 8, ["description", "class"]);
}
const Ph = /* @__PURE__ */ vt($h, [["render", kh]]), Th = [
  St,
  sh,
  dh,
  vh,
  gh,
  Oh,
  Ph
], Rh = {
  install(e) {
    e.component(Ku), e.component(bu), e.component(hu), e.component(Ju), e.component(mt), e.component(_o), e.component(yt), e.component(Zu), e.component(vu), e.component(el), e.component(mu), e.component(tl), e.component(nl), e.component(rl), e.component(al), e.component(ol), e.component(il), e.component(yu), e.component(ul);
    for (const t of Th)
      e.component(t.name, t);
  }
};
export {
  St as FormInput,
  Ph as FormInputCheckbox,
  Oh as FormInputCheckboxGroup,
  sh as FormInputDatePicker,
  yl as FormInputFeedbackMessage,
  gh as FormInputRadioGroup,
  vh as FormInputSelect,
  dh as FormInputTextarea,
  Rh as FormInputsPlugin
};
